## Konzept

Basierend auf den vorgegebenen Anforderungen und den Ergebnissen der Marktuntersuchung wurde entschieden, ein eigenes Monitoringsystem aufzubauen. Zentral ist der Umstieg von IBM Netcool Tivoli auf das Open-Source-Tool Alerta. Weiter soll das System auf einer verteilten Architektur basieren. Zudem muss das System über offene Schnittstellen verfügen und kompatibel zu verschiedenen anderen Monitoringsystemen wie SCOM sein. Die nachfolgende Skizze zeigt das hierfür erarbeitete Konzept:

![[NmsKonzept.drawio.svg]]

Das Konzept deckt dabei den kompletten Datenfluss vom Standortcontroller bis zur Darstellung in der Alerta Weboberfläche ab.

Auf jedem Standortcontroller läuft die Anwendung snmptrapd, welche SNMP-Traps der Sendetechnik empfangen und in ein Logfile schreiben. Dieses Logfile wird von Fluentd ausgelesen. Dabei handelt es sich um einen Open-Source-Datenkollektor. Dieser kann Daten aus verschiedenen Quellen auslesen und in ein gewünschtes Format transformieren. [[@project_what_nodate]] Die aus dem Logfile ausgelesenen Traps werden von Fluentd mit Informationen angereichert und in HTTP Paketen an das System gesendet.

Die erste Station im Monitoringsystem ist eine Traefik Instanz. Hierbei handelt es sich um einen Reverse-Proxy und Loadbalancer [[@noauthor_traefik_nodate]], welcher HTTP Pakete von den verschiedenen Standortcontrollern empfängt und an zugehörige Queues weiterleitet. Diese Warteschlangen werden auf Basis von Apache Kafka realisiert. Hierbei handelt es sich um eine Event-Streaming-Plattform, welche aufgetretene Events zwischenspeichert. [[@noauthor_was_nodate-9]] Pro Standort gibt es eine Queue, in welcher Messages zwischengespeichert werden. Diese werden nach und nach von einer entsprechenden Logstash Instanz ausgelesen. Für jede Queue gibt es eine eigene Instanz. Logstash ist eine Datenverarbeitungspipeline und Teil des Elasticstacks. [[@noauthor_logstash_nodate]] Diese schreiben Events aus der Kafkaqueue in eine Elasticsearch Datenbank. Hierbei handelt es sich um eine auf Volltextsuchen spezialisierte NoSQL-Datenbank. [[@noauthor_elasticsearch_nodate]] Abschließend wird diese Datenbank von Alerta ausgelesen und die Ereignisse visualisiert. Alerta ist ein Monitoringsystem, welches mit mehreren verschiedenen Monitoringsystemen mittels einer REST-API kommunizieren kann. [[@noauthor_alertaio_nodate]]

## Implementierung

Das System wird in zwei Stufen implementiert. Aufgrund der zeitlichen Relevanz wird zunächst eine verkleinerte Variante implementiert:

![[NmsV1.drawio.svg]]
Die erste Version des Systems beschränkt sich zunächst auf die Implementierung des absoluten Minimums. Zunächst wird lediglich ein direkter Pfad von den Standortcontrollern in Alerta abgebildet. Zusätzlich wird eine PostgreSQL Datenbank als Archiv verwendet.

In der zweiten Version wird das System durch RabbitMQ, Logstash und OpenSearch ergänzt.

![[NmsV2.drawio.svg]]
Nach Rücksprache mit Kompetenzen im Haus wurde die Entscheidung getroffen, Apache Kafka durch RabbitMQ zu ersetzen. Hierbei handelt es sich um einen Kafka ähnlichen Messaging Server, welcher allerdings weniger Administrationsaufwand benötigt. Kafka benötigt sehr feingliedrige Access-Control-Lists, welche insgesamt komplex zu administrieren sind. Zusätzlich vergisst Kafka keine Ereignisse, wodurch ein hoher Bedarf an Speicherplatz auftritt.

Zur Defintion der Zielschnittstelle wird asyncapi verwendet. Somit wird eine ereignisgesteuerte Architektur erstellt, welche einen späteren Wechsel zu Kafka einfach gestaltet.

Die Elasticsearch Datenbank wurde durch OpenSearch ersetzt. OpenSearch ist hierbei ein Fork von Elasticsearch welcher komplett unter einer Apache-Lizenz weiterentwickelt wird und den vollen Funktionsumfang ohne Lizenzbeschränkungen verwendbar macht.
