## Festlegung Sollzustand

- Umstieg auf Alerta
- Verteilte Architektur
	- Kubernetes
	- Apache Kafka
	- Elasticsearch bzw. OpenSearch
	- Traefik als Edge Router
- Kompatibilität zu verschiedenen Monitoring Produkten
- Offene Schnittstellen
## Ursprüngliches Konzept

![[Pasted image 20230813161835.png]]

### Komponenten
- Fluentd
	- Opensource Data Collector
	- Kann Daten aus verschiedenen Quellen in verschiedene Formate transformieren
- Traefik
	- Reverse Proxy
	- Load-Balancer
- Apache Kafka
	- Event-Streaming-Plattform
	- Kann Events zwischenspeichern
	- [[@noauthor_was_nodate-9]]
- Logstash
	- Datenverarbeitungspipeline
	- Transformiert und schreibt Daten in Elasticsearch DB
	- [[@noauthor_logstash_nodate]]
- Elasticsearch
	- NoSQL Datenbank
	- Spezialisierte Datenbank auf Volltextsuchen
- Alerta
	- Monitoring Tool
	- Zeigt Alarme bzw. Meldungen aus verschiedenen Quellen an 
- Kubernetes
	- Container Orchestrierungsplattform

### Zusammenspiel der Komponenten

Standortcontroller:
- Empfängt Traps mittels snmptrapd
- Schreibt Traps in Logfile
- Fluentd liest Logfile aus und schickt Nachrichten an Monitoringsystem

Monitoringsystem:
- Traefik
	- Dient als Reverseproxy und Load-Balancer
	- Routet empfange Nachrichten an entsprechende Queues weiter
- Apache Kafka
	- pro Standort eine Queue
	- Dient als Warteschlange für Messages
	- Messages werden nach und nach abgearbeitet
	- Messages werden entsprechend DNS-Namen vom Reverse-Proxy geroutet
- Logstash
	- Liest Daten aus der Queue und schreibt diese in die Elasticsearch DB
- Elasticsearch
	- Speichert empfange Nachrichten
	- Kann u.a. Reports generieren oder Abfragen abarbeiten
- Alerta
	- Visualisiert alle Meldungen nach Priorität
	- Schnittstelle zum Endnutzer

## Implementierung NMSv1

![[Pasted image 20230813173443.png]]

- Implementierung im NMS (NetzManagementProgram) Projekt
- Implementierung in zwei Stufen
	- v1:
		- Grundkonfiguration ohne HA Setup
		- Traefik routet Messages gleich an Alerta weiter
		- PostgreSQL DB als Archiv
		- Fluentd reichert Meldungen mit Informationen aus Admintools wie FNT Command und iTop an
## Implementierung NMSv2

![[Pasted image 20230814170141.png]]
NMSv2:
- Kafka, Logstash und ElasticSearch/OpenSearch werden hinzugefügt
- OpenSeach ist ein Fork von ElasticSearch
- Kafka wird durch RabbitMQ ersetzt
	- Grund:
		- Nach Rücksprache mit Kompetenzen im Haus
		- Kafka zu komplex
		- u.a. ACLs verursachen hohen Administrationsaufwand
		- Kafka vergisst keine Ereignisse -> hoher Speicherbedarf
		- Deshalb RabbitMQ
- RabbitMQ:
	- Messaging Server
	- Bietet ähnliche Features wie Kafka
	- Speichert Ereignisse aber nicht permanent
	- Durch Nutzung von asyncapi kann Zielschnittstelle als ereignisgesteuerte Architektur definiert werden
	- Dadurch späterer Wechsel zu Kafka simpel