In the early 2000s, Google introduced a cluster management service they called Borg. It ran hundreds of thousands of jobs and services on their internal clusters, helming a “collective” of tens of thousands of Google’s servers

kubernetes101 Page 1

But wait, the first problem you run into is there are actually many different ‘flavors’ of Kubernetes you can use when you want to try it out

kubernetes101 Page 5

One easy way to get started with the full-fledged Kubernetes distribution is to setup a cluster using Kubeadm. This is the official tool from Kubernetes, designed to bootstrap Kubernetes clusters on bare metal or cloud instances. It doesn’t include any extra frills, it just gets Kubernetes’ control plane running and attaches worker nodes to it. But the full Kubernetes install is a bit heavyweight, requiring a couple gigs of RAM just to run Kubernetes, and that’s before you add any of your applications running on top of it. So there are more lightweight distributions of Kubernetes like Rancher’s K3s, which even runs well on ARM single board computers like the Raspberry Pi!

kubernetes101 Page 5

---

**Master:** Wie fast alle verteilten IT-Plattformen besteht auch Kubernetes aus mindestens einem Master und mehreren Nodes. Es ist möglich, beide Komponenten auf einem einzelnen System zu betreiben. Das wird unter anderem bei Minikube, einer lokalen Testumgebung, basierend auf VirtualBox, so zur Verfügung gestellt. Der Master verwaltet und veröffentlicht die Schnittstelle (API), über die er angesteuert werden kann, und überwacht den Zustand des vollständigen Clusters. Darüber hinaus plant und steuert der Master auch das Deployment auf den jeweiligen Nodes. Der Master kann zum Beispiel aus Gründen der Hochverfügbarkeit auch auf mehreren Systemen betrieben und hinter einen Load Balancer, der in Kubernetes integriert ist, gesetzt werden. Der Master definiert sich durch folgende drei Komponenten:

- Der **API-Server** ist die zentrale Anlaufstelle für alle Befehle des gesamten Clusters und erlaubt dem Administrator die Konfiguration der einzelnen Kubernetes-Objekte. Der API-Server überwacht außerdem die Konsistenz zwischen den Parametern in etcd und den bereitgestellten Containern. Mit anderen Worten validiert und konfiguriert der API-Server die Daten der Pods, Services und ReplicaSets. Er weist Pods den einzelnen Nodes zu und synchronisiert die Pod-Information mit der Service-Konfiguration.

- Der **Service Controller Manager** verarbeitet die in den jeweiligen Replikationsaufgaben definierten Replikationsprozesse. Die dazu benötigten Informationen werden in der etcd festgehalten, die durch den Controller Manager auf Änderungen hin überwacht wird. Bei einer Änderung liest der Controller Manager die Informationen aus der Datenbank und führt die nötigen Schritte aus, um den gewünschten Zustand zu erreichen, zum Beispiel das Skalieren eines ReplicaSet oder das Löschen eines Pods. Auch der Controller Manager bedient sich hierbei des API.

- Der **Scheduler** organisiert innerhalb des Clusters die Lastverteilung auf einzelne Nodes. Das erreicht er, indem er die aktuellen Anforderungen erfasst, den aktuellen Zustand aller Nodes analysiert und schließlich die Last auf einen oder mehrere Nodes neu verteilt.

Jeder einzelne Node beinhaltet jeweils die Container-Runtime Docker, einen Agenten, der mit dem Master kommuniziert, sowie weitere grundlegende Komponenten, die unter anderem für das Monitoring, Logging und die Service Discovery zuständig sind. An dieser Stelle sei erwähnt, dass es natürlich auch möglich ist, statt Docker zum Beispiel rkt auf einem Node zu verwenden.

[[@dr_andreas_hess_was_2021]]

---

## Stichpunkte

- Borg, Vorläufer von Kubernetes
- von Google in den frühen 2000ern entwickelt
- Orchestrierungstechnologie
- wurde genutzt, um tausende Funktionen und Jobs auf Googles internen Clustern auszuführen
kubernetes101 Page 1

- Viele verschiedene Distributionen
- offizielles Tool zum aufsetzen von Clustern -> kubeadm
- vollständige Kubernetes Installation sehr ressourcenintensiv
- k3s leichtgewichtige Alternative
kubernetes101 Page 5

---

Cluster besteht aus Master und Nodes
Master:
- Stellt Schnittstelle zur Kommunikation bereit
- überwacht Zustand des Clusters
- Steuert und plant Deployments auf den Nodes
- Kann auf mehreren Systemen betrieben werden
- Besteht u.a. aus diesen Komponenten:
	- API-Server:
		- zentrale Anlaufstelle für Befehle des Clusters
		- Erlaubt Admin Konfiguration der einzelnen Objekte
		- überwacht Konsistenz zwischen Soll und Ist Zustand
	- Service Controller Manager:
		- verarbeitet Replikationsaufgaben
		- Informationen werden in ClusterDB (etcd) festgehalten
		- Controller Manager ließt Datenbank aus und führt gewünschten Zustand herbei
		- z.B. Skalieren eines ReplicaSet oder Löschen eines Pods
	- Scheduler
		- organisiert Lastverteilung auf einzelnen Nodes
[[@dr_andreas_hess_was_2021]]

Node:
- besteht aus Container-Runtime und Agent
- Agent kommuniziert mit Master
- Agent stelllt Monitoring, Logging und Service Discovery bereit
[[@dr_andreas_hess_was_2021]]

