## Beschreibung des Umfelds

Der SWR betreut die Sendetechnik an insgesamt 120 Standorten. Davon gehören 110 Standorte zum SWR selbst oder befinden sich an Standorten anderer Rundfunkanstalten. Unter diesen sind einige Standorte von der Deutschen Telekom AG (Deutsche Funkturm GmbH), des Bayerischen Rundfunk, Hessischen Rundfunk und den SWR Auslandsstudios. Der SWR übernimmt auch die Betreuung für 10 Standorte des Saarländischen Rundfunks.

Insgesamt werden etwa 2100 Geräte im Monitoringsystem überwacht. Davon sind 1500 IP-Netzelemente. Bei diesen ist ein SNMP-Agent direkt integriert und das Monitoring läuft über den TCP/IP-Konnektor des Netzelements. Ferner gibt es etwa 600 non-IP-Netzelemente, bei denen die eigentlichen Elemente der Sendetechnik mittels potenzialfreien Melde- und Steuerkontakten an SNMP-Gateways angeschlossen sind.

Die Infrastruktur des SWR wurde bisher vom ARD-Sternpunkt in Frankfurt am Main überwacht. Dabei handelt es sich um die zentrale technische Schnittstelle der ARD und ist beim Hessischen Rundfunk angesiedelt. Dieser ermöglicht den Programmaustausch zwischen den einzelnen Landesrundfunkanstalten. Die zentrale Disposition und Schaltung von Übertragungsleitungen spart Kosten und minimiert Übertagungsfehler. Zusätzlich ist er die Schnittstelle für Beiträge zum Gemeinschaftsprogramm der ARD "Das Erste" der einzelnen Rundfunkanstalten. Der ARD Stern ist auch für die Ausstrahlung internationaler Übertragungen zuständig. [[@germany_ard-sternpunkt_2017]]

Neben der Rolle als zentraler Hörfunk und Fernsehtauschpunkt ist der ARD Stern auch der wichtigste Knotenpunkt des HYBNET, ein Glasfasernetzwerk, dass Hochverfügbarkeitsdatenverbindungen zwischen den einzelnen ARD-Anstalten bereitstellt. Über dieses können HD-Videoinhalte mit bis zu 40GB/s zwischen den Rundfunkanstalten verschoben werden. [[Vodefone]] Seite 38 Anders als bei den Vorgängern unterhält die ARD keine eigene Infrastruktur mehr, sondern benutzt das Vodafone Backend. [[Vodefone]] Seite 39

Der Vertrag mit dem hessischen Rundfunk über das Monitoring der Infrastruktur läuft zum 01.01.2024 aus. Aus diesem Grund sucht der SWR nach Alternativen.

## Aktueller Zustand

Aktuell verwendet der SWR das IBM Produkt "IBM Netcool Tivoli". Dieses besteht aus mehreren Komponenten. Einen Überblick schafft die nachfolgende Abbildung:

![[Pasted image 20230806102140.png]]

Die im SWR eingesetzte Tivoli-Instanz besteht aus folgenden Komponenten:
- Omnibus:
	 Omnibus ist das zentrale Element des Monitoringsystems. Hier laufen alle Datenströme aus den verschiedenen Quellen zusammen und werden mithilfe des Impact-Servers weiter angereichert. Auch laufen in dieser Instanz alle Prozesse von Netcool.
- WebGUI:
	  Visualisiert die aufbereiteten Rohdaten.
-  Objectserver:
		Hierbei handelt es sich um eine schnelle Datenbank, welche direkt von den verschiedenen Probes beschrieben wird.
- Impact:
	 Impact ist ein Schnittstellenserver, welcher die einkommenden Traps mit Informationen anreichert. Weiter ermöglicht er das Anbinden von weiteren Datenquellen.
- TCR:
	 TCR ist ein Reporting Tool von IBM, welches Reports in eine Historie Datenbank schreibt.

IBM Netcool Tivoli bringt von sich selbst aus kein Archiv mit, aus diesem Grund werden lediglich aktuelle Events vorgehalten werden. Aus diesem Grund betreibt der SWR eine Oracle Datenbank Instanz, in welche als Archiv des Systems dient.

An jedem Standort gibt es einen 1HE Server, der als sogenannter Standortcontroller dient. Auf diesen läuft ein CentOS Linux und die Software mttrapd. Diese Software empfängt die SNMP Traps der Sendetechnik und sendet sie weiter an den Omnibus. Dieser verarbeitet diese und stellt die Meldungen auf der WebGUI dar.

IBM Netcool Tivoli bietet von sich aus keine Möglichkeit, um das System hochverfügbar zu betreiben. Die Standortcontroller benutzen einen Store-and-Forward-Modus, um die Datensammlung sicherzustellen.

In naher Zukunft ändert sich die Lizenzstruktur von IBM, deshalb wird der weitere Betrieb von Netcool Tivoli wirtschaftlich unrentabel.
