### Aufbau
- Ist die Software monolithisch oder modular aufgebaut
- Können Komponenten ersetzt werden?
- Können Komponenten durch Lösungen von Drittanbietern getauscht werden?
- Wird eine eine externe Datenbank verwendet?
	- SQL-DB?
	- NoSQL?
- Ist die Software in einer Schichtenarchitektur aufgebaut?
- Ist ein Webfrontend vorhanden?
- Gibt es anpassbare Dashboard?
- Ist das Webfrontend austauschbar?
- Welche Übertragungsformate werden unterstützt?
	- JSON
	- XML
	- Weitere
- Sind eigene Plugins möglich?
- Gibt es eine dedizierte Ingressschicht?
- Gibt es eine dedizierte Speicherschicht?
- Gibt es eine Northbound-Schnittstelle?
- Gibt es eine Southbound-Schnittstelle?

### Features
- Wird SNMP unterstützt?
- Werden Webhooks unterstützt?
- Wird Messagepack unterstützt?
- Wird MQTT unterstützt?
- Wird Syslog unterstützt?
- Wird ein Logfileparser mitgeliefert?
- Gibt es eine Funktion zur Root-Cause-Analyses-Funktion?
- Wird die Transformation von Daten in spezifiziertes Format unterstützt?
- Ist die Software SCOM-kompatibel?
- Sind Schnittstellen vorhanden?
    - REST
    - SOAP
    - Weitere?
- Können Bursts abgefangen werden?
- Sind eigene Log Formate definierbar?
- Ist das System als UFM (Umbrella Fault Management) einsetzbar?
- Sind Logs, Metriken und Traces erfassbar?
	- Sind diese mittels einer KI auswertbar oder sind eigene Einstellungen notwendig?
- Ist Workflowmonitoring möglich?
- Ist Applicationmonitoring möglich?
- Ist Lizenzmonitoring möglich?
- Ist Hardwaremonitoring möglich?
- Gibt es ein Rechtemodell (User/Operator/Admin...)?

### Deployment
- Ist das System auf Kubernetes deploybar?
- Sind Deployments an mehreren Standpunkten möglich?
- Gibt es eine SaaS-Lösung?
- Kann das Tool in der Cloud betrieben werden?

### Sonstige
- Lizenzmodell?
	- Pro Gerät
	- Pro Aspekt
	- Anderes
- Gibt es ein Redundanzkonzept?
- Support
	- Mail Support?
	- Chat Support?
	- Ist ein eigener Ansprechpartner möglich?
- SLA?
- Open Source?
- Anpassbar durch SWR?
	- ist es durch den SWR updatebar?
	- Kann es als SWR-eigener Fork weitergenutzt werden?

