Monitoring ist ein Überbegriff für alle Maßnahmen die zur Überwachung und Sicherung der IT-Infrastruktur und interner Prozesse unter Berücksichtigung von Compliance-Richtlinien. [[@noauthor_it-monitoring_nodate]] Das Ziel ist der reibungslose Betrieb der IT-Infrastruktur und mit ihr verbundener Prozesse. [[@noauthor_warum_2022]] Zur Sicherstellung des Betriebs werden im Zuge des Monitorings IT-Systeme kontinuierlich überwacht. Somit ist ihr Zustand zu jedem Zeitpunkt bekannt. [[@gutenbrunner_monitoring_nodate]] Treten Probleme auf, so können deren Ursachen ausfindig gemacht werden. [[@noauthor_warum_2022]] Grundlage für das Monitoring in der Informationstechnik ist das Nyquist-Shannon-Abtasttheorem. Dieses besagt, dass für ein gegebenes Signal fsignal die Abtastrate mindestens 2fsignal betragen muss, um das Ursprungssignal fehlerfrei rekonstruieren zu können:

fabtastrate >= 2 * fsignal
dm2a.pdf

Im Kontext das Monitoring bedeutet dies, dass die Abtastrate des Monitoring-Systems mindestens doppelt so hoch sein, wie der zu überwachende Zeitraum. Dies bedeutet beispielsweise, dass um sicherzustellen, dass ein Zielsystem in zu jeder Minute verfügbar ist, muss das Monitoringsystem alle 30 Sekunden den Zustand des Ziels erfassen.

Im simpelsten Fall handelt es sich beim Monitoring um das Sammeln von Systemmetriken, also beispielsweise der CPU-Auslastung, RAM-Belegung usw. Diese gesammelten Daten werden auf Dashboards dargestellt. [[@gutenbrunner_monitoring_nodate]] Das Monitoringsystem überwacht, ob die vom System gesammelten Rohdaten innerhalb vom Administrator gesetzten Schwellwerte bleibt. [[@noauthor_warum_2022]] Diese Überwachung besteht aus der systematischen Protokollierung aller Komponenten. [[@noauthor_it-monitoring_nodate]] Diese umfasst neben der bereits erwähnten Sammlung von Systemmetriken auch die Überwachung von Prozessen, Schnittstellen, Verzeichnissen oder Logs. Zur zielgerichteten Verarbeitung aller Rohdaten ist die Integration aller IT-Komponenten in eine Gesamtlösung notwendig. Nur so kann ein möglichst vollständiger Überblick erreicht werden. [[@noauthor_warum_2022]] Die vom Administrator vorgegebenen Schwellwerte bilden die Grundlage zur Detektion von Problemen innerhalb der Infrastruktur des Unternehmens. Werden diese über- oder unterschritten, so wird der entsprechende Eskalationsprozess eingeleitet. [[@noauthor_it-monitoring_nodate]] Ferner können diese Schwellwerte auch Rückschlüsse auf die Ursache des Problems ermöglichen und beschleunigen die Problemlösung.[[@noauthor_warum_2022]] Zusätzlich ist aktives Monitoring ein wichtiger Baustein in der Automatisierung der Infrastruktur eines Unternehmens und ersetzt die manuelle Kontrolle der Systeme. Somit können Zeit und Kosten eingespart werden [[@noauthor_warum_2022]] 

Es werden verschiedene Arten des Monitorings unterschieden:
- Verfügbarkeitsmonitoring:
	- Diese Art des Monitorings wird auch als Systemmonitoring bezeichnet. Unter anderem beinhaltet es Möglichkeiten zur Serververwaltung, Infrastructure Monitoring/Verwaltung und Netzwerk Monitoring/Verwaltung. Es stellt Informationen über die Uptime und Performance der überwachten Systeme bereit. [[@noauthor_was_nodate-3]]
- Web-Performance-Monitoring:
	- Hierbei wird die Verfügbarkeit eines Webservers/-services überwacht. Erfasst wird dabei beispielsweise die Ladezeit einer Webseite, der Ursprung von Fehlern und Ladezeiten von Elementen[@noauthor_was_nodate-3]]
- Anwendungs-Management/Anwendungs-Performance-Management (APM):
	- Das APM ist ähnlich dem Web-Performance-Monitoring ist ähnlich dem Web-Performance-Monitoring, allerdings ist es auf kundenspezifische Anwendungen ausgelegt. Es erlaubt die Verfolgung der Performance von spezifischen Anwendungen und die Analyse von auftretenden Problemen. [[@noauthor_was_nodate-3]]
- API-Monitoring:
	- Diese Art des Monitoring stellt Informationen über die Funktion und Erreichbarkeit von APIs bereit.  [[@noauthor_was_nodate-3]]
- Real-User-Monitoring:
	- Das Real-User-Monitoring nimmt eine Sonderstellung ein. Es überwacht tatsächliche Interaktionen des Nutzers mit einer Software. Besonders daran ist, dass es ausschließlich rückwärtsgewandt arbeitet und nicht prädiktiv. Deshalb können Probleme erst nach Auftreten festgestellt werden und nicht im Voraus. [[@noauthor_was_nodate-3]]
- Historical Monitoring:
	- Hierbei werden Langzeitstatistiken zu IT-Diensten erzeugt. Auf Basis dieser Daten können Rückschlüsse für z.B. die Kapazitäts-, Budgetplanung und Rechnungsstellung gewonnen werden. Zusätzlich ermöglicht es die Sammlung von Hinweisen auf systematische Verfügbarkeitsprobleme. [[@noauthor_monitoring_nodate]]

Unternehmen haben zur Implementierung eines Monitoringsystems im Großen zwei Optionen: Internes oder externes Monitoring. Beim internen Monitoring überwacht das Unternehmen seine Systeme selbst und trägt damit auch das volle Risiko. Gibt es ein Problem mit dem Monitoring, so können Probleme in der Infrastruktur untergehen. [[@noauthor_warum_2022]] Anders sieht es beim externen Monitoring aus. Hier übernimmt ein externer Dienstleister das Monitoring für das Unternehmen. Das Risiko liegt dabei beim Dienstleister. [[@noauthor_warum_2022]]