*IT-Monitoring ist ein Überbegriff und steht für alle Maßnahmen zur automatischen Überwachung einer IT-Infrastruktur und der darin ablaufenden Workflows unter Berücksichtigung von Compliance-Richtlinien.
Die Kernaufgaben sind hierbei die systematische Protokollierung aller Komponenten sowie die Dokumentation und die Einleitung von Eskalationsprozessen bei IT-Risiken oder -Ausfällen bis zur Wiederherstellung der Betriebsbereitschaft.
IT-Monitoring ist somit eine Maßnahme, die für eine höhere Sicherheit von Systemen, Prozessen und Daten sorgt. [[@noauthor_it-monitoring_nodate]]



*IT-Monitoring umfasst die laufende Überwachung von Vorgängen und Prozessen in der entsprechenden Systemumgebung auf ihre Funktionalität.
Das übergeordnete Ziel ist, den reibungslosen Betrieb der IT-Infrastruktur sicherzustellen.
Dafür muss Problemen und deren Ursachen vorgebeugt werden.
In dem Fall, dass ein Problem auftritt, muss es frühzeitig erkannt und schnellstmöglich beseitigt werden.  [[@noauthor_warum_2022]]

*Das IT-Monitoring überwacht, ob sich alle zu beobachtenden Leistungskomponenten innerhalb der zuvor definierten Schwellwerte befinden.
Durch eine systematische Erfassung der Ergebnisse sowie regelmäßige Protokollierung können die Daten analysiert, zukünftige Entwicklungstendenzen erkannt sowie Entscheidungsanstöße abgeleitet werden. [[@noauthor_warum_2022]]

*Mit IT-Monitoring kann eine dedizierte Überwachung der IT-Infrastruktur eines Unternehmens durchgeführt werden, egal ob für Hardware oder Software. Besonders wichtig ist die Integration aller relevanten Komponenten in eine Gesamtlösung, denn nur so wird eine lückenlose Überwachung möglich und der reibungslose Betrieb gewährleistet.
Das heißt, dass neben Ressourcen wie der Speicherkapazität oder der Auslastung des Arbeitsspeichers auch Anwendungen, Prozesse, Schnittstellen, Verzeichnisse oder Logs kontrolliert werden können.
Grundsätzlich können alle Komponenten überwacht und ausgelesen werden. [[@noauthor_warum_2022]]

*Aktives IT-Monitoring ersetzt durch automatisierte Überwachung eine manuelle Kontrolle der Infrastruktur.
Das erspart Zeit und Kosten. Unternehmen können diese gesparte Zeit nutzen, um sich auf unternehmenskritische Prozesse zu konzentrieren. [[@noauthor_warum_2022]]

*Außerdem lässt sich durch IT-Monitoring einem Worst-Case-Szenario für Unternehmen vorbeugen: dem Ausfall der IT und damit wichtiger betrieblicher Funktionen.
Die Benachrichtigungsfunktion bei Überschreitung der oder Annäherung an die definierten Schwellwerte sorgt für ein frühzeitiges Erkennen von Störungen und Problemen.
Dieses Frühwarnsystem ermöglicht das Verhindern von Problemen, bevor sie überhaupt entstehen und eine schnellstmögliche Fehlerbehandlung.
So kann der durchgängige Betrieb der Systeme gesichert werden. [[@noauthor_warum_2022]]

*Neben dem bekannten Server-, Netzwerk-, Speicher-, Datenbank- und Umgebungsmonitoring können allumfänglich zum Beispiel auch Zertifikate, Versionsstände oder ausreichende Softwarelizenzierung überwacht werden.
Besonders wichtig ist das Applikationsmonitoring, da dies aktuell in der Regel noch sehr rudimentär oder manuell durchgeführt wird.
Das proaktive Handeln in der IT ersetzt vielmals das heutige Reagieren auf Störungsmeldungen durch die Benutzer. [[@noauthor_warum_2022]]

*Internes Monitoring bedeutet, dass Unternehmen die Überwachung ihrer Systeme durch eigens implementierte Strukturen auf den zu überwachenden Komponenten vollkommen selbstständig regeln.
Internes Monitoring birgt aber das Risiko, selbst von Fehlfunktionen betroffen zu sein, die sich durch die gesamte Infrastruktur inklusive Monitoring ziehen und daher die Fehlfunktionen unerkannt bleiben. [[@noauthor_warum_2022]]

*Im Gegensatz dazu muss sich ein Unternehmen bei externem Monitoring als Managed Services (z.B. bei ISR) nicht um das Thema der Bereitstellung des Tools oder Lizenzierung kümmern.
Der große Vorteil bezieht sich auf ein End-to-End-Monitoring nach Best Practices der Anwendungen und IT-Infrastruktur.
Gerade bei den Anwendungen wird eine intelligente und umfangreichere Überwachung durchgeführt. [[@noauthor_warum_2022]]



### *Welche IT-Monitoring-Systeme gibt es?

*Da es keine offizielle Liste der verschiedenen Arten von Monitoring Tools und Monitoring Software gibt und viele Begriffe mehrere Arten des IT-Monitoring beinhalten, ist in diesem Segment keine klare Abgrenzung möglich.
Im Folgenden sehen wir uns die allgemeinen IT-Monitoring-Arten an, die Teil eines IT-Monitoring-Systems sein können und in denen Monitoring Tools und IT-Monitoring-Software Anwendung finden: [[@noauthor_was_nodate-3]]

- *Verfügbarkeits-Monitoring: Verfügbarkeits-Monitoring wird oft auch als System-Monitoring bezeichnet und ist wohl die ausgereifteste Art von IT-Monitoring-Tool.
  Verfügbarkeits-Monitoring beinhaltet Kategorien wie Serververwaltung, Infrastruktur-Monitoring/-Verwaltung und Netzwerk-Monitoring/-Verwaltung und soll Benutzern Informationen über Uptime und Performance des Monitoring-Ziels bereitstellen. [[@noauthor_was_nodate-3]]

- *Web-Performance-Monitoring: Als Teilbereich von Verfügbarkeits-Monitoring ist Web-Performance-Monitoring darauf ausgelegt, die Verfügbarkeit eines Webservers oder Webservice zu überwachen.
  Liefert aber auch genauere Details über das System. Diese Monitoring Tools können Informationen wie die Ladezeit einer Seite, den Ursprung erzeugter Fehler und individuelle Ladezeiten verschiedener Web-Elemente erfassen und Analysten damit bei der Feinabstimmung der Performance einer Website oder einer webbasierten App unterstützen. [[@noauthor_was_nodate-3]]

- *Anwendungs-Management/Anwendungs-Performance-Management (APM): APM-Tools ähneln Monitoring Tools für das Web-Performance-Monitoring, sind jedoch auf kundenorientierte Anwendungen ausgerichtet.
  Diese Art von Monitoring Software ermöglicht es Analysten, die Performance einer Anwendung zu verfolgen und Probleme zu erkennen, bevor sich diese gravierend auf die Benutzerbasis auswirken.
  Modernere APM-Tools enthalten eventuell automatisierte Routinen, um diese Probleme ohne menschliches Eingreifen zu beheben.. [[@noauthor_was_nodate-3]]

- *API-Monitoring: Für Unternehmen, die APIs für Entwickler von Drittanbietern bereitstellen, ist es von entscheidender Bedeutung, die Uptime dieser Services sicherzustellen.
  Monitoring Tools und Monitoring Software für das API-Monitoring liefern Erkenntnisse darüber, ob eine API ordnungsgemäß funktioniert, und sorgen für minimale Ausfallzeiten. [[@noauthor_was_nodate-3]]

- *Real-User-Monitoring: Das Real-User-Monitoring wurde entwickelt, um die tatsächlichen Interaktionen der Endbenutzer mit einer Website oder Anwendung aufzuzeichnen.
  Durch das Monitoring der realen Ladezeiten und des Benutzerverhaltens können Probleme auf der Grundlage „realer“ (im Gegensatz zu simulierten) Herausforderungen für die Benutzererfahrung identifiziert werden.
  Dieses Monitoring ist rückwärtsgerichtet und nicht prädiktiv – Analysten erkennen Probleme also erst, nachdem sie aufgetreten sind. [[@noauthor_was_nodate-3]]

- *Sicherheits-Monitoring: Sicherheits-Monitoring ist eine sehr spezifische Art von IT-Monitoring, die darauf ausgelegt ist, ein Netzwerk auf Sicherheitsverletzungen oder andere ungewöhnlichen Aktivitäten zu überwachen.
  Sicherheits-Monitoring ist eine weit umfassende, übergeordnete Kategorie, die zahlreiche Untergruppen von Monitoring-Tools für die Sicherheitsanalyse umfasst. [[@noauthor_was_nodate-3]]

- Monitoring von Geschäftsaktivitäten: Diese Art von Monitoring-Tool erfasst die wichtigsten Performance-Metriken eines Unternehmens und verfolgt sie über einen bestimmten Zeitraum.
  Diese Metriken könnten zum Beispiel Informationen über Einzelhandelsumsätze, Downloads von Anwendungen oder das Volumen von Finanztransfers enthalten. [[@noauthor_was_nodate-3]]



*Beim Monitoring – also dem Messen, Beobachten und/oder Überwachen – geht es darum, den aktuellen Zustand von Systemen zu kennen, um auf Probleme so schnell wie möglich reagieren zu können.
In der simpelsten Form ist das die Überwachung der Systemmetriken, wie Prozessorlast, Speichernutzung, Netzwerkverkehr, etc.
Ganz früher war für jede Aufgabe ein eigener Server vorgesehen.
Ein Datenbankserver, ein Anwendungsserver, ein Fileserver, etc. Auf einem Dashboard, das in vielen Iterationen immer wieder verfeinert wurde, wurden die wichtigsten Metriken schließlich noch in ansehnlichen Charts dargestellt.
Ist ein Problem aufgetreten, wurde für jede Überschreitung eine entsprechende E-Mail versandt. Probleme wurden üblicherweise durch vorher fix definierte Warn- und Fehlergrenzen definiert [[@gutenbrunner_monitoring_nodate]]

*Je weiter wir in die Tiefen des Monitoring vordringen, desto weiter entfernen wir uns auch von dem, was als klassisches Monitoring bekannt ist.
Mit dem Einzug von Microservices ist die Performance isolierter Komponenten zum Beispiel in den Hintergrund getreten, denn selbst kleinste Anwendungen sind nun verteilte Systeme aus vielen kleinen Komponenten.
Die Zusammenarbeit dieser ist nun mindestens so wichtig.
Neben der Anwendung selber ist außerdem die Orchestrierung in den Vordergrund gerückt.
Das heißt, auch die Infrastruktur selbst muss nun überwacht werden.
Themen wie Call-Tracing sind zur Notwendigkeit geworden, um die Zusammenhänge noch sinnvoll darstellen und nachvollziehen zu können.
Vielleicht ist auch das ein Grund dafür, dass DevOps – das Zusammenwachsen von Entwicklung und Betrieb – immer mehr Einzug hält in die Entwickler- und Betreiberstuben. [[@gutenbrunner_monitoring_nodate]]



*Grundsätzlich ist ein Ziel des Monitoring die Ermittlung der Ursachen, die Parameter außerhalb der gewünschten Bereiche erzeugt. Dabei dient das Monitoring dazu:  [[@noauthor_monitoring_nodate]]
-    *das Problem so rechtzeitig zu erkennen, dass es beseitigt werden kann, bevor größere Schäden entstehen  
-    *die Ursache des Problems zu identifizieren und zu lokalisieren  
-    *Durch Know-how-Gewinn Früherkennung zukünftiger Probleme und deren Vermeidung  [[@noauthor_monitoring_nodate]]

*Hinsichtlich des Betrachtungszeitraums der beim Monitoring erfassten Daten lassen sich zwei Vorgehensweisen unterscheiden:
Das "Historical Monitoring" zielt auf eine automatische Erzeugung von (Langzeit-)Statistiken zu IT-Diensten.
Diese Form des Monitoring erlaubt die Kapazitätsplanung zum Beispiel anhand der Wachstumsraten eines bestimmten Zeitraumes, die Budgetplanung oder auch die Rechnungslegung.
Auch finden sich in derartigen Daten oft die besten Hinweise auf systematische Verfügbarkeitsprobleme und entsprechende Lösungsansätze (etwa wenn sich ein Router als Flaschenhals eines Online-Shops herausstellt).
In diesem Szenario arbeitet der Administrator eher proaktiv mit den Monitoring-Daten.  [[@noauthor_monitoring_nodate]]
  
*Reaktiv ist der Systembetreuer beim Real-Time Monitoring tätig: durch die laufende Überwachung der Funktionalität von Diensten sollen Ausfälle schnellstmöglich registriert werden und die Verantwortlichen entsprechend in Kenntnis gesetzt werden.
Im optimalen Fall hat dieser Kenntnis, bevor die Nutzer den Ausfall bemerken und kann ihn auch vorher beheben. [[@noauthor_monitoring_nodate]]

*Beim aktiven Monitoring versucht das Monitoring-System das Problem vorübergehend in Ordnung zu bringen.
Dabei wird jedoch die tatsächliche Ursache des Problems nicht beseitigt, möglicherweise verschleiert dies sogar Ursachen.
Zudem ist für viele Probleme ein derartiges Vorgehen gar nicht möglich, etwa bei einem Geräteausfall.
Gravierender ist jedoch, dass beim aktiven Monitoring ein privilegierter Zugriff auf Systeme und Dienste notwendig ist, was ein erhöhtes Sicherheitsrisiko darstellt.
Beim durchgängigen Monitoring wird hingegen dauerhaft (fast) alles überwacht.
Dies bedingt jedoch einerseits eine hohe Disziplin der IT-Verantwortlichen, etwa wenn ein neues Gerät in das Netzwerk hinzukommt (es darf nicht vergessen werden, dieses in das Monitoring zu integrieren).
Außerdem erzeugt diese Form des Monitoring eine nicht unerhebliche Datenmenge, deren gezielte Auswertung unter Umständen sehr zeitaufwändig ist.  [[@noauthor_monitoring_nodate]]
  
*Beim End-to-End-Monitoring fokussiert sich die Messung auf die Funktionalität eines Dienstes.
Will etwa ein Kunde in einem Webshop einkaufen, wird die vollständige Transaktion dieses Dienstes geprüft.
Fokussierter ist das "Application Response Time Monitoring".
Dies ermittelt die Antwortzeit einer Anwendung und ob diese in einer angemessenen Zeit erfolgt.
Denn natürlich kann es vorkommen, dass alle Komponenten des Systems funktionieren und dennoch die Reaktion des Systems so lange dauert, dass beispielsweise kein Kunde seine Bestellung im Online-Shop abschließt.  [[@noauthor_monitoring_nodate]]
  
*Beim Netzwerk-Monitoring unterscheiden wir zwischen externem und internem Monitoring.
Beim externen Monitoring wird ein zusätzliches Monitoring-Gerät an das Netz angeschlossen, beim internen Monitoring nicht.
Eine weitere Charakterisierung wird mit den Begriffen aktiv und passiv getroffen.
Beim aktiven Monitoring werden zusätzliche Pakete in das Netz gesendet, beim passiven wird lediglich mitgehört.[[@noauthor_monitoring_nodate]]


## Stichpunkte

Überbegriff für alle Maßnahmen zur automatischen Überwachung von IT-Infrastruktur bzw. interner Workflows; unter Berücksichtigung von Compliance-Richtlinien [[@noauthor_it-monitoring_nodate]]

Kernaufgaben sind systematische Protokollierung aller Komponenten und Dokumentation; Einleitung von Eskalationsprozessen bei Risiken oder Ausfällen 
bzw. Wiederherstellung von Betriebsbereitschaft [[@noauthor_it-monitoring_nodate]]

Sorgt für höhere Sicherheit von Systemen, Prozessen und Daten [[@noauthor_it-monitoring_nodate]]

---

IT-Monitoring = Überwachung von Vorgängen und Prozessen auf Funktionalität innerhalb der IT
Ziel: Reibungslosen Betrieb der IT-Infrastruktur sicherstellen
Probleme und deren Ursachen müssen vorgebeugt werden
Problem muss möglichst frühzeitig erkannt und beseitigt werden [[@noauthor_warum_2022]]

Monitoring überwacht, ob alle beobachteten Systeme sich in definierten Schwellwerten befinden
Systematische Erfassung und Protokollierung können Entwicklungstendenzen aufzeigen und Grundlage für Entscheidungen liefern [[@noauthor_warum_2022]]

Dedizierte Überwachung für IT-Infrastruktur
Integration aller Komponenten in Gesamtlösung ist wichtig; Nur so ist lückenlose Überwachung möglich
Neben Ressourcen müssen auch Anwendungen, Prozesse, Schnittstellen, Verzeichnisse oder Logs kontrolliert werden können
Grundsätzlich müssen alle Komponenten überwacht und ausgelesen werden. [[@noauthor_warum_2022]]

Aktives Monitoring ersetzt durch Automatisierung manuelle Kontroller der Infrastruktur
Spart Zeit und Kosten -> Mehr Zeit für Kerngeschäft [[@noauthor_warum_2022]]

Ausfälle lassen sich vorbeugen, sowohl in der IT als auch geschäftlichen Komponenten
Durch Schwellwerte werden Störungen frühzeitig erkannt und Administratoren benachrichtigt
Entstehen von Problemen kann im Voraus verhindert werden -> Fehlerbeseitigung wird beschleunigt
Durchgängiger Betrieb kann gesichert werden [[@noauthor_warum_2022]]

Internes Monitoring: Unternehmen überwacht eigene Systeme selbst -> Risiko liegt komplett beim Unternehmen [[@noauthor_warum_2022]]

Externes Monitoring: Managed Service, der von extern eingekauft wird -> Monitoring wird komplett von externen Dienstleister zur Verfügung gestellt [[@noauthor_warum_2022]]

---

Arten von Monitoring:

- Verfügbarkeitsmonitoring: auch als Systemmonitoring bezeichnet, am ausgereiftesten
  Beinhaltet u.a. Serververwaltung, Infrastruktur Monitoring/Verwaltung und Netzwerkmonitoring/verwaltung
  Stellt Infos wie Uptime und Performance bereit [[@noauthor_was_nodate-3]]
  
- Web-Performance-Monitoring: Überwacht Verfügbarkeit eines Webservers/-services
  erfasste Metriken sind u.a. Ladezeit einer Seite, Ursprung von Fehlern, Ladezeiten von Elementen [[@noauthor_was_nodate-3]]

- Anwendungs-Management/Anwendungs-Performance-Management (APM): Ähnlich Web-Performance-Monitoring, jedoch auf kundenspezifische Anwendung ausgelegt; erlaubt Verfolgung der Performance der Anwendung und Analyse von auftretenden Problemen [[@noauthor_was_nodate-3]]

- API-Monitoring: Stellt Informationen über Funktion und Erreichbarkeit von APIs bereit [[@noauthor_was_nodate-3]]

- Real-User-Monitoring: Überwacht tatsächliche Interaktionen des Endnutzers
  Reale Probleme können aufgrund Benutzerinteraktion aufgezeichnet werden; ausschließlich rückwärtsgerichtet und nicht prädiktiv -> Probleme können erst nach Auftreten festgestellt werden [[@noauthor_was_nodate-3]]

- Sicherheits-Monitoring: Überwachung eines Netzwerks auf Sicherheitsverletzungen oder verdächtige Aktivitäten [[@noauthor_was_nodate-3]]

- Lizenzmonitoring

- Monitoring von Geschäftsaktivitäten: Erfasst wichtigste Performance-Metriken eines Unternehmens und verfolgt diese über Zeit
Z.B. Einzelhandelsumsätze, Downloads von Anwendungen oder Volumen von Finanztransfers [[@noauthor_was_nodate-3]]

---

Monitoring = Messen/Beobachten/Überwachung von Systemen -> aktueller Zustand jederzeit bekannt -> auf Probleme kann möglichst schnell reagiert werden [[@gutenbrunner_monitoring_nodate]]

Simpelste Form: Sammlung von Systemmetriken (Prozessorlast, Speichernutzung, Netzverkehr, etc.) [[@gutenbrunner_monitoring_nodate]]
Darstellung auf Dashboards  [[@gutenbrunner_monitoring_nodate]]

Beim Auftreten von Problemen, Benachrichtigung per Mail; Probleme wurden durch Schwellwerte definiert  [[@gutenbrunner_monitoring_nodate]]

Durch Umstieg von monolithischen Anwendungsstrukturen auf Microservices muss nun auch Infrastruktur gemonitort werden
Call Tracing -> Tracing erklären [[@gutenbrunner_monitoring_nodate]]

Historical Monitoring:
Erzeugung von Langzeitstatistiken zu IT-Diensten
Erlaubt u.a. Kapazitätsplanung, Budgetplanung und Rechnungsstellung
Hinweise auf systematische Verfügbarkeitsprobleme [[@noauthor_monitoring_nodate]]


