## Allgemeines

Das Simple Network Management Protocol [[@noauthor_was_nodate-4]] (SNMP) ist ein Protokoll zur Steuerung und Überwachung von Netzwerkgeräten wie Routern oder Schwitchen. [[@noauthor_snmp_nodate]] Es ist für den Austausch von Management-Informationen und Status- und Statistikdaten zwischen Netzwerkstationen und einem Management-System zuständig. [[@noauthor_snmp_nodate-1]] SNMP ist der Quasi-Standard für Monitoring im Netzwerkbereich. [[@noauthor_was_nodate-4]] Es wurde Mitte der 1980er bei der Einführung von TCP/IP als Übergangslösung eingeführt. Später sollte SNMP durch ein OSI-Konformes Protokoll ersetzt werden. [[@noauthor_snmp_nodate-1]] SNMP hat sich jedoch durchgesetzt [[@noauthor_snmp_nodate-1]] und wurde in den 1990ern und den 2000ern zum Standard. Die rapide Akzeptanz von SNMP und die zu großen, notwendigen Anpassungen für das OSI-konforme Protokoll führten dazu, dass die Entwicklung von diesem ausgesetzt wurden. [[@noauthor_snmp_nodate-1]] SNMP und die dazugehörige MIB (Management Information Database) wurden zum Standard. [[@noauthor_snmp_nodate-1]] Zur Übertragung im Netzwerk verwendet es die UDP-Ports 161 und 162. Hierbei wird der Port 161 zur Abfrage des Agenten verwendet. Port 162 dient zur Übermittlung der SNMP Traps. Die Portnummer sind in allen Versionen von SNMP gleich. [[@jessica_scarpati_was_nodate]] UDP wurde gewählt, da es das Netzwerk weniger belastet. [[@noauthor_snmp_nodate-1]]

## Aufbau

Das Grundkonzept von SMP sieht den Informationsaustausch zwischen den Agenten und dem Manager vor. [[@donner_was_2018]] Dabei ist das Network Management System mit dem SNMP Manager die einzige Schnittstelle für den Administrator. Mit diesem kann er Batch-Befehle ausführen und automatische Warnmeldungen erhalten. [[@jessica_scarpati_was_nodate]] Ein SNMP-basiertes Monitoringsystem besteht aus vier Komponenten:
- Agent
- Manager
- Verwaltungsinformationen:
	- Bei diesen handelt es sich um Informationen über das Netzwerk, die Konfiguration, den Aufbau und statistische Daten.
- Verwaltungsprotokoll
	- An dieser Stelle kommt das eigentliche SNMP-Protokoll zum Einsatz.
[[@noauthor_snmp_nodate-1]]

Zur Abfrage der einzelnen Geräte im Netzwerk gibt die Möglichkeit eines SNMP-Walks. Hierbei werden alle SNMP-Daten auf einem Gerät abgefragt. Notwendig hierfür ist allerdings eine Liste der Adressen der Zielgeräte. [[@noauthor_was_nodate-4]]
### Agent:

Der Agent ist eine Software, welche auf den zu überwachenden Geräten läuft. Diese kann Systemzustände erfassen, Einstellungen ändern und Aktionen auslösen. Sie ist insgesamt eine kleine Applikation, welche mit dem Netzwerkmanagementsystem kommuniziert und Statusinformationen und Konfigurationsänderungen austauscht. [[@jessica_scarpati_was_nodate]] [[@noauthor_was_nodate-4]] Der SNMP Agent hat drei Aufgaben:
- Das Beantworten von GET-Abfragen des Managers,
- die Konfiguration bzw. Verwaltung des Endgerätes,
- und das Versenden von Traps. [[@noauthor_was_nodate-4]]
Implementierungen von SNMP-Agents sind für viele Betriebssysteme verfügbar. [[@noauthor_was_nodate-4]] Der Agent kann auch proaktiv Meldungen an den Manager senden, eine solche Meldung wird dann als Trap bezeichnet. [[@jessica_scarpati_was_nodate]]

Der Agent kann allgemeine und herstellerspezifische Traps versenden. Allgemeine Traps beziehen sich auf übliche Ereignisse, wie beispielsweise dem Abbrechen einer Verbindung. Herstellerspezifische Traps ermöglichen es Geräteherstellern, eigene Meldungen zu definieren.  [[@noauthor_was_nodate-4]]

### Manager

Der Manager ist eine gesonderte Anwendung auf einem zentralen Server. [[@noauthor_snmp_nodate-1]] Sie kommuniziert mit den Agenten über SNMP und nimmt deren Meldungen(Traps) entgegen. [[@donner_was_2018]] Der Manager fragt zusätzlich in regelmäßigen Abständen den Zustand der Agents ab [[@noauthor_was_nodate-4]] und bildet die Grundlage eines Networkmanagementsystems. [[@jessica_scarpati_was_nodate]] Der Administrator kann über diese zentrale Schnittstelle das Netzwerk verwalten. [[@jessica_scarpati_was_nodate]]

### Management Information Base

Die Management Information Base (MIB) ist die Grundlage für SNMP. Sie organisiert, wie Informationen über Gerätemetriken ausgetauscht werden. Genauer ist sie eine formale Beschreibung der Komponenten und Statusinformationen von Geräten. [[@jessica_scarpati_was_nodate]] Eine MIB ist eine Textdatei, welche alle Objekte auf dem Gerät auflistet, welche per SNMP abgefragt werden kann. [[@jessica_scarpati_was_nodate]] Mit dieser können die Object ID (OID) auf den Geräten in eine menschenlesbare Form übersetzt werden. [[@noauthor_was_nodate-4]] Mit zunehmender Komplexität des Gerätes wird auch die MIB größer. [[@noauthor_was_nodate-4]] Sie wird vom Hersteller herausgegeben und gepflegt. [[@noauthor_was_nodate-4]]

### Object Identifier:

Object Identifier sind ein Identifikaitonsmechanismus für Objekte auf SNMP-fähigen Geräten. [[@noauthor_was_nodate-4]] Sie benennen jede Art von Konzept oder Objekt in einer baumartigen Struktur. [[@thomas_niedermeier_snmp_nodate]] Es handelt sich dabei um einen internationalen Standard, welcher ein Objekt weltweit durch eine lange, mit Punkten getrennte Zahlenfolge eindeutig identifiziert. Einige Zweige sind dabei allgemein gültig, andere werden vom Gerätehersteller definiert. [[@noauthor_was_nodate-4]] Die nachfolgende Abbildung visualisiert die Baumstruktur der OID und die Position der einzelnen Attribute.

![[grafik-OID-tree.jpeg]][[@noauthor_was_nodate-4]]

## Kommunikation

Die Kommunikation zwischen dem Netzwerkmanagementsystem und den Netzgeräten basiert auf einer Push-Pull-Konfiguration. Agents auf den Netzgeräten sammeln permanant Statusinformationen und werden in regelmäßigen Abständen vom Master abgefragt. [[@jessica_scarpati_was_nodate]] Tritt ein ungewöhnliches Ereignis ein, so sendet der Agent eine unaufgeforderte Nachricht an den Manager. [[@donner_was_2018]] Die nachfolgende Grafik illustriert diesen Sachverhalt:

![[Snmp-agent-manager.png]] [[@thomas_niedermeier_snmp_nodate]] 

Wie der Grafik entnommen werden kann, verläuft die Kommunikation meist synchron und nach demselben Muster, mit Ausnahme der SNMP Traps. [[@jessica_scarpati_was_nodate]]

## Versionen

Seit seiner Einführung wurden drei Versionen von SNMP entwickelt. [[@donner_was_2018]] Trotz massiver Sicherheitsproblemen ist es noch heute die meistgenutzte Netzwerkmonitoringlösung, aufgrund seiner Simplizität und Menge an Metriken. [[@noauthor_was_nodate-4]] Generell gilt jedoch, dass SNMP nicht sicher ist, und lediglich in internen Netzwerken eingesetzt werden sollte. [[@noauthor_was_nodate-4]]

Insgesamt gibt es drei Hauptversionen:
- Version 1:
	- Schwachstellen mit Sicherheitsrisiken und Leistungseinschränkungen
	- Authentifizierung erfolgt über einen Community-String
	- Erforderlichkeit von IP-Zugriffssteuerungslisten (ACLs)
	- Keine Verschlüsselung der übertragenen Daten
	- Keine Möglichkeit von Massenabfragen (Bulkabfragen)
	[[@noction_snmp_2022]]

- Version 2:
	- SNMP v2c:
		- führt 64 Bit Counter ein
		- verbessert Performance im Netzwerk
		- führt Bulkabfragen ein
		- führt Möglichkeit für Manager-Manager-Kommunikation ein
			- Inform Request
			- Manager 1 sendet diese wiederholt an Manager 2 bis diese quittiert wird
		- Community-String zur Authentifizierung
		[[@noction_snmp_2022]]
	- SNMP v2u:
		- Parallel zu v2c entwickelt
		- bessere Sicherheit als v1
		- weniger komplex als v2
		- nicht weit verbreitet
		- Inspiration für v3
		[[@noauthor_was_nodate-4]]

- Version 3:
	-  Führt Message Integrity, Verschlüsselung und Authentifizierung ein
	- führt ACL mit SNMP View, Gruppen und User ein
	[[@noction_snmp_2022]]

Der Community-String ist ein Passwort, welches eine alphanumerische Zahlenfolge ist. Es dient zur Authentifizierung zwischen der Kommunikation zwischen Agent und Manager. Bei den Versionen v1 und v2c wird die Zeichenfolge unverschlüsselt als Plain-Text über das Netzwerk gesendet. Erst mit der Version v3 wird die Kommunikation verschlüsselt. Die Verschlüsselung muss zusätzlich im Voraus konfiguriert werden.
[[@noauthor_was_nodate-4]]