Als Skalierbarkeit wird in der Informatik die Fähigkeit eines Systems bezeichnet, sich wachsenden oder schrumpfenden Anforderungen an Hard- bzw. Software anpassen zu können. Ein System, dass mit dieser Fähigkeit ausgestattet ist, funktioniert auch nach einer Anpassung weiter, ohne in seinen Fähigkeiten eingeschränkt zu werden. Es kann fortlaufend die Anforderungen des Betreibers erfüllen. [[@geisler_was_2019]] Der Skalierbarkeitsfaktor gibt dabei das Verhältnis von zusätzlicher Leistung zu den zusätzlich einsetzen Ressourcen an. [[@geisler_was_2019]] Das Deployment einer Anwendung auf einem größeren/stärkeren System ist einfacher zu realisieren, als diese von einem sehr leistungsfähigen System auf ein kleineres zu portieren (sog. Downscaling). Das Downscaling kann jedoch auch zeigen, ob ein System in einer leistungsschwächeren Umgebung funktionieren kann. [[@geisler_was_2019]]


Für die Skalierung werden zwei Richtungen unterschieden:
- vertikal
- und horizontal [[@geisler_was_2019]]

Die vertikale Skalierung beschreibt, dass einer logischen Einheit weitere Ressourcen hinzugefügt werden. Hierbei kann es sich um zusätzlichen RAM, weitere CPU Kerne oder andere Ressourcen handeln. Die Software muss hierfür nicht gesondert angepasst werden, sondern kann die zusätzlichen Ressourcen gleich benutzen. Limitiert wird dieser Ansatz durch die am Markt verfügbare Hardware.

![[scaleup.png]]
[[@anderson_couchdb_2010]] Seite 6ff

Anders sieht es bei der horizontalen Skalierbarkeit aus:
Bei dieser wird die Leistungserhöhung durch das Hinzufügen von weiteren Rechenknoten realisiert. Hierzu ist es zwingend notwendig, dass die Rechenoperationen der Software parallelisiert werden können. Hierdurch wird weiter die Verwendung eines Loadbalancers zwingend notwendig. Der Skalierbarkeitsfaktor ist bei diesem Ansatz niedriger, wodurch dieser im Allgemeinen weniger Overhead erzeugt und kosteneffizienter ist. [[@geisler_was_2019]]

![[scaleout.png]]
[[@anderson_couchdb_2010]] Seite 6ff

Die beiden Ansätze zur Skalierung einer Applikation schließen sich nicht gegenseitig aus, sondern ergänzen sich. [[@feix_skalierbare_2015]] Dies wird in der nachfolgenden Abbildung deutlich:

![[Skalierbarkeitspyramide.jpg]] [[@feix_skalierbare_2015]]

Die Skalierbarkeitspyramide zeigt deutlich, dass mit der horizontalen Skalierbarkeit zunächst die größten Erfolge in Bezug auf die Leistungssteigerung erzielt werden können. Durch das Hinzufügen weiterer Ressourcen wird die Performance der Applikation in keinem so hohen Maß gesteigert [[@feix_skalierbare_2015]]

Um die Skalierungsfähigkeit einer Software einschätzen zu können werden verschiedene Wachstumsarten genutzt:
- lineares Wachstum:
	Bei dieser Wachstumsart wächst die Leistungsfähigkeit des Systems linear mit den zur Verfügung stehenden Ressourcen. Ein zusätzlicher Rechenknoten erhöht die Leistungsfähigkeit des Systems also um 100 Prozent [[@rauch_was_2021]]
- sub-lineares Wachstum:
	Die Leistungsfähigkeit des Systems wächst sub-linear mit den zur Verfügung stehenden Ressourcen. Eine zusätzliche Ressource erhöht die Leistungsfähigkeit des Gesamtsystems also nur um beispielsweise 75 Prozent. [[@rauch_was_2021]]
- super-lineares Wachstum:
	Beim super-linearnen Wachstum erhöht sich die Gesamtleistung des Systems um z.B. 125 Prozent nach dem Hinzufügen weiterer Ressourcen. [[@rauch_was_2021]]
- negative Skalierbarkeit:
	Hierbei handelt es sich um einen Sonderfall. Durch das Hinzufügen weiterer Ressourcen wächst die Leistungsfähigkeit des Systems nicht, sondern sie nimmt ab. [[@rauch_was_2021]]

Zusätzlich zu den verschiedenen Arten des Wachstums sind auch verschiedenen Arten der Skalierbarkeit zu beachten:
- Lastskalierbarkeit:
	- Diese Art der Skalierbarkeit beschreibt das Systemverhalten bei hoher oder niedriger Auslastung. Dieses sollte im Idealfall konstant bleiben. [[@rauch_was_2021]]
- räumliche Skalierbarkeit
	- Hierbei handelt es sich um den Anstieg des Speicherbedarfes bei steigender Auslastung. Dieser sollte im Idealfall sub-linear sein und kann durch den Einsatz einer Sparse-Matrix oder Kompression erzielt werden. Allerdings gilt zu beachten, dass diese Maßnahmen mehr Rechenleistung benötigen, was zur Last der Lastskalierbarkeit geht. [[@rauch_was_2021]]
- Strukturelle Skalierbarkeit
	- Die strukturelle Skalierbarkeit beschreibt die Menge der Objekte, welche in einem definierten Bereich erhöht werden kann, ohne das System in irgendeiner Art negativ zu beeinflussen. [[@rauch_was_2021]]
- Zeitlich-räumliche Skalierbarkeit
	- Hierbei handelt es sich um die Antwortzeit, wenn die Anzahl der Datenobjekte ansteigt. [[@rauch_was_2021]]
- Geographische Skalierbarkeit
	- Dieser Aspekt beschreibt die Einflussnahme von geographischen Entfernungen auf das System [[@feix_skalierbare_2015]]
- Administrative Skalierbarkeit
	- Die Anzahl der beeinflusst die Performance des Systems nicht. [[@feix_skalierbare_2015]]

Allgemein gibt er in der Softwareentwicklung einige Aspekte, welche die Entwicklung von skalierbarer Software behindern können. Diese können beispielsweise  die Verwendung von ausschließlich synchronen Funktionsaufrufen sein. [[@feix_skalierbare_2015]] Dabei wartet das Programm beim Aufruf der entsprechenden Funktion auf die Antwort und blockiert die weitere Ausführung. Abhilfe kann hier die Verwendung von asynchronen Aufrufen. [[@noauthor_was_nodate-7]] Ein weiterer Aspekt kann beispielsweise sein, dass eine Datenbank nicht als Cluster arbeitet. Hierbei ist die Datenbank ein Bottelneck, da in diesem Fall der Datenbankserver nicht über genug Ressourcen zur Bearbeitung der Anfrage verfügt. [[@feix_skalierbare_2015]] Ferner können Ressourcenkonflikte auf Betriebssystemen (Racecondition) die Ausführung einer Software behindern. Hierbei handelt sich um eine Konfliktsituation zwischen zwei Prozessen, die gleichzeitig auf dieselbe Ressource zugreifen und im schlimmsten Fall zu inkonsistenten Daten führt. [[@noauthor_was_nodate-8]] Abschließend kann die Verwendung von zustandsbehafteten Komponenten die Ausführung einer Software behindern. Diese werden im Kontext von vorangegangenen Transaktionen ausgeführt. Anders verhält es sich mit zustandslosen Komponenten. Bei diesen läuft die Kommunikation nach folgendem Schema ab: Eine Anfrage ergibt eine Antwort, welche komplett für sich allein steht. [[@noauthor_zustandsbehaftet_nodate]]