*Mit Skalierbarkeit wird die Fähigkeit einer IT-Anlage oder eines Systems verstanden, sich den wachsenden oder auch schrumpfenden Anforderungen hinsichtlich der Leistungsfähigkeit auf Hardware- und Software-Ebene anpassen zu können [[@geisler_was_2019]]

*Eine IT-Anlage oder ein System, das erfolgreich skaliert wurde, funktioniert auch dann noch, wenn sie oder es in Größe oder Volumen verändert wurde, um die neuen Anforderungen eines Betreibers zu erfüllen. Doch Skalierbarkeit bedeutet nicht nur, dass die neu skalierte Anlage oder Anwendung funktioniert, sondern dass auch dessen Vorteile nutzbar sind. [[@geisler_was_2019]]

*Im Grunde gestaltet sich eine Skalierung nach oben einfacherer als nach unten. Dies ist der Tatsache geschuldet, dass die Entwickler dafür oftmals sämtliche Ressourcen eines Systems bedienen müssen. Eine Skalierung nach unten zeigt unter anderem, ob eine ähnliche [Performance](https://www.datacenter-insider.de/was-ist-performance-in-der-it-a-735949/) auch in einer „kleineren“ Umgebung realisierbar sein kann. [[@geisler_was_2019]]

*Vertikale Skalierung:

*Werden Ressourcen innerhalb einer logischen Einheit hinzugefügt, so liegt eine vertikale Skalierbarkeit (Scale up) vor. Das heißt, die Leistungssteigerung entsteht durch das Hinzufügen von Ressourcen zu einem Knoten/Rechner innerhalb des Systems. [[@geisler_was_2019]]

*Beispiele dafür wären: das Vergrößern von Speicherplatz, das Hinzufügen einer [CPU](https://www.datacenter-insider.de/rechnen-mit-kernen-die-cpu-der-hauptprozessor-a-573253/), Aufrüstung von Arbeitsspeichern, der Einbau einer leistungsstärkeren Grafikkarte oder das Ersetzen von weniger leistungsfähigen Bauteilen. Für das Cloud Computing bedeutet das beispielsweise, dass die Virtual Machines ([VM](https://www.datacenter-insider.de/was-sind-virtuelle-maschinen-a-644494/)) erweitert werden. [[@geisler_was_2019]]

*Bei einer vertikalen Skalierung lässt sich die [Software](https://www.datacenter-insider.de/software-der-treibstoff-fuer-den-computer-a-589358/) sehr leicht anpassen oder eine Anpassung ist bisweilen überhaupt nicht erforderlich. Meist muss keine Zeile Code geändert werden, um eine Leistungssteigerung durch vertikales Skalieren zu erhalten. Jedoch stößt man früher oder später an eine Grenze, bei der ein Rechner nicht weiter aufrüstbar ist, weil bereits die beste [Hardware](https://www.datacenter-insider.de/hardware-ist-greifbar-a-578479/) verwendet wird. [[@geisler_was_2019]]

*Horizontale Skalierung:

*Aus der Sicht der Hardware sind bei der horizontalen Skalierung (scale out) im Gegensatz zur vertikalen Skalierung keine Grenzen gesetzt. Denn hier ist die Leistungssteigerung eines Systems durch das Hinzufügen zusätzlicher Rechner/Knoten gemeint. Andererseits hängt die Effizienz dieser Skalierung stark von der Implementierung der Software ab, da sich nicht jede Software gleich gut parallelisieren lässt. [[@geisler_was_2019]]

*Anders gewendet könnte man sagen, eine horizontale Skalierung liegt dann vor, wenn weitere Instanzen hinzukommen, damit die steigende Workload mit gleichbleibender Performance verarbeitet werden kann. In einem [Rechenzentrum](https://www.datacenter-insider.de/rechenzentren-sind-konzentrierte-it-power-und-ort-des-geschehens-a-573707/) verteilen sich dann die anstehenden Aufgaben auf mehrere Rechner oder [Server](https://www.datacenter-insider.de/warum-heisst-der-server-server-a-567972/). Dies wird in der Praxis dadurch gelöst, dass ein Rechner davon als Verteiler für die Workloads der anderen agieren muss. [[@geisler_was_2019]]

*Die Koordination als Lastverteiler ist immer dann nötig, wenn viele Ressourcen-Einheiten zusammen in einer horizontalen Skalierung arbeiten sollen. Daher ist der so genannte Skalierbarkeitsfaktor (Verhältnis von zusätzlicher Leistung zu zusätzlich eingesetzten Ressourcen) bei einer horizontalen Skalierbarkeit im Allgemeinen niedriger. [[@geisler_was_2019]]

*Die horizontale Skalierung ist häufig kostengünstiger als eine vertikale Skalierung. Wobei eine vertikale Skalierung hinsichtlich der Overheads vielfach wesentlich effizienter ist als eine horizontale Skalierung. [[@geisler_was_2019]]



*Der Einsatz von besserer Hardware oder des Upgrades eines Rechners bzw. Knotenpunktes wird vertikale Skalierung genannt. Sprechen wir von vertikaler Skalierbarkeit, so meinen wir im Allgemeinen vorrangig die Skalierbarkeit nach oben. In seltenen Fällen ist jedoch auch von der Skalierbarkeit nach unten die Rede, in diesen Fällen funktioniert die Software weiter, aber mit verringerter Performance. [[@rauch_was_2021]]

*Natürlich ist Software dabei niemals beliebig nach unten oder oben skalierbar. Vielmehr gibt es physische Leistungsgrenzen, unter denen Software gar nicht lauffähig ist und Hardware, deren Funktionalität und Geschwindigkeit die Software nicht ausnutzen kann - beispielsweise weil diese zum [Release](https://www.dev-insider.de/was-ist-ein-software-release-a-7f4da0dff9ffd327b5f3aa8d24fb93f7/)-Zeitpunkt noch nicht einmal konzipiert war. [[@rauch_was_2021]]

*Das horizontale Skalieren hingegen setzt auf das Aneinanderreihen von mehr Rechnern und Knotenpunkten und kann theoretisch beliebig weiter gedacht werden. Die Leistungsgrenze ist hier eher Software-seitig gesetzt, da das Parallelisieren von Software nicht für jede Art Anwendung geeignet ist. Ein Beispiel für horizontale Skalierbarkeit sind beispielsweise Serverfarmen oder Rechenzentren. [[@rauch_was_2021]]

- *Lastskalierbarkeit: Unter Lastskalierbarkeit versteht man ein System, dass weder bei sehr geringer noch bei sehr hoher Belastung eine Verzögerung aufweist. Das Systemverhalten wird hierbei als konstant beschrieben. [[@rauch_was_2021]]

- *Räumliche Skalierbarkeit: Relevant für den Begriff der räumlichen Skalierbarkeit ist vor allem der akzeptable Anstieg des Speicherbedarfs. Dieser sollte sub-linear erfolgen, was in der Regel durch höhere Kompression oder den Einsatz einer sparse matrix erfolgt. [[@rauch_was_2021]]

- *Dieser sub-lineare Anstieg des Speicherbedarfs erfolgt jedoch auf Lasten der Lastskalierbarkeit, da höhere Datenkompressionsraten ebenfalls mehr Rechenleistung und Zeit erfordern. [[@rauch_was_2021]]

- *Zeitlich-räumliche Skalierbarkeit: Ein Beispiel für zeitlich-räumliche Skalierbarkeit findet sich in Form von modernen indizierten Suchmaschinen (wie beispielsweise Google). Der Anstieg an Daten führt bei Google nicht zu einem linearen Anstieg der Suchzeit, weil die Sortierung der Daten die notwendige Skalierbarkeit erlaubt. Hohe Performance wirkt sich folglich nicht auf die Performance aus. [[@rauch_was_2021]]

- *Strukturelle Skalierbarkeit: Bei der strukturellen Skalierbarkeit kann die Anzahl der Objekte in einem definierten Bereich erhöht werden, ohne das System in seiner Performance negativ zu beeinflussen. Das System behindert also eine hohe Auslastung nicht. [[@rauch_was_2021]]

*Die vier Formen der Skalierbarkeit können nicht unabhängig voneinander betrachtet werden, da unterschiedliche Formen der Skalierbarkeit, abhängig von [Implementierung](https://www.dev-insider.de/was-ist-implementierung-a-903068/) und System, Wechselwirkungen aufeinander haben können, aber nicht müssen. [[@rauch_was_2021]]

*Weiter oben war bereits vom Skalierungsfaktor die Rede, dieser bezeichnet den tatsächlichen Leistungszuwachs (Speed Up) beim Hinzufügen einer Leistungseinheit. Unterschieden wird hier zwischen super-linearem, linearem und sub-linearem Zuwachs. Verdeutlicht sei dies anhand des Hinzufügens eines Prozessorkerns und der skalierenden Leistung einer Software. [[@rauch_was_2021]]

- *Lineares Wachstum: Die Skalierbarkeit wächst analog zu den zur Verfügung stehenden Ressourcen, ein zweiter Prozessorkern erhöht die Leistung um 100 Prozent. [[@rauch_was_2021]]

- *Sub-lineares Wachstum: Die Skalierbarkeit nimmt mit den Ressourcen ab, hier würde ein zweiter Prozessorkern beispielsweise nur 75 Prozent Leistung zusätzlich bringen. [[@rauch_was_2021]]

- *Super-lineares Wachstum: Die Skalierbarkeit steigt mit weiteren Ressourcen an und wird immer größer, ein zweiter Prozessorkern könnte hier die Leistung etwa um 125 Prozent steigern. [[@rauch_was_2021]]

- *Negative Skalierbarkeit: Ein Sonderfall, bei dem die Leistung mit mehr Ressourcen nicht steigt, sondern sinkt. Dies kann in Systemen dann der Fall sein, wenn die zusätzlichen Systemressourcen nicht eingesetzt werden können, das Systemmanagement diese aber verwalten muss. [[@rauch_was_2021]]



*Bei der vertikalen Skalierung, die international gerne als "Scale-up" bezeichnet wird, werden die Ressourcen lokal zu einem Rechnerknoten hinzugefügt. Dabei wird der bestehende Rechner einfach mit leistungsfähigerer Hardware, wie z. B. CPUs, Hauptspeicher, Festplatten oder Netzwerkschnittstellen, erweitert. Diese Strategie der vertikalen Skalierung ist einfach zu verstehen und hat in der Regel keinen Einfluss auf die Software-Architektur. Doch erkauft man sich den Zuwachs an Möglichkeiten oftmals durch teure Spezialhardware und man kommt schnell an die physischen Grenzen des Rechners.  [[@feix_skalierbare_nodate]]

*Bei der horizontalen Skalierung, die international gerne als "Scale-out" bezeichnet wird, werden die Ressourcen dem Netzwerk hinzugefügt. Dazu werden einfach weitere Rechner zu einem bestehenden Rechnernetz hinzugefügt und die Aufgaben werden auf mehrere Rechner verteilt. Um die horizontale Skalierungsstrategie nutzen zu können braucht man einen Verbund aus mehreren Rechnern. Außerdem muss sich das Problem, das man mit der horizontalen Skalierung lösen möchte, auch verteilen lassen – sonst sind den Skalierungsmaßnahmen schnell Grenzen gesetzt und man ist ggf. gezwungen, das ganze Rechnernetz einschließlich Datenbank zu duplizieren. Dafür hat man aber in der Regel bei einer horizontalen Skalierung eine preisgünstige Möglichkeit, einem System neue Ressourcen hinzuzufügen, da man nach Aufbau des verteilten Netzes auf die Anschaffung teurer Spezialhardware verzichten kann.  [[@feix_skalierbare_nodate]]

*Es ist nun wichtig zu erkennen, dass sich die beiden Skalierungsstrategien der horizontalen und der vertikalen Skalierung nicht gegenseitig ausschließen, vielmehr ist es oftmals möglich, beide Strategien sinnvoll zu kombinieren.  [[@feix_skalierbare_nodate]]

*Nachdem wir uns mit den beiden Strategien zur Durchführung von Skalierungsmaßnahmen beschäftigt haben, kommen wir nun zu den sechs verschiedenen Arten von Skalierbarkeit:

1. *Lastskalierbarkeit  
    Bei der Lastskalierbarkeit geht es darum, wie das System mit einer Erhöhung der aktiven Nutzerzahl umgehen kann. Dazu teilt man die Anwender eines Systems gerne in Power-User und Gelegenheitsnutzer ein. Power-User sind Vielnutzer, die das System über einen Großteil der Arbeitszeit hinweg nutzen, während Gelegenheitsnutzer das System erfahrungsgemäß nur in den zwei bis fünf Stunden der höchsten Beanspruchung aktiv nutzen. Um nun mit einer erhöhten Nutzerzahl umgehen zu können, werden Ressourcen lastabhängig hinzugefügt oder eingeschränkt. Die Verschiebung von Prozessen und Daten auf Ressourcen erfolgt für den Benutzer und die Anwendung verdeckt und unbemerkt. Welche Prozesse und welche Daten wohin verschoben werden, entscheidet das System automatisch.  [[@feix_skalierbare_nodate]]
2. *Räumliche Skalierbarkeit  
    Die räumliche Skalierbarkeit gibt an, inwiefern das System mit dem erhöhten Speicherbedarf umgeht, wenn die Anzahl der Datenobjekte ansteigt.  [[@feix_skalierbare_nodate]]
3. *Zeitlich-räumliche Skalierbarkeit   
    Die zeitlich-räumlichen Skalierbarkeit dagegen zeigt an, wie das System mit der erhöhten Antwortzeit umgeht, wenn die Anzahl der Datenobjekte ansteigt.  [[@feix_skalierbare_nodate]]
4. *Strukturelle Skalierbarkeit
    Eine gute strukturelle Skalierbarkeit sagt aus, dass sich die Software-Architektur des Systems nicht hinderlich auf die Erhöhung der Anzahl der Datenobjekte auswirkt.   [[@feix_skalierbare_nodate]]
5. *Geographische Skalierbarkeit 
    Bei der geographischen Skalierbarkeit geht es darum, das die geographische Entfernung des Systems von Benutzer und Ressourcen keinen oder nur wenig Einfluss auf die Leistungsfähigkeit des Systems hat.  [[@feix_skalierbare_nodate]]
6. *Administrative Skalierbarkeit 
    Bei der administrativen Skalierbarkeit geht es darum, dass die ggf. variierende Anzahl der Organisationen, die sich ein System teilen, nicht beschränkt ist. Anhand dieser Art der Skalierbarkeit soll das Managen, Überwachen und der Gebrauch eines Software-Systems einfach zu bewerkstelligen und von überall auf der Welt aus möglich sein.  [[@feix_skalierbare_nodate]]

*Um die verschiedenen Maßnahmen zur Verbesserung der Skalierbarkeit besser einordnen zu können, kann man die sog. "Skalierungspyramide" verwenden (s. Abb.2). Die Skalierungspyramide ist eine Darstellung mit vier Ebenen. An der Spitze steht die Ebene 4 mit der Hardware-Optimierung, darunter folgt in Ebene 3 die System- und Produkt-Optimierung. Darunter folgt in Ebene 2 die Code-Optimierung und als unterste Ebene 1 schließlich der Entwurf. Die Auswirkungen auf die Skalierbarkeit nehmen von oben nach unten zu. Dies bedeutet, dass man mit Hardware-Optimierungen (also z. B. der Strategie der vertikalen Skalierung) die geringsten Auswirkungen auf die Skalierbarkeit eines Systems hat und im Entwurf die größten Auswirkungen auf die Skalierbarkeit erreichen kann. [[@feix_skalierbare_nodate]]

*Neben der Skalierungspyramide zur Einordnung der Skalierungsmaßnahmen gibt es noch eine Reihe weiterer Best-Practices – Tipps & Tricks die auch im folgenden Projektbeispiel immer wieder eine Rolle spielen:

- *Nutzen Sie die vertikale und die horizontale Skalierungsstrategie
- *Nutzen Sie asynchrone Kommunikation vor synchroner Kommunikation
- *Verwenden Sie Clustersysteme
- *Halten Sie Ressourcenkonflikte möglichst klein
- *Machen Sie Komponenten möglichst zustandslos
- *Trennen Sie transaktionale Aufrufe von nicht-transaktionalen Aufrufen [[@feix_skalierbare_nodate]]

*Wie schon erläutert, gibt es gute Gründe für die Verwendung beider Skalierungsstrategien: Also nutzen Sie möglichst auch die vertikale und die horizontale Skalierungsstrategie in einer Softwareschicht. [[@feix_skalierbare_nodate]]

*Die meisten heutigen Frameworks arbeiten mit synchronen Aufrufen. Synchrone Aufrufe haben die Eigenschaft, nach einem Aufruf zuerst auf eine Antwort zu warten bis die Verarbeitung weiter geht. Asynchrone Aufrufe haben dagegen den Vorteil, dass man nicht auf die Antwortnachricht warten muss. Daher kann die Verwendung eines Frameworks mit asynchroner Kommunikation bei hohem Kommunikationsaufkommen die Verarbeitung deutlich beschleunigen. [[@feix_skalierbare_nodate]]

*Heutige Datenbanken haben ausgereifte Clustersysteme. In Clustern sind die Verteilungsalgorithmen und der automatische Neustart bei Absturz einzelner Rechnerknoten schon fest mit integriert. Es gibt also keinen Grund mehr, eigene Lösungen für Clustersysteme zu basteln oder auf Cluster zu verzichten. [[@feix_skalierbare_nodate]]

*Das Minimieren von Ressourcenkonflikten ist eine alte Weisheit – es lohnt sich aber oft, einmal wirklich darauf zu achten, dass man im Code Ressourcen nur so lange blockiert wie man sie wirklich benötigt. Wird nicht auf das Minimieren von Ressourcenkonflikten geachtet, dann hat das System bei vielen Zugriffen auf die knappen Ressourcen wahrscheinlich schnell Probleme zu skalieren. [[@feix_skalierbare_nodate]]

*Eine weitere Strategie zur Verbesserung der Skalierbarkeit ist es, Komponenten möglichst zustandslos ("stateless") zu machen, um sie besser verwenden zu können. Schließlich geben wir noch den Rat, transaktionale Aufrufe von nicht-transaktionalen Aufrufen zu trennen. Die Trennung führt unter anderem dazu, dass für die beiden Aufrufarten auch zwei verschieden teure Sperrkonzepte genutzt werden können – doch dazu im nächsten Kapitel mehr. In diesem Kapitel werden die Skalierungsmaßnahmen anhand des Projekts "Scale-Me-Up" erläutert. [[@feix_skalierbare_nodate]]

*Um die verschiedenen Maßnahmen zur Verbesserung der Skalierbarkeit besser einordnen zu können, kann man die sog. "Skalierungspyramide" verwenden (s. Abb.2). Die Skalierungspyramide ist eine Darstellung mit vier Ebenen. An der Spitze steht die Ebene 4 mit der Hardware-Optimierung, darunter folgt in Ebene 3 die System- und Produkt-Optimierung. Darunter folgt in Ebene 2 die Code-Optimierung und als unterste Ebene 1 schließlich der Entwurf. Die Auswirkungen auf die Skalierbarkeit nehmen von oben nach unten zu. Dies bedeutet, dass man mit Hardware-Optimierungen (also z. B. der Strategie der vertikalen Skalierung) die geringsten Auswirkungen auf die Skalierbarkeit eines Systems hat und im Entwurf die größten Auswirkungen auf die Skalierbarkeit erreichen kann. [[@feix_skalierbare_nodate]]

[[Skalierbarkeitspyramide.jpg]] [[@feix_skalierbare_nodate]]

Scale-up: 

[[scaleup.png]]  [[@anderson_couchdb_2010]] Seite 6ff

Scale-out:

[[scaleout.png]] [[@anderson_couchdb_2010]] Seite 6ff

### Stichpunkte

Skalierbarkeit: Fähigkeit eines Systems, sich wachsenden oder schrumpfenden Anforderungen im Bezug auf Hard- oder Software anpassen zu können [[@geisler_was_2019]]

System, dass erfolgreich skaliert wurde funktioniert auch noch nach Änderung weiter, um Anforderungen des Betreibers zu erfüllen. Dabei ist alle Vorteile des skalierten Systems nutzbar. [[@geisler_was_2019]]

Skalierung nach oben ist einfacher als nach unten; Downscaling zeigt u.A. ob System auch in kleinerer Umgebung funktionieren kann [[@geisler_was_2019]]

Vertikale Skalierung:

Ressourcen werden logischer Einheit hinzugefügt -> vertikale Skalierung; Z.B. werden weitere CPU, mehr RAM oder Speicher hinzugefügt; Software muss nicht geändert werden, sondern kann Ressourcen gleich benutzen; Limit ist jedoch durch auf dem Markt vorhandene Hardware vorgegeben [[@geisler_was_2019]]

Horizontale Skalierung

Skalierung durch Hinzufügen von weiteren Rechenknoten; Software muss sich parallelisieren lassen; Loadbalancer ist notwendig; Skalierbarkeitsfaktor (Verhältnis von zusätzlicher Leistung zu zusätzlich eingesetzten Ressourcen) ist niedriger; kostengünstiger; weniger Overhead [[@geisler_was_2019]]

Arten von Skalierung:

- Lastskalierbarkeit: System, das bei sehr geringer oder sehr hoher Auslastung eine Verzögerung aufweist -> Systemverhalten konstant [[@rauch_was_2021]]

- räumliche Skalierbarkeit: relevant ist akzeptabler Anstieg des Speicherbedarfs; sollte sublinear sein; erfolgt durch Kompression oder Einsatz einer sparse Matrix; sublinearer Anstieg geht auf Lasten der Lastskalierbarkeit; höhere Kompressionsarten erfordern mehr Rechenleistung u. Zeit [[@rauch_was_2021]]

- Strukturelle Skalierbarkeit: Anzahl der Objekte kann in einem definierten Bereich erhöht werden, ohne das System negativ zu beeinflussen [[@rauch_was_2021]]

- Zeitlich-räumliche Skalierbarkeit: Antwortzeit, wenn Anzahl der Datenobjekte ansteigt [[@feix_skalierbare_2015]]

- Geographische Skalierbarkeit: Geographische Entfernungen haben kaum Einfluss auf das System [[@feix_skalierbare_2015]]

- Administrative Skalierbarkeit: Anzahl der Organisationen beeinflussen Performance des Systems nicht [[@feix_skalierbare_2015]]

Wachstumsarten:
- lineares Wachstum: Die Skalierbarkeit wächst analog zu den zur Verfügung stehenden Ressourcen; zusätzliche Ressourcen erhöhen Leistung um 100 Prozent [[@rauch_was_2021]]

- Sub-lineares Wachstum: Die Skalierbarkeit nimmt mit den Ressourcen ab;  zusätzliche Ressourcen erhöhen Leistung um z.B. 75 Prozent [[@rauch_was_2021]]

- Super-lineares Wachstum: Die Skalierbarkeit steigt mit weiteren Ressourcen an und wird immer größer; zusätzliche Ressourcen erhöhen Leistung um z.B.125 Prozent [[@rauch_was_2021]]

- Negative Skalierbarkeit: Sonderfall; Leistung des Systems steigt nicht mit zusätzlichen Ressourcen [[@rauch_was_2021]]

Vertikale und horizontale Skalierung schließen sich nicht gegenseitig aus, sondern ergänzen sich [[@feix_skalierbare_2015]]

Skalierungspyramide stellt Ebenen der Skalierung dar; größter Einfluss hat Entwurf der Software -> HW entsprechend wenig Einfluss [[@feix_skalierbare_2015]]

Hindernisse für skalierbare Software:
- ausschließlich synchrone Kommunikation [[@feix_skalierbare_2015]] -> Was ist synchrone und asynchrone Kommunikation
- Datenbank arbeitet nicht als Cluster [[@feix_skalierbare_2015]] -> Was sind Cluster?
- Ressourcenkonflikte vermeiden -> Raceconditions [[@feix_skalierbare_2015]]
- Komponenten sind stateful [[@feix_skalierbare_2015]] -> Was bedeutet Stateful und Stateless?

[[Skalierbarkeitspyramide.jpg]] [[@feix_skalierbare_nodate]]

Scale-up: 

[[scaleup.png]]  [[@anderson_couchdb_2010]] Seite 6ff

Scale-out:

[[scaleout.png]] [[@anderson_couchdb_2010]] Seite 6ff

