## Allgemein

Virtualisierung ist in der Informatik ein mehrdeutiger Begriff. [[@noauthor_virtualisierung_nodate]] Es ist eine Technologie, welche virtuelle Ressourcen für Betriebssysteme bereitstellt. [[@noauthor_virtualisierung_nodate]] Physikalische IT-Ressourcen wie z.B. Hardware, Software, Speicher oder Netzwerkkomponenten werden abstrahiert. Durch diese Abstraktion können die Ressourcen flexibel bereitgestellt werden und somit bei Bedarf an verschiedene Abnehmer verteilt werden. Somit können IT-Ressourcen eines Unternehmens besser ausgelastet werden. [[@noauthor_konzepte_2021]] Die Anfänge dieser Technologie liegen im Großrechnerbereich in den 1960er Jahren. Zunächst ermöglichte sie den Mehrbenutzerbetrieb durch ein Timesharing-Verfahren. Hierbei werden Nutzer innerhalb eines Betriebssystems voneinander isoliert und jeder bekommt CPU-Zeit zugeteilt. [[@noauthor_virtualisierung_nodate-1]] Abzugrenzen ist die Virtualisierung von der Emulation bzw. Simulation:
### Simulation

Der Begriff "Simulation" beschreibt die vollständige Nachbildung eines Systems mittels Software. Ziel der Nachbildung ist eine Nachstellung aller Systemkomponenten und deren inneren Logik eines Computers. Angewandt wird diese für beispielsweise um Programme, welche für andere Prozessorarchitekturen entwickelt wurden zu untersuchen oder alte Großrechnersoftware auf modernen Systemen auszuführen. Anders als Systeme, die auf Emulation basieren, sind Simulatoren nicht für den Produktiveinsatz vorgesehen. Beispiele hierfür sind Flugsimulatoren oder der iPhone-Simulator in der XCode Entwicklungsumgebung. [[@noauthor_konzepte_2021]]
### Emulation

Bei der Emulation wird die Hardware bzw. Software des Zielsystems nachgebildet, allerdings ohne innere Logik. Ziel ist hierbei das Erzielen der gleichen Ergebnisse wie das reale System. Anders als die Simulation kann ein emuliertes System das nachgebildete System allerdings komplett ersetzen. Ein Beispiel hierfür ist der Android Simulator im Android Studio. [[@noauthor_konzepte_2021]]

Virtualisierung ähnelt der Simulation und Emulation, hat jedoch einen anderen Zweck. Diese beiden implementieren ein Computermodell, mit welchem Inkompatibilitäten umgangen werden. Somit können Anwendungen auf einem nicht unterstützten Betriebssystem ausgeführt werden. Diese beiden Technologien kommen mit den Nachteilen, dass sie einerseits schwierig zu entwickeln sind und andererseits keine hohe Performance bieten. Virtualisierung minimiert die Abhängigkeit von diesen Technologien, indem eine Abstraktionsschicht bereitgestellt wird. Dadurch können IT-Ressourcen unabhängig von ihrer physikalischen Grundlage bereitgestellt werden. [[@noauthor_konzepte_2021]]

## Hypervisor

Grundlage für die Virtualisierung ist der sogenannte Hypervisor. Dabei handelt es sich um eine Software, welche physikalische Ressourcen von virtuellen Systemen trennt. [[@noauthor_virtualisierung_nodate-1]] Hierdurch können die Ressourcen des Hostsystems zwischen den einzelnen virtuellen Maschinen aufgeteilt werden. Der Hypervisor erstellt virtuelle Maschinen und führt diese aus. [[@noauthor_virtualisierung_nodate]] Weiter stellt er innerhalb der VM Standard-Schnittstellen bereit. Führt ein Betriebssystem innerhalb dieser Umgebung einen Hardwarezugriff aus, so fängt der Hypervisor diesen ab und verarbeitet diesen. Somit verhindert der Hypervisor parallele Zugriffe auf die Hardware des Hostsystems. [[@noauthor_virtualisierung_nodate]] Die nachfolgende Grafik visualisiert die Rolle des Hypervisor:

![How virtualization works](https://www.redhat.com/rhdc/managed-files/how-virtualization-works-400x217.png "So funktioniert die Virtualisierung")
[[@noauthor_virtualisierung_nodate-1]]

Durch die Abstraktion der IT-Ressourcen des Hostsystems durch den Hypervisor können diese der virtuellen Maschine beliebig zugewiesen werden. Weiter können virtuelle Maschinen ohne Komplikationen zwischen verschiedenen Hostsystemen transferiert werden, da es keine feste Bindung an die Hardware des Hostsystems gibt.  [[@noauthor_virtualisierung_nodate-1]]

Ursprünglich waren Hypervisoren reine Softwareanwendungen, wodurch die Performance der einzelnen virtuellen Maschinen stark litt. Mit der Einführung von Virtualisierungserweiterungen innerhalb der x86-Architektur (Intel VT und AMD SVM) konnte die Ausführungsgeschwindigkeit von virtualisierten Workloads massiv erhöht werden. Zusätzlich erlauben diese Erweiterungen die I/O-Virtualisierung wie beispielsweise das Durchreichen von PCIe-Geräten an virtuelle Maschinen. [[@noauthor_virtualisierung_nodate]]

Generell werden zwei Typen von Hypervisoren unterschieden:
- Typ 1
	Ein Typ-1-Hypervisor läuft direkt auf der Hardware anstelle eines Betriebssystems. Damit verwaltet diese alle Systemressourcen selbst und weist diese entsprechend der Vorgaben des Administrators an virtuelle Maschinen. Hierfür muss das Hypervisor-Betriebssystem allerdings alle Hardwaretreiber selbst mitbringen. Beispiele sind hierfür KVM , Xen oder VMware vSphere (ehemals ESXi) [[@noauthor_was_nodate-5]]
	![System-Virtualisierung](https://www.elektronik-kompendium.de/sites/com/bilder/11010113.gif) 
	[[@noauthor_virtualisierung_nodate]]

- Typ 2
	Der Typ-2-Hypervisor läuft nicht direkt auf der Hardware, sondern auf einem bereits installierten Betriebssystem. Dadurch muss der Hypervisor keine eigenen Hardwaretreiber bereitstellen, sondern fordert die benötigte Ressourcen beim Betriebssystem an. Beispiele für diese Art des Hypervisors sind z.B. VMware Workstation oder Oracle VirtualBox.  [[@noauthor_virtualisierung_nodate]]
	![System-Virtualisierung](https://www.elektronik-kompendium.de/sites/com/bilder/11010112.gif)
	[[@noauthor_virtualisierung_nodate]]

Zur Erstellung virtueller Maschinen gibt es zwei Grundsätze: Para- und Vollvirtualisierung. Bei der Paravirtualisierung bietet der Hypervisor eine direkte API für den Zugriff auf die physikalische Hardware des Hosts. Da das Gastbetriebssystem direkt auf die Hardware des Wirtssystems zugreifen kann, kann die Performance der Applikation verbessert werden. Allerdings ist für den Betrieb eines Betriebssystems in einer solchen Umgebung ein angepasster Kernel notwendig, welcher die bereitgestellte API verwenden kann. Ein Beispiel für diese Art der Virtualisierungstechnologie ist Xen. [[@noauthor_konzepte_2021]]
Anders ist es bei der Vollvirtualisierung. Hierbei gibt der Hypervisor der virtuellen Maschine eine komplette Hardwareumgebung vor, welche aus weitverbreiteten Hardwarekomponenten besteht. Somit muss das Gastsystem nicht modifiziert werden. Die eigentliche physikalische Hardware des Hostsystems bleibt verborgen. Beispiele für diese Technologie sind Microsoft Hyper-V und VMware Workstation. [[@noauthor_konzepte_2021]]

## Virtuelle Maschine

Eine virtuelle Maschine ist ein Softwarecontainer, welche eine Laufzeitumgebung für ein Betriebssystem bereitstellt. [[@noauthor_virtualisierung_nodate]] Die folgende Abbildung verdeutlicht diesen Sachverhalt:

![Virtuelle Maschine](https://www.elektronik-kompendium.de/sites/com/bilder/11010114.gif)
[[@noauthor_virtualisierung_nodate]]

Ressourcen werden entsprechend der Benutzervorgabe zugewiesen. [[@noauthor_was_nodate-5]] Die virtuelle Hardware einer Instanz steht dabei nur dieser zur Verfügung, andere virtuelle Maschinen haben keinen Zugriff auf diese. In diesen VMs können Workloads, wie Server, Desktops, Datenbanken o.ä. ausgeführt werden. [[@noauthor_was_nodate-5]] Generell sind virtuelle Maschinen ohne Anpassungen nicht für Workloads wie 3D-Software oder die Wiedergabe von Videos nicht geeignet, da die emulierten Grafikadapter dafür nicht ausgelegt sind. [[@noauthor_virtualisierung_nodate]] 

## Anwendungen

Für Virtualisierungstechnologien gibt es viele Einsatzbereiche. Im Folgenden werden einige Bereiche erläutert:

### Virtualisierung von Betriebssystemen

Hierbei werden mehrere Betriebssysteme auf derselben Hardware ausgeführt. [[@noauthor_virtualisierung_nodate-1]] Damit ist es möglich, mehrere Applikationen in unterschiedlichen Umgebungen zu betreiben. [[@noauthor_virtualisierung_nodate]] Für den Anwender entsteht so der Vorteil, dass er beispielsweise getrennte Umgebungen für Arbeit und dass Surfen im Internet benutzen kann. Somit entsteht ein Sicherheitsvorteil für den Anwender. [[@noauthor_virtualisierung_nodate]] Weiter können diese Umgebungen benutzt werden, um Legacyanwendungen zu betreiben. [[@noauthor_virtualisierung_nodate]] Auch der Absturz von einzelnen Anwendungen wirkt sich nicht auf die Virtualisierungsumgebung aus, da diese jede virtuelle Maschine voneinander isoliert. [[@noauthor_virtualisierung_nodate]]

### Servervirtualisierung

Die Servervirtualisierung basiert auf der Virtualisierung von Betriebssystemen. Hierbei wird diese Technologie genutzt um die verfügbare Serverhardware effektiver ausnutzen zu können. Durch diese effektive Ausnutzung kann physikalische Hardware eingespart werden. Somit entfallen auch weitere Kosten für Strom und Platz im Rechenzentrum. [[@noauthor_was_nodate-6]] Das folgende Beispiel visualisiert diesen Sachverhalt:

Es sei angenommen, dass es in einer Firma drei physikalische Server mit folgenden Funktionen befinden:
- 1 Mailserver
- 1 Webserver
- 1 Server mit einer legacy Anwendung

Jeder dieser Server ist zu 30 Prozent ausgelastet.

![Server usage](https://www.redhat.com/rhdc/managed-files/server-usage-500x131.png "Server-Auslastung") [[@noauthor_virtualisierung_nodate-1]]

Mithilfe von Virtualisierungstechnologien können diese Systeme konsolidiert werden. 

![Server usage: virtualization](https://www.redhat.com/rhdc/managed-files/server-usage-for-virtualization-500x131.png "Server-Auslastung mit Virtualisierung") [[@noauthor_virtualisierung_nodate-1]]

Somit kann einer der Server in diesem Beispiel komplett eingespart werden. [[@noauthor_virtualisierung_nodate-1]]

Virtualisierungsumgebungen bieten noch zusätzliche Vorteile. Neben der effizienteren Ressourcenausnutzung können virtuelle Maschinen automatisiert erstellt und provisioniert werden. [[@noauthor_was_nodate-6]] In Verbindung mit weiteren Technologien wird auch die Daten- bzw. Dienstwiederherstellung im Notfall stark beschleunigt. So kann eine virtuelle Maschine bei Problemen auf dem Hostsystem auf ein Weiteres live migriert werden.  [[@noauthor_was_nodate-6]] 

### Anwendungsvirtualisierung

Im Zuge dieser Art der Virtualisierung werden Anwendungen von Betriebssystem abstrahiert. Sie laufen damit losgelöst von eigentlichem Betriebssystem in einer isolierten Laufzeitumgebung. Hierdurch wird das eigentliche Betriebssystem vor Schadcode geschützt. Weiterhin können alle Anwendungen von einem zentralen Server verteilt und auf verschiedenen Clients bereitgestellt werden. Ein Beispiel für eine solche Technologie ist VMware ThinApp:
- Eine Windows-Installer-Paketdatei (MSI) wird in eine eigenständige EXE-Datei konvertiert.
- In dieser EXE-Datei sind alle notwendigen Bibliotheken und Abhängigkeiten enthalten.
- Diese EXE-Datei kann somit in allen Windows-Umgebungen ausgerollt werden.
[[@noauthor_konzepte_2021]]

### Netzwerkvirtualisierung

Bei der Netzwerkvirtualisierung werden Netzwerkressourcen auf Hard- bzw. Softwareebene abstrahiert. Dabei werden logische Funktionen bzw. Topologien auf der physikalischen Ebene erzeugt. Beispiele für diese Art der Virtualisierung sind VLAN (Virtual Local Area Network) und VPN (Virtual Private Network). [[@noauthor_konzepte_2021]]

### Datenvirtualisierung

Hierbei handelt es sich um einen Sammelbegriff für verschiedene Virtualisierungsansätze für Data-Warehouse-Analysen. Dabei soll der Datenzugriff für Anwendungen abstrahiert werden. Für den Zugriff werden Daten aus unterschiedlichen Quellen extrahiert und in einer Zieldatenbank in einer einheitlichen Form zusammengeführt. Hier durch kann der benötigte Speicherbedarf für die Analyse großer Datenmengen verringert werden. [[@noauthor_konzepte_2021]]
### Speichervirtualisierung

Diese Virtualisierungstechnologie fasst verschiedene Speichermedien (z.B. Flashspeicher, magnetische Speicher) in einem zusammenhängenden Speicherpool zusammen. Diese logischen Laufwerke sind nicht nur auf einzelne physikalische Datenträger begrenzt, sondern können sich über eine beliebige Anzahl spannen. Somit kann einerseits die verfügbare Hardware besser ausgenutzt werden, andererseits bietet diese Technologie deutlich mehr Flexibilität.  [[@noauthor_konzepte_2021]]
### Desktopvirtualisierung

Desktopvirtualisierung beschreibt die zentralisierte Bereitstellung von Desktop-Umgebungen über ein Netzwerk. Hierdurch wird der Wartungs- und Verwaltungsaufwand der Unternehmensinfrastruktur verringert. [[@noauthor_virtualisierung_nodate-1]] Führende Anbieter in diesem Bereich sind Microsoft, VMware und Citrix [[@noauthor_konzepte_2021]]
## Containervirtualisierung

Moderne Betriebssysteme trennen zwischen User- und Kernel-Space. Im Kernel-Space werden Treiber, der Betriebssystemkernel selbst und andere Kernkomponenten eines Betriebssystems ausgeführt. Anwendungen und Dienste des Nutzers laufen hingegen im User-Space. [[@noauthor_konzepte_2021]] Containertechnologien bauen auf diesem System und der chroot-Fähigkeit unixoider Betriebssysteme auf. Hierbei handelt es sich um einen Systemcall, der das Root-Verzeichnis eines laufenden Prozesses ändert. Bei korrekter Implementierung kann das Programm lediglich auf Dateien innerhalb des Verzeichnisses zugreifen. Die Chroot-Kapselung allein ist jedoch nicht ausreichend, da diese nie als Konzept zur Absicherung von Prozessen vorgesehen wurde. Deshalb verwenden Containertechnologien zusätzlich noch Kerneltechnologien wie Cgroups und Namespaces, um die erstellen Laufzeitumgebungen weiter zu beschränken. [[@noauthor_konzepte_2021]] 

Container sind eine Laufzeitumgebung, die eine Anwendung mit samt derer Abhängigkeiten paketiert. [[@noauthor_container_nodate]] Diese Abhängigkeiten sind auf das absolute Minimum reduziert. Aus diesem Grund sind Container meist nur wenige Megabyte groß. [[@noauthor_container_nodate]] Im Gegensatz zu virtuellen Maschinen können Container innerhalb von Sekunden bereitgestellt werden, da sie kein eigenes Betriebssystem und Kernel enthalten. [[@noauthor_container_nodate]] Hierdurch bilden sie die Grundlage für Microservices. [[@noauthor_container_nodate]]
### Kubernetes

Kubernetes ist eine von Google entwickelte Orchestrierungstechnologie entwickelt. Der Vorläufer "Borg" wurde Anfang der 2000 entwickelt, um tausende Funktionen und Jobs auf internen Clustern auszuführen. [[kubernetes101 Page 1]] Heute gibt es viele verschiedene Kubernetesdistributionen, wie z.B. k3s, das eine leichtgewichtige Alternative zur Standarddistribution ist. [[kubernetes101 Page 5]]

Ein Kubernetescluster besteht in erster Linie aus zwei Komponenten:
- Master
- Nodes

Ein Masterserver besteht wiederum aus mehreren Komponenten. 
- API-Server:
  Der API-Server ist die zentrale Anlaufstelle für Kommandos des Administrators. Dieser erlaubt dem Admin die Konfiguration der einzelnen Clusterobjekte und überwacht die Konsistenz zwischen dem Ist- und Soll-Zustand. [[@dr_andreas_hess_was_2021]]
- Service Controller Manager:
   Änderungsvorgaben des Administrator werden in die Clusterdatenbank (etcd) geschrieben. Der Service Controller Manager verarbeitet die in dieser Datenbank vorgegebenen Änderungen und führt den gewünschten Zustand des Clusters herbei. [[@dr_andreas_hess_was_2021]]
- Scheduler
   Der Scheduler organisiert die Lastverteilung auf den einzelnen Nodes und startet bzw. stoppt Pods. [[@dr_andreas_hess_was_2021]]

Auf Nodeserver laufen lediglich die Container-Runtime und eine Agent-Applikation. Diese kommuniziert mit dem Master und stellt Dienste für Monitoring, Logging und Service Discovery bereit. [[@dr_andreas_hess_was_2021]]