~~#### Was ist Virtualisierung?

~~Der Begriff Virtualisierung ist mehrdeutig. In der Regel verwendet man den Begriff Virtualisierung in der Computertechnik. Typischerweise versteht man unter Virtualisierung die Prozessor-Virtualisierung. Neben der Prozessor-Virtualisierung gibt es auch noch andere Möglichkeiten. Dazu zählt zum Beispiel das Partitionieren von Festplatten oder die Netzwerk-Virtualisierung durch VLAN. [[@noauthor_virtualisierung_nodate]]

![Virtualisierung](https://www.elektronik-kompendium.de/sites/com/bilder/11010115.gif)

~~Virtualisierung ist eine Hardware-Unterstützung, die den Betrieb virtueller Computer auf einem echten Computer erleichtert oder beschleunigt. Mit der Virtualisierung kann man mehrere Software-Systeme auf einer Hardware laufen lassen. Das können zum Beispiel unterschiedliche Betriebssysteme sein. Virtualisierung macht dann Sinn, wenn ein Hardware-System nicht ausgelastet ist und die Ressourcen parallel für weitere Systeme genutzt werden sollen. [[@noauthor_virtualisierung_nodate]]

~~Da eine steigende Taktfrequenz bei Prozessoren so einfach nicht möglich ist, sind die Prozessorhersteller, insbesondere Intel und AMD, auf alternative leistungssteigernde Techniken für Prozessoren angewiesen. Neben Mehrkern-Prozessoren, Multimedia-Erweiterungen und 64-Bit gelten Virtualisierungs-Funktionen als die bahnbrechende Entwicklung. [[@noauthor_virtualisierung_nodate]]


~~### Gründe für Virtualisierung

~~- Erhöhung der Ausfallsicherheit
~ - bessere Auslastung der IT-Systeme durch Konsolidierung der Hardware
~- niedrigere IT-Kosten
~- geringerer Stromverbrauch [[@noauthor_virtualisierung_nodate]]

~~Wichtigstes Merkmal der Virtualisierung ist die Ausfallsicherheit. Wenn eine Applikation sich selbst oder sogar das gesamte Betriebssystem zum Absturz bringt, laufen die anderen virtuellen Maschinen weiter.  
Der Betrieb unterschiedlicher Applikationen in mehreren Umgebungen ist die häufigste Anwendung. Zum Beispiel um Applikationen aus Sicherheitsgründen und wegen des Datenschutzes getrennt zu halten. Um aber nicht für jede Applikation eine eigene Hardware bereitstellen zu müssen, werden virtuelle Maschinen geschaffen, auf denen dann die Applikationen getrennt voneinander arbeiten können.  
Auf den ersten Blick scheint Virtualisierung nur etwas für Server zu sein. Doch auch normale Anwender können davon profitieren. Zum Beispiel zwei Umgebungen für das Arbeiten mit dem Computer. Die eine ganz normal und die andere bei Verbindung mit dem Internet. Hat sich das Internet-System Würmer oder Viren eingefangen, wird sie gelöscht und neu aufgesetzt. So etwas lässt sich zum Beispiel bei jedem Systemstart automatisieren. So hat man immer ein sauberes System. Das könnte auch soweit gehen, dass unsichere Programme in einer eigenen Umgebung laufen, damit das Betriebssystem von außen nicht angreifbar ist. [[@noauthor_virtualisierung_nodate]]

### Was ist eine virtuelle Maschine

![Virtuelle Maschine](https://www.elektronik-kompendium.de/sites/com/bilder/11010114.gif)

~~Eine virtuelle Maschine ist ein Software-Container, der einem darin installierten Betriebssystem eine Scheinwelt vorgaukelt, in dem gängige Hardware-Komponenten emuliert werden. Üblicherweise verfügen Betriebssystem über Standard-Treiber mit denen sie die emulierte Hardware ansprechen können.  

~~Virtuelle Maschinen verfügen nur über eine eingeschränkte Grafikleistung. 3D-Software und die Wiedergabe und Bearbeitung von Videos ist in einer virtuellen Maschine nicht ausreichend schnell machbar.  

~~Mit virtuell ist die Hardware gemeint, die dem Betriebssystem in der virtuellen Maschine zur Verfügung steht. Denn CPU, Arbeitsspeicher, Grafikkarte, Laufwerke und Schnittstellen stehen den parallel arbeitenden Betriebssystemen nicht direkt zur Verfügung. Eine im Hintergrund laufende Virtualisierungssoftware überwacht die Zugriffe auf die Hardware. Sie organisiert und verwaltet die virtuellen Maschinen (VM).  
Diese Aufgabe kann zum Beispiel ein Hypervisor übernehmen. Er benötigt einen kleinen Teil der Hardware-Leistung, insbesondere von Prozessor und Arbeitsspeicher, um seine Arbeit erledigen zu können. [[@noauthor_virtualisierung_nodate]]



### ~~System-Virtualisierung mit Hypervisor

~~Bei der System-Virtualisierung wird ein oder mehrere vollständige Systeme nachgebildet, auf dem beliebige Betriebssysteme ausführbar sind. Die Systeme orientieren sich an echter Hardware. So kann man verschiedene virtuelle Systeme nachbilden und mit unterschiedlicher Hardware ausstatten.  
Beispiele sind VMWare Workstation, Virtual PC, Virtual Server und Parallels. [[@noauthor_virtualisierung_nodate]]

### ~~Hypervisor / Virtual Machine Monitor (VMM)

~~Der Hypervisor wird auch als Virtual Machine Monitor (VMM) bezeichnet. Er erstellt und verwaltet virtuelle Hardware. In der Regel stellt ein Hypervisor innerhalb der virtuellen Maschinen Standard-Schnittstellen zur Verfügung. Gleichzeitig stellt er eine Abstraktionsschicht zur Verfügung, die den Zugriff der Treiber auf die Hardware verhindert. Damit ist sichergestellt, dass sich verschiedene Betriebssysteme nicht gegenseitig in die Quere kommen. [[@noauthor_virtualisierung_nodate]]

|![System-Virtualisierung](https://www.elektronik-kompendium.de/sites/com/bilder/11010113.gif)|![System-Virtualisierung](https://www.elektronik-kompendium.de/sites/com/bilder/11010112.gif)|
|---|---|
|Hypervisor Typ 1|Hypervisor Typ 2|

~~Man unterscheidet zwischen zwei Arten. Typ 1 und Typ 2. Ein Typ-1-Hypervisor läuft als Betriebssystem direkt auf der Hardware (native). Das Gesamtsystem verbraucht so wenig Ressourcen. Aber der Hypervisor muss alle Treiber für die gesamte Hardware mitbringen.  
Ein Typ-2-Hypervisor setzt auf einem vollwertigen Betriebssystem auf (hosted) und nutzt alle Ressourcen, die ihm in dieser Umgebung zur Verfügung stehen. [[@noauthor_virtualisierung_nodate]]

~~Der Hypervisor kann also ein vollwertiges Betriebssystem sein (Typ 1). Er ist dann ein Betriebssystem für ein Betriebssystem. Es bildet eine Virtualisierungsschicht, die es ermöglicht, mehrere Betriebssysteme gleichzeitig auf einem Computersystem zu betreiben. Der Hypervisor vermittelt den Betriebssystemen den Eindruck sie würden alleine auf dem System laufen und hätten die Hardware für sich alleine. Der Hypervisor stellt gleichzeitig sicher, dass ein Betriebssystem nicht die Daten eines andere Betriebssystems zerstört oder auch nur darauf Zugriff hat. Er verhindert, dass die Betriebssysteme miteinander in Konflikt geraten. Die Sicherheitsanforderungen an den Hypervisor sind entsprechend hoch. [[@noauthor_virtualisierung_nodate]]

### ~~System-Virtualisierung mit Hypervisor (Typ 1)

- ~~Hyper-V (Microsoft)
- ~~vSphere Hypervisor, ehemals ESX/ESXi (VMware)
- ~~XenServer (Citrix)
- ~~PowerVM (IBM)
- ~~LPAR und PR/SM (IBM)
- ~~Proxmox VE (Proxmox)
- ~~KVM - Kernel-based Virtual Machine (Open Source)
- ~~QEMU - Quick Emulator (Freie Software) [[@noauthor_virtualisierung_nodate]]

### ~~System-Virtualisierung mit Hypervisor (Typ 2)

- ~~VMware Workstation/Player (VMware)
- ~~Windows Virtual PC (Microsoft)  
- ~~VirtualBox (Oracle)
- ~~Parallels Workstation[[@noauthor_virtualisierung_nodate]]

### Hardware-Unterstützung

~~Ursprünglich war Virtualisierung reine Software-Sache. Doch für manche Funktionen braucht die Virtualisierungssoftware Hardware-Unterstützung. 64-Bit und Mehrkern-Prozessoren unterstützen die Virtualisierung. Erst mit einem großen Adressraum und viel Rechenleistung macht Virtualisierung Sinn. Mehrere parallel laufende virtuelle Computer sind darauf angewiesen. Sonst leidet der Bedienkomfort unter der schleichenden Ausführungsgeschwindigkeit der Anwendungen.

~~Bei der Hardware-Unterstützung geht es weniger um die Geschwindigkeitssteigerung, sondern um Zusatzfunktionen. Das sind bestimmte Funktionen im Prozessor und im Chipsatz. Befehlserweiterungen in Prozessoren gibt es von AMD mit Secure Virtual Machine (SVM) und von Intel mit VT-x und VT-d. Ob AMD-SVM oder Intel VT, mit der Virtualisierungsunterstützung des Prozessors kann der Hypervisor die Virtualisierung deutlich schneller ausführen.  
AMD-SVM und Intel VT reichen für die Hardware-Virtualisierung nicht aus. Zusätzlich nötig ist auch Second-Level Address Translation (SLAT). Das ist ein Adressverwaltungsbeschleuniger, der in der CPU angesiedelt ist und sich in einer höheren Geschwindigkeit bemerkbar macht. Bei AMD heißt das Nested Page Tables (NPT) oder Rapid Virtualization Indexing (RVI). Bei Intel heißt es Extended Page Tables (EPT).

~~Im Regelfall ist Virtualisierung ein Aufgabenbereich des Prozessors. Doch auch bei der I/O-Virtualisierung ist die Unterstützung von CPU, BIOS und Chipsatz nötig. Dann kann man eine bestimmte PCIe-Komponente direkt an eine virtuelle Maschine durchreichen, sodass sich darin ein Treiber für dieses Gerät installieren lässt. Das ist vor allem bei Grafikkarten interessant. [[@noauthor_virtualisierung_nodate]]

### ~~Intel Virtualization Technology (VT)

~~Die Virtualization Technology ist die Virtualisierungsunterstützung von Intel, die seit November 2005 in Intel-Prozessoren eingebaut ist. [[@noauthor_virtualisierung_nodate]]

### ~~AMD Secure Virtual Machine (SVM)

~~Die Virtualisierungsunterstützung von AMD heißt Secure Virtual Machine (SVM), und ist seit 2006 in den AMD-Prozessoren eingebaut. [[@noauthor_virtualisierung_nodate]]

### ~~Was bringen VT (Intel) und SVM (AMD)?

_~~Hinweis: Die folgende Beschreibung ist stark vereinfacht und allgemein gehalten._

~~Ein Prozessor ist normalerweise darauf ausgelegt nur ein Betriebssystem auszuführen. Wenn ein Computersystem nun neben einem Host- auch ein Gast-Betriebssystem (virtuelle Maschine) beherbergt, dann ist es ohne Änderungen am Original-Code nicht möglich, bei der Befehlsausführung zwischen Host und Gast zu unterscheiden. Wenn bestimmte Instruktionen auf die gleiche Ressource zugreifen, dann kann es zu Abstürzen und Datenverlust kommen. Schon einfache Instruktionen, wie das Sichern und Schreiben von Statusregistern im Prozessor, können zu Problemen führen.  
Um Probleme auszuschließen muss der Code vor der Ausführung auf problematische Instruktionen durchsucht und diese gegebenenfalls ersetzt werden. Für die Überprüfung ist der Hypervisor zuständig. Weil jede einzelne Instruktion überprüft werden muss, geht dabei die Performance des gesamten Systems etwas in die Knie. Im Prinzip muss der Hypervisor den virtuellen Maschinen vorgaukeln, dass sie den Prozessor für sich alleine haben. [[@noauthor_virtualisierung_nodate]]

~~Viel besser ist die Virtualisierungsunterstützung durch den Prozessor. Dadurch wird die Virtualisierung etwas schneller (Geschwindigkeitsvorteil). Das hilft vor allem "einfachen" Virtualisierungslösungen. Viel wichtiger ist, dass unter einem 32-Bit-Betriebssystem auch ein 64-Bit-Gastsysteme ausgeführt werden kann, wenn der Prozessor Virtualisierung unterstützt. Denn mit speziellen Virtualisierungsinstruktionen lassen sich die virtuellen Maschinen in eine Umgebung verschieben, wo das Durchsuchen auf problematische Instruktionen nicht mehr nötig ist.  
Wenn die Virtualisierungsunterstützung trotzdem nicht sehr viel zur Geschwindigkeitssteigerung führt, dann liegt das daran, weil die meisten Instruktionen immer noch vom Hypervisor abgefangen werden müssen. Das bedeutet, dass die Virtualisierungsunterstützung des Prozessors nicht besonders umfangreich ist. Der Prozessor kann nicht alle Instruktionen selber abhandeln.  
Ob Instruktionen von der Hypervisor oder vom Prozessor behandelt werden, hängt vom Umfang der Virtualisierungsunterstützung des Prozessors ab. Die Behandlung durch den Prozessor ist auf alle Fälle schneller. Aber prinzipiell ist immer ein Hypervisor nötig, der sich um die Organisation und die aufwendigeren Instruktionen kümmert. [[@noauthor_virtualisierung_nodate]]

### ~~Anwendungen

~~Virtuelle Computer sind eher selten im Einsatz. Es werden aber schon konkrete Anwendungen diskutiert. Einiges davon ist jetzt schon möglich. Mit einem neuen Software-Zweig ist zu rechnen.

- ~~Software-Entwickler nutzen virtuelle Computer, um ihre Produkte unter verschiedenen Betriebssystemen zu testen.
- ~~Auf Arbeitsplatz-Rechnern könnte man verschiedene Arbeitsumgebungen schaffen. Eine normale Arbeitsoberfläche, eine Oberfläche für den Internet-Zugang und eine für spezielle Hardware-Ressourcen. So lassen sich die verschiedenen Oberflächen gegen Hardware- und Software-Fehler, Viren und Würmern schützen.
- ~~Bestimmte Anwendungen für ältere Betriebssysteme können in einem virtuellen Computer ausgeführt werden. Parallel dazu kann ein aktuelles Betriebssystem mit vollem Leistungsumfang arbeiten.
- ~~Wenn zwei Applikationen sich nicht vertragen, kann man sie unter eigenen virtuellen Umgebungen installieren und ausführen. [[@noauthor_virtualisierung_nodate]]

### ~~Virtualisierung in der Server-Umgebung

- ~~bessere Systemauslastung erreichbar
- ~~leichter managebar
- ~~Energiekosten senken -> Umweltrichtlinien einhalten
- ~~höhere Sicherheit und Stabilität
- ~~schneller Anforderungen umsetzen [[@noauthor_virtualisierung_nodate]]

### ~~Virtualisierung in der Desktop-Umgebung

- ~~höhere Sicherheit und Stabilität
- ~~Abwärtskompatibilität [[@noauthor_virtualisierung_nodate]]

### ~~Virtualisierung im großen Maßstab

~~Ab 20 virtuellen Maschinen auf einem Rechner, tritt die Überwachung, das Update-Management und die Leistungsmessung in den Vordergrund. Es stellt sich unter anderem auch die Frage, wie man ein Update-Patch auf allen virtuellen Maschinen einspielt, ohne das jede einzelne virtuelle Maschine gestoppt und gestartet werden muss.  
Ein Verteilungs- und Kontrollmechanismus muss in der Lage sein, die virtuellen Maschinen automatisch auf eine andere Hardware zu verteilen.[[@noauthor_virtualisierung_nodate]]

--- 

## Überblick

~~Virtualisierung ist die Technologie, mit der Sie nützliche IT-Services mithilfe von Ressourcen erstellen können, die traditionell an eine bestimmte Hardware gebunden sind. So sind Sie in der Lage, die vollständige Kapazität einer einzelnen physischen Maschine durch Verteilung ihrer Funktionen auf viele Nutzer oder Umgebungen auszuschöpfen. [[@noauthor_virtualisierung_nodate-1]]

~~_In der Praxis_ können Sie sich das als drei physische Server mit individuellen Aufgaben vorstellen. Einer ist ein Mailserver, der andere ein Webserver und der dritte führt interne Legacy-Anwendungen aus. Jeder dieser Server wird nur bis zu 30 %, also einem Bruchteil seiner Kapazität genutzt. Da die Legacy-Anwendungen allerdings wichtig für Ihre internen Abläufe sind, müssen Sie diese Systeme sowie den Hostserver behalten, oder? [[@noauthor_virtualisierung_nodate-1]]

![Server usage](https://www.redhat.com/rhdc/managed-files/server-usage-500x131.png "Server-Auslastung")

~~Früher ja. Da war es oft viel einfacher und zuverlässiger, Aufgaben auf getrennten Servern auszuführen: 1 Server, 1 Betriebssystem, 1 Aufgabe. Ein Server mit mehr als einem Gehirn war nur schwer vorstell- und durchführbar. Durch die Virtualisierung aber können Sie den Mailserver in zwei Maschinen mit unabhängigen Aufgaben aufteilen und die Legacy-Anwendungen so migrieren. Die Hardware bleibt die gleiche, allerdings wird ihre Effizienz um ein Vielfaches gesteigert. [[@noauthor_virtualisierung_nodate-1]]
 
![Server usage: virtualization](https://www.redhat.com/rhdc/managed-files/server-usage-for-virtualization-500x131.png "Server-Auslastung mit Virtualisierung")

~~Vor dem Hintergrund des Sicherheitsaspekts könnte man den ersten Server zur Ausführung einer weiteren Aufgabe erneut teilen und damit seine Auslastung von 30 über 60 bis auf 90 % steigern. Die dadurch „leer“ gewordenen Server könnten dann für andere Aufgaben verwendet oder komplett außer Betrieb gesetzt werden, um Kühl- und Wartungskosten einzusparen. [[@noauthor_virtualisierung_nodate-1]]

## ~~Eine kurze Geschichte der Virtualisierung

~~Die Anfänge der Virtualisierung lassen sich [bis in die 1960er Jahre](https://www.youtube.com/watch?v=u6mu5B-YZU8) zurückverfolgen, allerdings wurde die Technologie erst in den frühen 2000ern übernommen. Die Technologien zur Umsetzung der Virtualisierung, wie [Hypervisoren](https://en.wikipedia.org/wiki/Hypervisor), wurden bereits vor Jahrzehnten entwickelt, um mehreren Nutzern gleichzeitig Zugriff auf Computer zur Batch-Verarbeitung zu gewähren. Die Batch-Verarbeitung war damals vor allem in den Geschäftssektoren sehr beliebt, in denen Routineaufgaben tausendfach und extrem schnell durchgeführt werden mussten (wie die Lohnabrechnung). [[@noauthor_virtualisierung_nodate-1]]

~~Im Laufe der folgenden Jahrzehnte aber wurde die Virtualisierung von anderen Lösungen für das Problem „Viele Nutzer/Eine Maschine" üb
erholt. Eine dieser Lösungen war das Timesharing, bei dem Nutzer innerhalb von Betriebssystemen isoliert wurden. Dies wiederum führte fast unbeabsichtigt zu Systemen wie [UNIX](http://www.unix.org/what_is_unix.html), auf das dann später [Linux](https://www.redhat.com/de/topics/linux)® folgte. Während dieser ganzen Zeit führte die Virtualisierung zumeist ein Schattendasein. [[@noauthor_virtualisierung_nodate-1]]

~~Springen wir nun zu den 1990ern. Die meisten Unternehmen verfügten damals über physische Server und IT-Stacks von einzelnen Anbietern, die die Ausführung von Legacy-Apps auf der Hardware eines anderen Anbieters unmöglich machten. Später aktualisierte man dann seine IT-Umgebungen mit kostengünstigeren Commodity-Servern, Betriebssystemen und Anwendungen von einer Vielfalt an Anbietern und machte sich so von ineffizient genutzter Hardware abhängig. So konnte mit jedem Server lediglich eine anbieterspezifische Aufgabe ausgeführt werden. [[@noauthor_virtualisierung_nodate-1]]

~~Und genau da kam die Virtualisierung wieder ins Spiel. Sie präsentierte eine natürliche Lösung für zwei Probleme: Mit ihr konnte man seine Server partitionieren _und_ Legacy-Apps auf mehreren Betriebssystemen und -versionen ausführen. Ganz nebenbei wurden die Server effizienter genutzt (oder gar nicht), was die Kosten in Zusammenhang mit Anschaffung, Einrichtung, Kühlung und Wartung senkte. [[@noauthor_virtualisierung_nodate-1]]

~~Die vielen Einsatzmöglichkeiten der Virtualisierung reduzierten die Anbierterabhängigkeit und bildeten die Grundlage für das [Cloud Computing](https://www.redhat.com/de/topics/cloud). Mittlerweile ist diese Technologie bei Unternehmen so weit verbreitet, dass man nicht selten eine spezielle [Virtualisierungsverwaltungssoftware](https://www.redhat.com/de/topics/virtualization/what-is-virtualization-management) benötigt, um mit der Entwicklung Schritt halten zu können. [[@noauthor_virtualisierung_nodate-1]]

## ~~Wie funktioniert Virtualisierung?

~~Eine Software namens [Hypervisor](https://www.redhat.com/de/topics/virtualization/what-is-a-hypervisor) trennt die physischen Ressourcen von den virtuellen Umgebungen, also den Systemen, die die Ressourcen benötigen. Hypervisoren können auf beliebigen Betriebssystemen aufsitzen (wie auf einem Laptop) oder direkt auf der Hardware (wie ein Server) installiert werden, was das von Unternehmen am häufigsten verwendete Modell ist. Mit Hypervisoren können Sie Ihre physischen Ressourcen zur spezifischen Verwendung durch Ihre virtuellen Umgebungen aufteilen. [[@noauthor_virtualisierung_nodate-1]]

![How virtualization works](https://www.redhat.com/rhdc/managed-files/how-virtualization-works-400x217.png "So funktioniert die Virtualisierung")

~~Ressourcen werden je nach Bedarf von Ihrer physischen Umgebung an die verschiedenen virtuellen Umgebungen partitioniert. Die Nutzer interagieren mit ihrer speziellen virtuellen Umgebung (normalerweise als Guest oder [virtuelle Maschine](https://www.redhat.com/de/topics/virtualization/what-is-a-virtual-machine) bezeichnet) und führen dort ihre Berechnungen durch. Die virtuelle Maschine funktioniert wie eine einzelne Datendatei. Und wie diese Dateien auch lassen sie sich von einem PC zum anderen verschieben und dort öffnen bzw. bieten die exakt gleiche Funktion. [[@noauthor_virtualisierung_nodate-1]]

~~Wenn die virtuelle Umgebung ausgeführt wird und ein Nutzer/Programm eine Anweisung ausgibt, die zusätzliche Ressourcen von der physischen Umgebung erfordert, gibt der Hypervisor diese Anfrage an ein physisches System weiter und speichert die Änderungen. Das alles läuft praktisch mit nativer Geschwindigkeit ab (insbesondere, wenn die Anfrage über einen Open Source-Hypervisor gesendet wird, der auf KVM basiert, der [Kernel-based Virtual Machine](https://www.redhat.com/de/topics/virtualization/what-is-KVM). [[@noauthor_virtualisierung_nodate-1]]

## ~~Arten der Virtualisierung

### ~~Datenvirtualisierung

![data virtualization](https://www.redhat.com/rhdc/managed-files/data%20virtualization.png "Daten-Virtualisierung")

~~An vielen Orten verteilte Daten können in einer einzigen Quelle konsolidiert werden. Durch die Virtualisierung von Daten können Unternehmen Daten als dynamische Quelle behandeln. Damit profitieren sie von Verarbeitungsfunktionen, mit denen sie Daten aus mehreren Quellen zusammenführen, neue Datenquellen einfach integrieren und die Daten entsprechend der Nutzeranforderungen umwandeln können. Datenvirtualisierungstools sind mehreren Datenquellen vorgelagert, damit diese als eine Quelle behandelt werden können. So können die benötigen Daten für beliebige Anwendungen oder Nutzer im geforderten Format und zum richtigen Zeitpunkt bereitgestellt werden. [[@noauthor_virtualisierung_nodate-1]]

### Desktop-Virtualisierung

![desktop virtualization](https://www.redhat.com/rhdc/managed-files/desktop%20virtualization_0.png "Desktop-Virtualisierung")

~~Die Virtualisierung von Desktops wird oft mit der Virtualisierung von Betriebssystemen verwechselt, die die Ausführung mehrerer Betriebssysteme auf einem Rechner ermöglicht. Mit der Virtualisierung von Desktops allerdings kann ein zentraler Administrator (oder ein automatisiertes Administrationstool) simulierte Desktopumgebungen in Hunderten von physischen Rechnern gleichzeitig simulieren. Im Gegensatz zu traditionellen Desktopumgebungen, die physisch installiert, konfiguriert und für jeden Rechner aktualisiert werden müssen, ermöglicht die Virtualisierung von Desktops dem Administrator die Ausführung von Massenkonfigurationen, Updates und Sicherheitsprüfungen auf allen virtuellen Desktops. [[@noauthor_virtualisierung_nodate-1]]

### ~~Servervirtualisierung

![Server virtualization](https://www.redhat.com/rhdc/managed-files/server-virtualization-layout-530x287_0.png "Server-Virtualisierung")

~~Server sind Computer, die speziell auf die Verarbeitung eines großen Volumens an spezifischen Aufgaben ausgelegt sind, damit andere Rechner wie Laptops und Desktops für diverse andere Maßnahmen frei bleiben. Durch die Virtualisierung eines Servers lassen sich noch mehr dieser spezifischen Funktionen sowie Partitionierungen ausführen, damit diese Komponenten für mehrere Funktionen verwendet werden können. [[@noauthor_virtualisierung_nodate-1]]

### ~~Virtualisierung von Betriebssystemen

![Operating system virtualization](https://www.redhat.com/rhdc/managed-files/operating-system-virtualization-400x321.png "Betriebssystem-Virtualisierung")

~~Die Virtualisierung von Betriebssystemen erfolgt auf [Kernel](https://www.linux.com/blog/what-linux-kernel)ebene, also beim zentralen Task Manager des Betriebssystems. Auf diese Weise können Linux- und Windows-Umgebungen sehr effizient parallel ausgeführt werden. Dazu können Unternehmen virtuelle Betriebssysteme auf Rechnern installieren, was folgende Vorteile bietet:

- ~~Senkung der gesamten Hardware-Kosten, da die Rechner keine anspruchsvollen Out-of-the-Box-Funktionen aufweisen müssen
- ~~Verbesserung der Sicherheit, da alle virtuellen Instanzen überwacht und isoliert werden können
- ~~Reduzierung des Zeitaufwands für IT-Services wie Softwareaktualisierungen
~~[[@noauthor_virtualisierung_nodate-1]]

### ~~Network Functions Virtualization

![Network function virtualization](https://www.redhat.com/rhdc/managed-files/network-function-virtualization-400x337_0.png "Network Function Virtualization")

~~Die Network Functions Virtualization (NFV) gewährleistet die Trennung der wichtigsten Netzwerkfunktionen (wie Verzeichnisdienste, gemeinsame Dateinutzung und IP-Konfiguration) zwecks Verteilung über mehrere Umgebungen. Sobald die Softwarefunktionen von den physischen Rechnern „losgelöst" sind, auf denen sie installiert waren, können spezifische Funktionen in einem neuen Netzwerk gepackt und einer speziellen Umgebung zugewiesen werden. Durch die Virtualisierung von Netzwerken lässt sich die Zahl der physischen Komponenten wie Switches, Router, Server, Kabel und Hubs reduzieren, die zur Erstellung von mehreren unabhängigen Netzwerken benötigt werden und besonders in der Telekommunikationsbranche beliebt sind.
[[@noauthor_virtualisierung_nodate-1]]

---

## Was ist eine Virtuelle Maschine (VM)?

~~Eine virtuelle Maschine (VM) ist eine Anwendungsumgebung, die als virtuelles Betriebssystem mit CPU, Speicher, Netzwerkschnittstelle und Storage agiert und auf einem physischen Hardwaresystem (On- oder Off-Premise) erstellt wurde. Eine Software namens [Hypervisor](https://www.redhat.com/de/topics/virtualization/what-is-a-hypervisor) trennt die Rechnerressourcen von der Hardware und provisioniert sie so, dass sie von der VM genutzt werden können.  [[@noauthor_was_nodate-5]]

~~VMs enthalten normalerweise ihr eigenes Betriebssystem, auf dem sie mehrere ressourcenintensive Funktionen auf einmal ausführen können. Dank der zahlreichen, ihnen zur Verfügung stehenden Ressourcen können VMs ganze Server, Betriebssysteme, Desktops, Datenbanken und Netzwerke abstrahieren, aufteilen, duplizieren und emulieren. [[@noauthor_was_nodate-5]]

~~Die physischen Maschinen, die mit einem Hypervisor wie [KVM (Kernel-based Virtual Machine)](https://www.redhat.com/de/topics/virtualization/what-is-KVM) ausgestattet sind, werden als Host-Maschine, Host-Computer, Host-Betriebssystem oder einfach als _Host_ bezeichnet. Die vielen VMs, die ihre Ressourcen verwenden, werden als Guest-Maschinen, Guest-Computer, Guest-Betriebssysteme oder einfach als _Guests_ bezeichnet. Der Hypervisor behandelt die Computing-Ressourcen (wie CPU, RAM und Storage) als einen Pool von Ressourcen, die problemlos auf Guests oder neue VMs verteilt werden können. [[@noauthor_was_nodate-5]]

~~Mit VMs können Sie mehrere verschiedene Betriebssysteme gleichzeitig auf einem einzelnen Computer ausführen – wie eine [Linux-Distribution](https://www.redhat.com/de/topics/linux/whats-the-best-linux-distro-for-you) auf einem MacOS-Laptop. Die Betriebssysteme werden genauso ausgeführt wie Betriebssysteme oder Apps auf der Host-Hardware. Daher ist die in der VM emulierte Endbenutzererfahrung nahezu identisch mit einer Echtzeit-Betriebssystemerfahrung, die auf einer physischen Maschine ausgeführt wird.   [[@noauthor_was_nodate-5]]

## ~~Wie funktionieren Virtuelle Maschinen?

~~Mithilfe von [Virtualisierungstechnologien](https://www.redhat.com/de/topics/virtualization) können Sie ein System mit vielen virtuellen Umgebungen teilen. Der Hypervisor verwaltet die Hardware und trennt die physischen Ressourcen von den virtuellen Umgebungen. Ressourcen werden je nach Bedarf von Ihrer physischen Umgebung an die VMs partitioniert. [[@noauthor_was_nodate-5]]

~~Wenn die entsprechende VM ausgeführt wird und ein Nutzender oder ein Programm Anweisungen ausgibt, die zusätzliche Ressourcen von der physischen Umgebung anfordert, sendet der Hypervisor diese Anforderung an die Ressourcen des physischen Systems, damit Betriebssystem und Anwendungen der VM auf den gemeinsamen Pool an physischen Ressourcen zugreifen können. [[@noauthor_was_nodate-5]]


## ~~Virtualisierung mit Hypervisoren

~~Es gibt zwei Typen von [Hypervisoren](https://www.redhat.com/de/topics/virtualization/what-is-a-hypervisor), die für die Virtualisierung eingesetzt werden können. [[@noauthor_was_nodate-5]]

#### ~~Typ 1

~~Ein Hypervisor vom Typ 1 ist ein Bare Metal-Hypervisor. VM-Ressourcen werden vom Hypervisor direkt für die Hardware eingeplant. KVM ist ein Beispiel für einen Hypervisor vom Typ 1. KVM wurde 2007 in den [Linux-Kernel](https://www.redhat.com/de/topics/linux/what-is-the-linux-kernel) integriert. Wenn Sie also eine moderne Version von [Linux](https://www.redhat.com/de/topics/linux/what-is-linux) verwenden, verfügen Sie bereits über einen solchen Hypervisor.  [[@noauthor_was_nodate-5]]

#### ~~Typ 2
 
~~Ein Hypervisor vom Typ 2 ist ein gehosteter Hypervisor. VM-Ressourcen werden beim Host-Betriebssystem angefordert und dann über die Hardware ausgeführt. VMware Workstation und Oracle VirtualBox sind Beispiele für einen Hypervisor vom Typ 2.  [[@noauthor_was_nodate-5]]

## ~~Was sind die Vorteile einer Virtuellen Maschine?

~~Einer der wichtigsten Gründe für die Nutzung von VMs ist die Serverkonsolidierung. Die meisten Betriebssysteme und Anwendungsbereitstellungen in Bare Metal-Umgebungen nutzen lediglich einen kleinen Teil der verfügbaren physischen Ressourcen. Durch die Virtualisierung Ihrer Server können Sie zahlreiche virtuelle Server auf jedem physischen Server platzieren und so die Hardwarenutzung optimieren.  [[@noauthor_was_nodate-5]]

~~Auf diese Weise müssen Sie keine zusätzlichen Ressourcen wie Speichermedien erwerben und können dazu den Bedarf an Strom, Platz und Kühlung Ihres Rechenzentrums verringern. VMs bieten zudem Disaster-Recovery-Optionen durch Failover und Redundanz, die zuvor nur mit zusätzlicher Hardware möglich waren. [[@noauthor_was_nodate-5]]

~~Eine VM liefert eine Umgebung, die vom Rest des Systems isoliert ist. Das heißt, all das, was in einer VM ausgeführt wird, kommt nicht mit anderen Daten auf der Hardware in Kontakt. [[@noauthor_was_nodate-5]]

~~Durch diese Isolierung sind VMs für das Testen neuer Anwendungen oder das Einrichten einer Produktivumgebung ideal geeignet. Sie können außerdem eine VM ausführen, die nur einen speziellen Prozess unterstützt. [[@noauthor_was_nodate-5]]

---

## ~~Was ist Virtualisierung? 
Bei Virtualisierung handelt es sich um eine **Abstraktion physischer IT-Ressourcen**. Abstrahieren lassen sich Hardware- und Software-Komponenten. Eine im Rahmen der Virtualisierung erstellte IT-Komponente wird als _virtuelle_ oder _logische Komponente_ bezeichnet und kann genauso verwendet werden wie ihr physisches Pendant. [[@noauthor_konzepte_2021]]


~~Der zentrale Vorteil der Virtualisierung ist die **Abstraktionsschicht** zwischen der physischen Ressource und dem virtuellen Abbild. Diese ist Grundlage diverser Cloud-Services, die im Unternehmensalltag zunehmend an Bedeutung gewinnen. Abzugrenzen ist Virtualisierung von den (z. T. sehr ähnlichen) Konzepten _Simulation_ und _Emulatio_n. [[@noauthor_konzepte_2021]]


~~Definition Virtualisierung

~~Bei Virtualisierung handelt es sich um die Abstraktion physischer IT-Ressourcen wie Hardware, Software, Speicher und Netzwerkkomponenten. Ziel ist es, diese Ressourcen auf virtueller Ebene bereitzustellen und ebenso flexibel wie bedarfsgerecht an verschiedene Abnehmer zu verteilen. Dies soll für eine verbesserte Auslastung der IT-Ressourcen sorgen. [[@noauthor_konzepte_2021]]


## ~~Virtualisierung: Weder Simulation noch Emulation 

~~Wer sich mit Virtualisierung beschäftigt, stößt unweigerlich auf die Begriffe _Simulation_ und _Emulation_, die oft synonym verwendet werden, sich technisch jedoch sowohl voneinander als auch vom Konzept der Virtualisierung unterscheiden. [[@noauthor_konzepte_2021]]


- ~~**Simulation:** Als Simulation bezeichnet man die vollständige Nachbildung eines Systems mittels Software. „Vollständig“ heißt in diesem Fall, dass nicht nur die Funktionen im Zusammenspiel mit anderen Systemen imitiert, sondern alle Systemkomponenten sowie deren innere Logik nachgestellt werden. Simulatoren kommen zur Anwendung, um Programme, die eigentlich für ein bestimmtes System entwickelt wurden, zu Analysezwecken auf einem anderen System kompilieren zu können. Simulation ermöglicht es beispielsweise, Software für antiquierte Großrechner auf modernen Rechenplattformen auszuführen. Im Gegensatz zur Emulation ist Simulation nicht für den Praxiseinsatz vorgesehen. Als Beispiel bietet sich der Flug-Simulator an. Dieser simuliert einen Flug, bringt den Piloten aber nicht ans Ziel. Ein populärer Simulator ist der [iPhone Simulator in XCode](https://www.youtube.com/watch?v=e7XBvDPkkCs "Mehr zum iPhone Simulator in XCode auf YouTube"). Er kommt beispielsweise zum Einsatz, um das Design mobiler Webseiten auf dem Desktop zu testen.   [[@noauthor_konzepte_2021]]

     
- ~~**Emulation:** Während Simulation darauf abzielt, Systeme nachzubilden, stellt Emulation die Funktionen von Hardware- oder Software-Komponenten bereit, nicht jedoch deren innere Logik. Ziel der Emulation ist es, mit dem nachgebildeten System dieselben Ergebnisse zu erzielen wie mit dem realen Pendant. Im Gegensatz zum Simulator kann ein Emulator das nachgebildete System daher komplett ersetzen. Ein Flug-Simulator, der den Piloten tatsächlich ans gewünschte Ziel bringt, wäre somit ein Flug-Emulator. Ein prominentes Software-Projekt, das diesem Konzept entspricht, ist der [Android Emulator in Android Studio](https://developer.android.com/studio/run/emulator.html "Mehr zum Android-Emulator auf developer.android.com"). [[@noauthor_konzepte_2021]]


~~Simulatoren und Emulatoren kommen in der Praxis in **drei Szenarien** zum Einsatz:

- ~~Eine Hardware-Umgebung wird nachgebildet, damit ein Betriebssystem ausgeführt werden kann, das eigentlich für eine andere Prozessorplattform entwickelt wurde.  
     
- ~~Ein Betriebssystem wird nachgebildet, damit Anwendungen ausgeführt werden können, die eigentlich für andere Systeme geschrieben wurden.  
     
- ~~Eine Hardware-Umgebung für eine veraltete Software muss nachgebildet werden, da die Original-Komponenten nicht mehr zur Verfügung stehen.
[[@noauthor_konzepte_2021]]


~~Von Emulatoren und Simulatoren abzugrenzen sind Software-Lösungen, die lediglich eine **Kompatibilitätsschicht** bereitstellen, um Unvereinbarkeiten zwischen verschiedenen Hardware- und Software-Komponenten zu überbrücken. Bei diesem Konzept wird nicht das gesamte System, sondern lediglich ein Teil eines Systems nachgebildet – beispielsweise eine Schnittstelle. Bekannte Beispiele sind **[Wine](https://www.winehq.org/ "Mehr zu Wine auf der Projektwebsite")** (ein rekursives Akronym für **_W_**_ine **I**s **N**ot an **E**mulator_) und **[Cygwin](https://www.ionos.de/digitalguide/server/tools/cygwin/ "Cygwin")**.[[@noauthor_konzepte_2021]]


 ~~Hinweis

~~Wine etabliert auf POSIX-kompatiblen Betriebssystemen (Linux, Mac, Solaris oder BSD) eine Kompatibilitätsschicht, die es ermöglicht, Windows-Programme auszuführen. Die Software basiert auf einer mühsamen Rekonstruktion des proprietären, nichtöffentlichen Windows-Quellcodes. Grundlage der Rekonstruktion war dabei nicht die Demontage der urheberrechtlich geschützten Software, sondern ein [Reverse-Engineering](https://www.ionos.de/digitalguide/websites/web-entwicklung/software-reverse-engineering/ "Software Reverse Engineering") im Rahmen des Black-Box-Testings. Technisch bildet Wine nicht die innere Logik des gesamten Windows-Betriebssystems nach, sondern lediglich die Windows-API (_Application Programming Interface_, deutsch: „Programmierschnittstelle“). Systemaufrufe der Windows-Software werden von Wine entgegengenommen, ohne Zeitverzögerung in POSIX-Aufrufe umgewandelt und an das zugrundeliegende System weitergeleitet. [[@noauthor_konzepte_2021]]


## ~~Wie funktioniert Virtualisierung?

~~Virtualisierung ähnelt den Konzepten _Simulation_ und _Emulation_, dient jedoch einem anderen Zweck. Simulatoren und Emulatoren implementieren ein mittels Software realisiertes **Modell eines Computersystems**, das dazu dient, Inkompatibilitäten zu überbrücken. Ziel ist es, Anwendungen auf einem System auszuführen, die von diesem eigentlich nicht unterstützt werden. Dieser Ansatz hat zwei Nachteile: Emulation und Simulation sind in der Entwicklung sehr aufwendig. Zudem gehen beide Ansätze zwangsläufig mit einem Performance-Verlust einher. Im Idealfall ist Virtualisierung daher so konzipiert, dass möglichst wenig simuliert oder emuliert werden muss. Stattdessen sollen Virtualisierungstechnologien lediglich eine Abstraktionsschicht etablieren, die es ermöglicht, IT-Ressourcen unabhängig von ihrer physischen Grundlage bereitzustellen. [[@noauthor_konzepte_2021]]


~~Dazu ein **Beispiel**: Möchte ein Anwender auf seinem Windows-7-Rechner zu Testzwecken eine oder mehrere virtuelle Versionen von Windows 7 ausführen, nutzt er dazu eine [Virtualisierungssoftware](https://www.ionos.de/digitalguide/server/konfiguration/virtualisierungssoftware-im-vergleich/ "Virtualisierungssoftware im Vergleich"). Möchte derselbe Nutzer auf dem gleichen Rechner hingegen zwei virtuelle Versionen von Ubuntu starten, benötigt er eine Virtualisierungssoftware, die in der Lage ist, Inkompatibilitäten zwischen dem zugrundeliegenden Windows-System und dem darauf aufsetzenden Linux-Systemen durch Emulation zu überbrücken. [[@noauthor_konzepte_2021]]


~~Zahlreiche Software-Lösungen, die im Rahmen der Virtualisierung zum Einsatz kommen, enthalten Emulatoren. In der Praxis kommt es daher oft zu **Überschneidungen** beider Konzepte. [[@noauthor_konzepte_2021]]


## ~~Formen der Virtualisierung

~~Der Begriff „Virtualisierung“ wurde in den 1960er Jahren geprägt und bezog sich zunächst auf das Erstellen virtueller Maschinen – ein Konzept der Hardware-Virtualisierung. Heute finden sich in modernen IT-Landschaften **diverse Formen der Virtualisierung**, die sich auf die Abstraktion von IT-Ressourcen wie Software, Speicher, Daten oder Netzwerkkomponenten beziehen. Man unterscheidet daher zwischen: 

- ~~Hardware-Virtualisierung
- ~~Software-Virtualisierung
- ~~Speichervirtualisierung
- ~~Datenvirtualisierung
- ~~Netzwerkvirtualisierung
[[@noauthor_konzepte_2021]]

### ~~Hardware-Virtualisierung

~~Der Begriff _Hardware-Virtualisierung_ verweist auf Technologien, die es ermöglichen, Hardware-Komponenten mittels Software unabhängig von ihrer physischen Grundlage bereitzustellen. Das Paradebeispiel für eine Virtualisierung von Hardware ist die **virtuelle Maschine** (kurz VM).

~~Bei einer VM handelt es sich um einen virtuellen Rechner, der sich dem Endnutzer gegenüber wie ein physischer Rechner inklusive Hardware und Betriebssystem verhält. Virtuelle Maschinen laufen als _virtuelle Gastsysteme_ auf einem oder mehreren physischen Systemen, die als _Wirt_ bezeichnet werden. Die Abstraktionsschicht zwischen der physischen Grundlage und dem virtuellen System wird bei der Hardware-Virtualisierung durch einen sogenannten **Hypervisor** erzeugt.

~~Bei einem Hypervisor (auch _Virtual Machine Monitor_, VMM) handelt es sich um eine Software, die den Betrieb mehrerer Gastsysteme auf einem Wirtssystem ermöglicht. Man unterschiedet zwei Typen von Hypervisoren: Ein Typ-1-Hypervisor setzt direkt auf der Hardware des Hostsystems auf. Hypervisoren dieser Art werden Bare-Metal-Hypervisoren genannt. Typ-2-Hypervisoren hingegen laufen im Betriebssystem des Wirts und nutzen die vom System bereitgestellten Gerätetreiber, um auf die Hardware zuzugreifen. Man spricht von einem Hosted Hypervisor.

~~Hypervisoren verwalten die vom Wirtssystem zur Verfügung gestellten Hardware-Ressourcen wie CPU, RAM, Festplattenspeicher und Peripherie und teilen diese auf beliebig viele Gastsysteme auf. Dies kann technisch durch Vollvirtualisierung oder Paravirtualisierung erfolgen.

- ~~**Vollvirtualisierung:** Bei der Vollvirtualisierung spielt der Hypervisor jeder virtuellen Maschine eine komplette Hardware-Umgebung vor. Jede VM verfügt somit über ein eigenes, vom Hypervisor zugewiesenes Kontingent an virtuellen Hardware-Ressourcen und kann auf dieser Grundlage Anwendungen ausführen. Die physische Hardware des Wirtssystems hingegen bleibt dem Gastbetriebssystem verborgen. Dieser Ansatz ermöglicht den Betrieb unmodifizierter Gastsysteme. Beliebte Software-Lösungen zur Vollvirtualisierung sind Oracle VM VirtualBox, Parallels Workstation, VMware Workstation, Microsoft [Hyper-V](https://www.ionos.de/digitalguide/server/knowhow/was-ist-hyper-v/ "Was ist Hyper-V?") und Microsoft Virtual Server.  
     
- ~~**Paravirtualisierung:** Während bei der Vollvirtualisierung für jede VM eine eigene virtuelle Hardware-Umgebung bereitstellt wird, stellt der Hypervisor bei der Paravirtualisierung lediglich eine [Programmierschnittstelle (API)](https://www.ionos.de/digitalguide/websites/web-entwicklung/was-ist-eine-api/ "Was ist eine API?") zur Verfügung, über die die Gastbetriebssysteme direkt auf die physische Hardware des Wirtssystems zugreifen können. Paravirtualisierung bietet damit gegenüber Vollvirtualisierung einen Performance-Vorteil. Voraussetzung dafür ist jedoch, dass der [Kernel](https://www.ionos.de/digitalguide/server/knowhow/was-ist-ein-kernel/ "Was ist ein Kernel?") des Gastbetriebssystems für die API portiert wurde. Es lassen sich somit nur modifizierte Gastsysteme paravirtualisieren. Anbieter proprietärer Systeme – beispielsweise Microsoft Windows – gestatten eine solche Modifizierung in der Regel nicht. Zu Hypervisoren, die eine Paravirtualisierung ermöglichen, gehören Xen und Oracle VM Server for SPARC. Das Konzept kommt zudem in IBMs Großrechnerbetriebssystem z/VM zum Einsatz.

~~Für den Endnutzer ist die virtuelle Maschine von einem physischen Rechner nicht zu unterscheiden. Hardware-Virtualisierung ist daher das Konzept der Wahl, wenn es darum geht, eine Vielzahl virtueller Server für verschiedene Anwender auf Basis einer leistungsstarken Rechenplattform bereitzustellen – die Grundlage des populären Shared-Hosting-Modells.

~~Ein weiteres Anwendungsfeld der Hardware-Virtualisierung ist die **Server-Konsolidierung** im Unternehmensumfeld. Virtualisierung kommt dabei mit dem Ziel zum Einsatz, die Auslastung der Server-Hardware zu erhöhen. Hardware-Komponenten wie Prozessoren sind in der Anschaffung kostspielig. Um zu verhindern, dass teure CPU-Ressourcen ungenutzt bleiben, vermeiden Unternehmen IT-Architekturen, in denen separate Rechenmaschinen für unterschiedliche Server-Anwendungen zum Einsatz kommen. Stattdessen werden unterschiedliche Server als separate Gastsysteme auf derselben Hardware-Plattform betrieben. Dies bringt im Wesentlichen drei Vorteile:

- ~~Verbesserte Prozessorauslastung der Server
- ~~Effektive Aufteilung von Speichermedien
- ~~Geringerer Stromverbrauch für Betrieb und Kühlung

~~Besonders effizient ist dieser Ansatz, wenn die konsolidierten Server mit versetzten Leistungsspitzen arbeiten. Wird die Hardware des Wirtssystems hingegen von allen Gastsystemen gleichzeitig in Anspruch genommen, muss sichergestellt werden, dass genügend Ressourcen für alle Workloads zur Verfügung stehen. Andernfalls besteht die Gefahr, dass sich eine ressourcenintensive Anwendung in der einen virtuellen Maschine negativ auf die Performance anderer Anwendungen in anderen VMs auf demselben Wirtssystem auswirkt.
[[@noauthor_konzepte_2021]]

### ~~Software-Virtualisierung

~~Werden statt Hardware-Komponenten Software-Komponenten virtualisiert, spricht man von _Software-Virtualisierung_. Geläufige Ansätze dieses Virtualisierungskonzepts sind:

- ~~Anwendungsvirtualisierung
- ~~Desktop-Virtualisierung
- ~~Virtualisierung auf Betriebssystemen

~~_Anwendungsvirtualisierung_

~~Unter Anwendungsvirtualisierung (englisch _application virtualization_) versteht man die Abstraktion einzelner Anwendungen vom darunterliegenden Betriebssystem. Anwendungsvirtualisierungssysteme wie VMware ThinApp, Microsoft App-V, oder Citrix XenApp ermöglichen es, **Programme in isolierten Laufzeitumgebungen** auszuführen und über verschiedene Systeme hinweg zu verteilen, ohne dass Änderungen an lokalen Betriebs- oder Dateisystemen sowie der jeweiligen Registry erforderlich sind.

~~Mit VMware ThinApp beispielsweise lassen sich Windows-Installer-Paketdateien (z. B. MSI-Dateien) komplexer Programme in eigenständige EXE-Dateien konvertieren. Diese beinhalten sämtliche Bibliotheken und Konfigurationsdateien, die benötigt werden, um die Anwendung auf einer beliebigen Windows-Betriebssystemumgebung auszuführen.

~~Anwendungsvirtualisierung bietet sich für den lokalen Einsatz an – beispielsweise, um das darunterliegende Betriebssystem vor möglichem Schadcode zu schützen. Alternativ können virtualisierte Anwendungen auf einem Server für verschiedene Clients im Netzwerk bereitgestellt werden. Endnutzer greifen in diesem Fall beispielsweise via **Application-Streaming** auf virtualisierte Anwendungen zu. Dabei wird die gewünschte Anwendung inklusive aller Abhängigkeiten vom Server auf das jeweilige Clientgerät kopiert und dort in einer isolierten Laufzeitumgebung ausgeführt – ohne dass die Software auf dem Zielsystem installiert werden muss. Die Kapselung von Anwendungen inklusive Laufzeitumgebung ermöglicht es zudem, Programme auf portable Speichermedien wie USB-Sticks zu kopieren und direkt auf diesen auszuführen.

~~Ziel der Anwendungsvirtualisierung ist es, Programme vom darunterliegenden Betriebssystem zu entkoppeln, sodass sich diese bequem portieren und zentral warten lassen. Im Unternehmenskontext eignet sich das Konzept beispielsweise zur **Bereitstellung von Office-Anwendungen**.
[[@noauthor_konzepte_2021]]

#### ~~_Desktop-Virtualisierung_

~~Desktop-Virtualisierung bezeichnet ein Konzept, bei dem **Desktop-Umgebungen zentral bereitgestellt** und über ein Netzwerk in Anspruch genommen werden können. Anwendung findet dieser Ansatz in erster Linie im Unternehmenskontext.

~~Der Desktop-Virtualisierung liegt eine **Client-Server-Struktur** zugrunde. Die Datenübertragung zwischen Server und Client erfolgt über sogenannte Remote-Display-Protokolle. Führende Anbieter von Software-Lösungen zur Desktop-Virtualisierung wie Microsoft, VMware oder Citrix setzen dabei auf proprietäre Technologien. Je nachdem, wo die Rechenleistung für die Bereitstellung eines virtuellen Desktops in Anspruch genommen wird, unterscheidet man zwischen host- und clientbasierten Ansätzen.

- **~~Hostbasierte Desktop-Virtualisierung:** Zur hostbasierten Desktop-Virtualisierung zählen alle Ansätze, bei denen virtuelle Desktops direkt auf dem Server ausgeführt werden. Die gesamte Rechenleistung für die Bereitstellung der Desktop-Umgebung sowie für den Betrieb von Anwendungen wird bei dieser Art der Desktop-Virtualisierung von der Server-Hardware zur Verfügung gestellt. Anwender greifen auf hostbasierte virtuelle Desktops mit beliebigen Clientgeräten über das Netzwerk zu. Dabei können vollausgestattete PCs oder Notebooks (_Thick Clients_), Endgeräte mit reduzierter Hardware (_Thin Clients_) oder gänzlich minimalisierte Rechner (_Zero Clients_) sowie Tablets und Smartphones zum Einsatz kommen. In der Regel ist eine permanente Netzwerkverbindung erforderlich. Umsetzen lässt sich eine hostbasierte Desktop-Virtualisierung durch folgende Ansätze:  
     
    - ~~**Hostbasierte virtuelle Maschine:** Bei diesem Virtualisierungsansatz verbindet sich jeder Anwender über ein Clientgerät mit einer eigenen virtuellen Maschine auf dem Server. Man unterscheidet zwischen einer _persistenten_ Desktop-Virtualisierung, bei der sich ein Anwender bei jeder Sitzung mit derselben VM verbindet, und _nichtpersistenten_ Ansätzen, bei denen virtuelle Maschinen zufällig zugeteilt werden. Kommen hostbasierte virtuelle Maschine im Rahmen der Desktop-Virtualisierung zum Einsatz, spricht man von einer _Virtual Desktop Infrastructure_ (VDI). Persistente hostbasierte VMs bieten Anwendern einen großen Individualisierungsspielraum. Virtuelle Desktops, die im Rahmen dieses Ansatzes bereitgestellt werden, lassen sich wie lokale Desktops mit benutzerdefinierten Anwendungen und individuellen Anzeigeoptionen personalisieren.  
         
    - ~~**Terminal-Service:** Kommt der Client lediglich als Anzeigegerät für zentral gehostete Desktop-Umgebungen zum Einsatz, spricht man von Terminal-Services oder Präsentationsvirtualisierung. Diese werden von einem sogenannten [Terminalserver](https://www.ionos.de/digitalguide/server/knowhow/terminalserver-das-steckt-hinter-den-remote-hosts/ "Terminalserver – das steckt hinter den Remote-Hosts") zur Verfügung gestellt. Dieser Ansatz der hostbasierten Desktop-Virtualisierung bietet Anwendern lediglich einen minimalen Individualisierungsspielraum und eignet sich daher für Szenarios, bei denen hochstandardisierte Arbeitsplätze mit eingeschränkten Funktionen in großer Anzahl zur Verfügung gestellt werden sollen. Terminal-Services kommen beispielsweise im Einzelhandel zum Einsatz. Hier bieten Thin Clients Angestellten die Möglichkeit, Lagerbestände zu prüfen und Produktinformationen abzurufen. Kunden nutzen Terminals dieser Art, um Waren individuell zu konfigurieren und Bestellungen aufzugeben.  
         
    - ~~**Blade-Server:** Sollen Endanwender per Remote auf separate physische Maschinen zugreifen, wird dies in der Regel mithilfe eines Blade-Server realisiert. Dabei handelt es sich um einen modular aufgebauten Server bzw. ein Servergehäuse, das mehrere Einplatinencomputer – sogenannte _Blades_ (deutsch: „Blatt“) – beinhaltet. Im Rahmen der Desktop-Virtualisierung wird jede Desktop-Umgebung auf einem separaten Blade ausgeführt. Der Vorteil dieses Ansatzes: Serverblades sind eigenständige physische Rechenmaschinen, teilen sich jedoch die Versorgungseinrichtungen des Gehäuses (Strom und Kühlung) und werden zentral verwaltet.  
         
- ~~**Clientbasierte Desktop-Virtualisierung**: Erfolgt die Desktop-Virtualisierung clientbasiert, müssen die Ressourcen für den Betrieb der Desktop-Umgebung vom jeweiligen Clientgerät bereitgestellt werden. Dieser Ansatz erfordert daher einen Thick Client mit entsprechender Hardware. In der Praxis wird die clientbasierte Desktop-Virtualisierung mithilfe von virtuellen Maschinen oder als OS-Streaming umgesetzt.  
     
    - ~~**Clientbasierte virtuelle Maschinen:** Bei diesem Ansatz der Virtualisierung wird die Desktop-Umgebung in einer virtuellen Maschine auf dem Clientgerät ausgeführt. In der Regel kommt dabei ein Hypervisor zum Einsatz. Jeder virtuelle Desktop synchronisiert sich in regelmäßigen Abständen mit einem Betriebssystem-Image auf dem Server. Dies ermöglicht eine zentrale Verwaltung sowie imagebasierte Back-up-Zyklen. Ein weiterer Vorteil dieses Virtualisierungsansatzes ist, dass Anwendungen auch dann lokal zur Verfügung stehen, wenn die Verbindung zum Server abbricht.  
         
    - ~~**OS-Streaming:** Beim OS-Streaming wird das Betriebssystem der Desktop-Umgebung auf der lokalen Hardware ausgeführt. Lediglich der Boot-Vorgang erfolgt per Remote über ein Image auf dem Server. OS-Streaming bietet sich somit für Szenarien an, in denen ganze Desktop-Gruppen auf Basis eines einzigen Betriebssystem-Images bereitgestellt werden sollen. Dies hat den Vorteil, dass Administratoren lediglich ein Image auf dem Server verwalten müssen, um Anpassungen auf allen gestreamten Desktops herbeizuführen. OS-Streaming kommt ohne Hypervisor aus. Es benötigt jedoch eine konstante Netzwerkverbindung zwischen dem Server und dem Clientgerät.

~~Konzepte der Desktop-Virtualisierung punkten in erster Linie durch eine **zentralisierte Administration**. Signifikant reduzieren lässt sich der Aufwand für die Verwaltung und Wartung vor allem bei standardisierten Arbeitsumgebungen. Steht die Unternehmens-IT jedoch vor dem Problem, dass eine heterogene IT-Infrastruktur mit einer Vielzahl unterschiedlicher Desktops realisiert werden soll, relativiert sich dieser Vorteil.

~~Unternehmen, die auf Desktop-Virtualisierung setzen, versprechen sich in der Regel Einsparungen. Vor allem Thin Clients sollen die **Kosten bei der Hardware-Anschaffung** sowie den **Stromverbrauch im Büro reduzieren**. Mitunter lassen sich vergleichbare Arbeitsbedingungen mit deutlich weniger Software-Lizenzen realisieren. Auch im Bereich der Lizenzierung sind somit Einsparungen möglich. Auf der Serverseite hingegen fallen bei der Umstellung auf virtuelle Desktops zunächst Kosten an.

~~Desktop-Virtualisierung erfordert leistungsstarke Server. Je nach Virtualisierungsansatz ist zudem eine hohe Bandbreite für die Datenübertragung im Netzwerk erforderlich. Durch die damit verbundenen **Anschaffungskosten** zahlt sich Desktop-Virtualisierung in der Praxis daher oft erst langfristig aus.
[[@noauthor_konzepte_2021]]

### ~~Speichervirtualisierung

~~Bei der Speichervirtualisierung (_Storage-Virtualisierung_) handelt sich um ein Virtualisierungskonzept, das darauf abzielt, diverse Speicherressourcen eines Unternehmens wie Festplattenlaufwerke, Flashspeicher oder Bandlaufwerke virtuell abzubilden und als zusammenhängenden **Speicherpool** bereitzustellen. Dabei etabliert eine Virtualisierungslösung eine Abstraktionsschicht zwischen den verschiedenen physischen Speichermedien und der logischen Ebene, auf der sich die zusammengefassten **Speicherressourcen mittels Software zentral verwalten** lassen.

~~Auch virtueller Speicher lässt sich in Kontingente zerlegen und ausgewählten Anwendungen zuteilen. Anwender können auf gespeicherte Daten trotz Virtualisierung stets über dieselben Dateipfade zugreifen, auch wenn sich der physische Speicherort ändert. Sichergestellt wird dies durch eine von der Virtualisierungssoftware verwaltete Zuordnungstabelle. Man spricht von einem **Mapping** der physischen Speichermedien auf ein logisches Laufwerk (auch _Volumes_ genannt).

~~An die physischen Kapazitätsgrenzen der zugrundeliegenden einzelnen Speichermedien sind logische Laufwerke nicht gebunden. Speichervirtualisierung bietet somit deutlich mehr **Flexibilität bei der Zuteilung von Speicherressourcen**. Die zur Datenspeicherung zur Verfügung stehende Hardware lässt sich effektiver auslasten. Für Unternehmen bedeutet dies, dass sich Speicherkapazitäten im Rechenzentrum kostengünstiger bereitstellen lassen.

~~Im Unternehmenskontext wird Speichervirtualisierung in der Regel **blockbasiert** umgesetzt. Bei der Blockspeicherung werden Daten in gleich große Blöcke unterteilt. Jeder Datenblock erhält eine einzigartige Adresse. Diese wird von der Virtualisierungssoftware in der zentralen Zuordnungstabelle (_Mapping-Table_) gespeichert. Die Zuordnungstabelle enthält somit alle Metadaten, die benötigt werden, den physischen Speicherort eines Datenblocks ausfindig zu machen. Dieses Mapping erlaubt es, Daten auf der virtuellen Ebene unabhängig vom jeweiligen Controller des physischen Speichermediums zu verwalten und somit beispielsweise zu verschieben, zu kopieren, zu spiegeln oder zu replizieren.
[[@noauthor_konzepte_2021]]


### ~~Datenvirtualisierung

~~Datenvirtualisierung fasst verschiedene Virtualisierungsansätze im Rahmen von [Data-Warehouse-Analysen](https://www.ionos.de/digitalguide/online-marketing/web-analyse/dwh-was-ist-ein-data-warehouse/ "DWH | Was ist ein Data-Warehouse?") zusammen, die darauf abzielen, Anwendungen einen von physischen Gegebenheiten abstrahierten Zugriff auf Daten zu verschaffen. Dabei wird eine sogenannte **Master-Kopie**, ein virtuelles Abbild des Gesamtdatenbestands, erstellt.

~~Bei der Datenvirtualisierung handelt sich somit um ein Konzept der **Informationsintegration**, das sich von klassischen Verfahren wie dem ETL-Prozess dadurch abhebt, dass eine Abstraktionsschicht zwischen den physischen Datenquellen und dem virtuellen Abbild der Daten etabliert wird.

~~Im Rahmen der Informationsintegration kommt ETL (**E**xtract, **T**ransform, **L**oad) zum Einsatz, um Daten aus unterschiedlich strukturierten Quellen zu extrahieren und in einheitlicher Form in einer Zieldatenbank zusammenzuführen. Auch Datenvirtualisierung ermöglicht es, Daten aus verschiedenen Quellen auszulesen und zu manipulieren, diese bleiben (anders als bei ETL) physisch jedoch an Ort und Stelle. Software-Lösungen zur Datenvirtualisierung integrieren Daten somit lediglich auf einer virtuellen Ebene und stellen einen **Echtzeit-Zugriff auf die physische Datenquelle** zur Verfügung.

~~Mit Datenvirtualisierungstechnologien lassen sich Daten, die über mehrere Data-Warehouses, Data- Marts oder Data-Lakes verteilt sind, effektiv zusammenführen, ohne dass eine neue physische Datenplattform geschaffen werden muss. Dies reduziert in erster Linie den benötigten Speicherplatz für **Analysen großer Datenmengen**. Zudem müssen weniger Daten über das Netzwerk übertragen werden. Das virtuelle Abbild des Gesamtdatenbestands kann diversen Anwendungen zur Verfügung gestellt werden. Im Rahmen der Business Intelligence (BI) stehen Self-Service-Tools zur Verfügung, mit denen Berichte und Analysen erstellt werden können, ohne dass eine Zusammenarbeit mit fachkundigem IT-Personal erforderlich ist.

~~Führende Anbieter entsprechender Technologien sind: Denodo, TIBCO, IBM und Informatica.
[[@noauthor_konzepte_2021]]

### ~~Netzwerkvirtualisierung

~~Netzwerkvirtualisierung umfasst verschiedene Ansätze, bei denen Netzwerkressourcen auf Hardware- und Software-Ebene von ihrer physischen Grundlage abstrahiert werden. In der Regel kommt diese Art der Virtualisierung **im Rahmen von Sicherheitskonzepten** zum Einsatz. Dabei stehen grundsätzlich zwei Ziele im Vordergrund:

- ~~Physische Netzwerk-Ressourcen sollen mittels Virtualisierung zu einer logischen Einheit zusammengefasst werden.

- ~~Physische Netzwerk-Ressourcen sollen mittels Virtualisierung in verschiedene virtuelle Einheiten aufgeteilt werden.

~~Ein anschauliches Beispiel für Netzwerkvirtualisierung ist das [Virtual Private Network (VPN)](https://www.ionos.de/digitalguide/server/knowhow/was-ist-ein-vpn-virtual-private-network/ "Was ist ein VPN (Virtual Private Network)?"). Bei einem VPN handelt es sich um ein virtuelles Netzwerk auf Basis eines physischen Netzwerks. In der Praxis kommen VPNs zum Einsatz, um sichere Verbindungen über unsichere Leitungen zu realisieren – beispielsweise, wenn ein Außenmitarbeiter über das Internet auf das private Netzwerk seiner Firma zugreifen möchte.

~~Als öffentliches Netz ermöglicht das Internet keine sichere Verbindung zwischen zwei Rechnern. Um die Vertraulichkeit von Daten bei der Übertragung sicherzustellen, ist es daher ratsam, auf Virtualisierung zurückzugreifen. Diverse Software-Hersteller bieten Virtualisierungslösungen, mit denen sich virtuelle Netzwerke von physischen Netzwerken abstrahieren und mittels Verschlüsselungs- und Authentifizierungsverfahren absichern lassen. Die Datenübertragung von einem Rechner zum anderen erfolgt somit in einem privaten Netz, das auch als **Tunnel** bezeichnet wird.

~~Ein anderes Beispiel für Netzwerkvirtualisierung sind sogenannte [Virtual Local Area Network (VLANs)](https://www.ionos.de/digitalguide/server/knowhow/vlan-grundlagen/ "VLAN-Grundlagen"). Bei VLANs handelt es sich um virtuelle Teilnetze auf Basis eines physischen Rechnernetzes. Realisiert werden VLANs über Hardware-Komponenten wie virtualisierende Switches oder Router. An ein VLAN angeschlossene Geräte können lediglich mit Geräten im selben VLAN kommunizieren. Eine Datenverbindung zu Geräten in anderen VLANs besteht nicht, selbst wenn sich alle Geräte im selben physischen Netzwerk befinden. Netzwerkvirtualisierung bietet somit die Möglichkeit, Netzwerk-Ressourcen unabhängig von physischen Gegebenheiten auf virtueller Ebene flexibel bereitzustellen, zu verwalten und zuzuteilen.

~~Ein Konzept, das es erlaubt, virtuelle Netzwerkressourcen zentral zu steuern, ohne manuell auf physische Netzwerkkomponenten zugreifen zu müssen, ist **Software-Defined Networking (SDN)**. SDN beruht auf der Entkopplung der virtuellen Kontrollebene (_Control Plane_) von der physischen Netzwerkebene, die für die Weiterleitung der Datenpakete verantwortlich ist (_Data Plane_). Kernkomponente der Control Plane ist ein **Netzwerk-Controller**. Dieser verwaltet die Netzwerkkomponenten der Data Plane wie Router und Switches und steuert die Weiterleitung von Datenpaketen. Der Netzwerk-Controller ist somit für das Management des Netzwerks sowie für Routingvorgaben, Zugriffsrechte und die Umsetzung von Sicherheitskonzepten zuständig. Netzwerkkomponenten der Data Plane nehmen Anweisungen des Netzwerk-Controllers entgegen und sind für den Transport der Datenpakete zum gewünschten Empfangsgerät zuständig.
[[@noauthor_konzepte_2021]]

---

## ~~Was ist Virtualisierung? [[@noauthor_was_nodate-6]]

~~Virtualisierung ist eine Technologie, die man benutzen kann, um virtuelle Darstellungen von Servern, Speichern, Netzwerken und anderen physischen Maschinen herzustellen. Virtuelle Software ahmt die Funktionen materieller Hardware nach, um viele virtuelle Maschinen gleichzeitig auf einer einzigen materiellen Maschine laufen zu lassen. Firmen benutzen Virtualisierung, um ihre Hardwareressourcen effizienter zu nutzen und mehr aus ihrer Investition zu holen. Sie leistet auch Cloud-Computing-Services, so dass Organisationen ihre Infrastruktur effizienter nutzen können.[[@noauthor_was_nodate-6]]

## ~~Warum ist Virtualisierung wichtig?

~~Durch den Einsatz von Virtualisierung können Sie mit jeder Hardwareressource flexibler umgehen. Physische Server verbrauchen Strom, nehmen Speicherplatz in Anspruch und müssen gewartet werden. Wenn Sie darauf zugreifen möchten, sind Sie oft durch die räumliche Nähe und das Netzwerkdesign eingeschränkt. Die Virtualisierung hebt all diese Einschränkungen auf, indem sie die physische Hardwarefunktionalität in Software abstrahiert. Sie können Ihre Hardware-Infrastruktur wie eine Anwendung im Internet verwalten, pflegen und nutzen.[[@noauthor_was_nodate-6]]


## ~~Welche Vorteile bietet die Virtualisierung?

~~Die Virtualisierung bietet jedem Unternehmen mehrere Vorteile:

### ~~Effiziente Ressourcennutzung

~~Virtualisierung verbessert die Hardware-Ressourcen in Ihrem Rechenzentrum. Anstatt einen Server auf einem Computersystem zu betreiben, können Sie beispielsweise einen virtuellen Serverpool auf demselben Computersystem erstellen, indem Sie nach Bedarf Server in den Pool aufnehmen und wieder abgeben. Mit weniger zugrunde liegenden physischen Servern wird Platz in Ihrem Rechenzentrum frei und Sie sparen Geld für Strom, Generatoren und Kühlgeräte. [[@noauthor_was_nodate-6]]

### ~~Automatisierte IT-Verwaltung

~~Jetzt, wo physische Computer virtuell sind, können Sie sie mit Hilfe von Software-Tools verwalten. Administratoren erstellen Bereitstellungs- und Konfigurationsprogramme, um Vorlagen für virtuelle Maschinen zu definieren. Sie können Ihre Infrastruktur wiederholt und konsistent duplizieren und fehleranfällige manuelle Konfigurationen vermeiden.[[@noauthor_was_nodate-6]]

### ~~Schnellere Notfallwiederherstellung

~~Wenn Ereignisse wie Naturkatastrophen oder Cyberangriffe den Geschäftsbetrieb beeinträchtigen, kann die Wiederherstellung des Zugriffs auf die IT-Infrastruktur und der Austausch oder die Reparatur eines physischen Servers Stunden oder sogar Tage dauern. Im Gegensatz dazu dauert der Prozess in virtualisierten Umgebungen nur Minuten. Diese prompte Reaktion verbessert die Ausfallsicherheit erheblich und erleichtert die [Geschäftskontinuität](https://docs.aws.amazon.com/whitepapers/latest/disaster-recovery-workloads-on-aws/business-continuity-plan-bcp.html), so dass der Betrieb wie geplant fortgesetzt werden kann.  [[@noauthor_was_nodate-6]]

## Wie funktioniert Virtualisierung?

Bei der Virtualisierung wird eine spezielle Software, ein sogenannter Hypervisor, verwendet, um mehrere Cloud-Instanzen oder virtuelle Maschinen auf einem physischen Computer zu erstellen.[[@noauthor_was_nodate-6]]

### Cloud-Instances oder virtuelle Maschinen

Nachdem Sie die Virtualisierungssoftware auf Ihrem Computer installiert haben, können Sie eine oder mehrere virtuelle Maschinen erstellen. Sie können auf die virtuellen Maschinen auf die gleiche Weise zugreifen wie auf andere Anwendungen auf Ihrem Computer. Ihr Computer wird als Host und die virtuelle Maschine als Gast bezeichnet. Mehrere Gäste können auf dem Host laufen. Jeder Gast hat sein eigenes Betriebssystem, das mit dem des Hosts identisch sein oder sich von diesem u nterscheiden kann. 

Aus der Sicht des Benutzers arbeitet die virtuelle Maschine wie ein typischer Server. Es enthält Einstellungen, Konfigurationen und installierte Anwendungen. Die Rechenressourcen, wie z. B. CPUs (Central Processing Units), RAM (Random Access Memory) und Speicher sind dieselben wie bei einem physischen Server. Außerdem können Sie die Gastbetriebssysteme und ihre Anwendungen nach Bedarf konfigurieren und aktualisieren, ohne das Host-Betriebssystem zu beeinträchtigen.[[@noauthor_was_nodate-6]]

### Hypervisor

Der Hypervisor ist die Virtualisierungssoftware, die Sie auf Ihrem physischen Computer installieren. Es handelt sich um eine Softwareschicht, die als Vermittler zwischen den virtuellen Maschinen und der zugrunde liegenden Hardware oder dem Host-Betriebssystem fungiert. Der Hypervisor koordiniert den Zugriff auf die physische Umgebung, so dass mehrere virtuelle Maschinen Zugriff auf ihren eigenen Anteil an physischen Ressourcen haben. 

Wenn die virtuelle Maschine beispielsweise Rechenressourcen benötigt, wie z.B. Rechenleistung, geht die Anfrage zunächst an den Hypervisor. Der Hypervisor leitet die Anfrage dann an die zugrunde liegende Hardware weiter, die die Aufgabe ausführt. 

Im Folgenden finden Sie die beiden Hauptarten von Hypervisoren.
[[@noauthor_was_nodate-6]]
#### _Typ 1 Hypervisoren_

Ein Hypervisor vom Typ 1 – auch Bare-Metal-Hypervisor genannt – läuft direkt auf der Computerhardware. Es verfügt über einige Betriebssystemfunktionen und ist äußerst effizient, da es direkt mit den physischen Ressourcen interagiert. [[@noauthor_was_nodate-6]]

#### _Typ 2 Hypervisoren_

Ein Hypervisor vom Typ 2 läuft als Anwendung auf Computerhardware mit einem vorhandenen Betriebssystem. Verwenden Sie diese Art von Hypervisor, wenn Sie mehrere Betriebssysteme auf einem einzigen Computer ausführen. [[@noauthor_was_nodate-6]]

## Was sind die verschiedenen Arten von Virtualisierung?

Mit der Virtualisierungstechnologie können Sie die Funktionen vieler verschiedener Arten von physischer Infrastruktur und alle Vorteile einer virtualisierten Umgebung nutzen. Sie können über virtuelle Maschinen hinausgehen und eine Sammlung von virtuellen Ressourcen in Ihrer virtuellen Umgebung erstellen. [[@noauthor_was_nodate-6]]

### Servervirtualisierung

Servervirtualisierung ist ein Prozess, bei dem ein physischer Server in mehrere virtuelle Server aufgeteilt wird. Es ist ein effizienter und kostengünstiger Weg zur Nutzung von Serverressourcen und zur Bereitstellung von IT-Services in einem Unternehmen. Ohne Servervirtualisierung nutzen physische Server nur einen kleinen Teil ihrer Verarbeitungskapazitäten, wodurch die Geräte ungenutzt bleiben.
[[@noauthor_was_nodate-6]]
### Speichervirtualisierung

Die Speichervirtualisierung kombiniert die Funktionen von physischen Speichergeräten wie Network Attached Storage (NAS) und Storage Area Network (SAN). Sie können die Speicherhardware in Ihrem Rechenzentrum zusammenlegen, auch wenn sie von verschiedenen Anbietern oder unterschiedlichen Typen stammt. Die Speichervirtualisierung nutzt Ihren gesamten physischen Datenspeicher und erstellt eine große Einheit virtuellen Speichers, den Sie mit Hilfe von Verwaltungssoftware zuweisen und steuern können. IT-Administratoren können Speicheraktivitäten wie Archivierung, Backup und Wiederherstellung rationalisieren, da sie mehrere Netzwerkspeichergeräte virtuell zu einem einzigen Speichergerät zusammenfassen können.
[[@noauthor_was_nodate-6]]
### Netzwerkvirtualisierung

Jedes [Computernetzwerk](https://aws.amazon.com/what-is/computer-networking/) verfügt über Hardwareelemente wie Switches, Router und Firewalls. Ein Unternehmen mit Niederlassungen an mehreren geografischen Standorten kann mehrere verschiedene Netzwerktechnologien einsetzen, um sein Unternehmensnetzwerk aufzubauen. Die Netzwerkvirtualisierung ist ein Prozess, der all diese Netzwerkressourcen kombiniert, um die Verwaltungsaufgaben zu zentralisieren. Administratoren können diese Elemente virtuell anpassen und steuern, ohne die physischen Komponenten zu berühren, was die Netzwerkverwaltung erheblich vereinfacht.
[[@noauthor_was_nodate-6]]
Im Folgenden finden Sie zwei Ansätze zur Netzwerkvirtualisierung.

#### _Softwaredefiniertes Netzwerk_

Software-defined Networking (SDN) steuert das Routing des Datenverkehrs, indem es das Routing-Management vom Daten-Routing in der physischen Umgebung übernimmt. Sie können Ihr System beispielsweise so programmieren, dass es den Datenverkehr von Videoanrufen gegenüber dem Datenverkehr von Anwendungen priorisiert, um eine gleichbleibende Gesprächsqualität in allen Online-Meetings zu gewährleisten.
[[@noauthor_was_nodate-6]]
#### _Virtualisierung von Netzwerkfunktionen_ 

Die Technologie der Netzwerkfunktionsvirtualisierung kombiniert die Funktionen von Netzwerk-Appliances wie Firewalls, Load Balancern und Traffic-Analysatoren, die zusammenarbeiten, um die Netzwerkleistung zu verbessern.
[[@noauthor_was_nodate-6]]
### Datenvirtualisierung

Moderne Unternehmen sammeln Daten aus verschiedenen Quellen und speichern sie in unterschiedlichen Formaten. Sie können Daten auch an verschiedenen Orten speichern, z. B. in einer Cloud-Infrastruktur und in einem Rechenzentrum vor Ort. Die Datenvirtualisierung schafft eine Softwareschicht zwischen diesen Daten und den Anwendungen, die sie benötigen. Datenvirtualisierungstools verarbeiten die Datenanforderung einer Anwendung und geben die Ergebnisse in einem geeigneten Format zurück. Unternehmen nutzen daher Datenvirtualisierungslösungen, um die Flexibilität bei der Datenintegration zu erhöhen und die funktionsübergreifende Datenanalyse zu unterstützen.
[[@noauthor_was_nodate-6]]
### Anwendungs-Virtualisierung

Die Anwendungs-Virtualisierung zieht die Funktionen von Anwendungen heraus, um sie auf anderen Betriebssystemen laufen zu lassen als denjenigen, für die sie entwickelt wurden. So können Benutzer beispielsweise eine Microsoft-Windows-Anwendung auf einem Linux-Rechner ausführen, ohne die Konfiguration des Rechners zu ändern. Um eine Anwendungs-Virtualisierung zu erreichen, befolgen Sie diese Praktiken:

- **Anwendungs-Streaming** – Benutzer streamen die Anwendung von einem Remote-Server, so dass sie nur bei Bedarf auf dem Gerät des Endbenutzers läuft.
- **Serverbasierte Anwendungs-Virtualisierung** – Benutzer können über ihren Browser oder ihre Client-Schnittstelle auf die Remote-Anwendung zugreifen, ohne sie zu installieren.
- **Lokale Anwendungs-Virtualisierung** – Der Anwendungscode wird mit einer eigenen Umgebung ausgeliefert, die auf allen Betriebssystemen ohne Änderungen ausgeführt werden kann.
[[@noauthor_was_nodate-6]]
### Desktop-Virtualisierung

Die meisten Unternehmen haben nicht-technische Mitarbeiter, die Desktop-Betriebssysteme verwenden, um gängige Geschäftsanwendungen auszuführen. Sie könnten zum Beispiel die folgenden Mitarbeiter haben:

- Ein Kundenserviceteam, das einen Desktop-Computer mit Windows 10 und eine Software zur Verwaltung von Kundenbeziehungen benötigt
- Ein Marketingteam, das Windows Vista für Verkaufsanwendungen benötigt

Sie können die Desktop-Virtualisierung nutzen, um diese verschiedenen Desktop-Betriebssysteme auf virtuellen Maschinen auszuführen, auf die Ihre Teams aus der Ferne zugreifen können. Diese Art der Virtualisierung macht die Desktop-Verwaltung effizient und sicher und spart Geld für Desktop-Hardware. Im Folgenden finden Sie die verschiedenen Arten der Desktop-Virtualisierung.
[[@noauthor_was_nodate-6]]
#### _Virtuelle Desktop-Infrastruktur_

Die [virtuelle Desktop-Infrastruktur](https://aws.amazon.com/workspaces/) führt virtuelle Desktops auf einem Remote-Server aus. Ihre Benutzer können mit Client-Geräten auf sie zugreifen.
[[@noauthor_was_nodate-6]]
#### _Lokale Desktop-Virtualisierung_

Bei der lokalen Desktop-Virtualisierung führen Sie den Hypervisor auf einem lokalen Computer aus und erstellen einen virtuellen Computer mit einem anderen Betriebssystem. Sie können zwischen Ihrer lokalen und Ihrer virtuellen Umgebung genauso wechseln wie zwischen den Anwendungen. 
[[@noauthor_was_nodate-6]]
## Was ist der Unterschied zwischen Virtualisierung und Cloud-Computing?

Der Begriff Cloud-Computing bezeichnet die On-Demand-Bereitstellung von Rechenressourcen über das Internet zu nutzungsabhängigen Preisberechnungen. Anstatt ein physisches Rechenzentrum zu kaufen, besitzen und warten, erhalten Sie über einen Cloudanbieter je nach Bedarf Zugriff auf Technologiedienste wie z. B. Rechenleistung, Speicherplatz und Datenbanken.

Die Virtualisierungstechnologie macht Cloud-Computing möglich. Cloud-Anbieter errichten und unterhalten ihre eigenen [Rechenzentren](https://aws.amazon.com/compliance/data-center/people/). Sie erstellen verschiedene virtuelle Umgebungen, die die zugrunde liegenden Hardwareressourcen nutzen. Sie können dann Ihr System so programmieren, dass es mit Hilfe von [APIs](https://aws.amazon.com/what-is/api/) auf diese Cloud-Ressourcen zugreift. Ihre Infrastrukturanforderungen können als vollständig verwalteter Service erfüllt werden.
[[@noauthor_was_nodate-6]]

---

# Stichpunkte

~~Virtualisierung: Begriff ist mehrdeutig [[@noauthor_virtualisierung_nodate]]

~~Typischerweise ist Prozessorvirtualisierung gemeint  [[@noauthor_virtualisierung_nodate]]

~~Virtualisierung → Hardware-Unterstützung, welche Betrieb virtueller Computer erleichtert oder beschleunigt. [[@noauthor_virtualisierung_nodate]]

~~Mehrere Systeme auf einem Hardwaresystem ausführen  [[@noauthor_virtualisierung_nodate]]

~~![Virtualisierung](https://www.elektronik-kompendium.de/sites/com/bilder/11010115.gif)
[[@noauthor_virtualisierung_nodate]]

##### ~~Gründe für Virtualisierung:
- ~~Steigerung der Ausfallsicherheit
- ~~Optimierung der IT-Systemauslastung durch Hardware-Konsolidierung
- ~~Senkung der IT-Kosten
- ~~Reduzierung des Stromverbrauchs
[[@noauthor_virtualisierung_nodate]]

~~Wichtigstes Merkmal: Ausfallsicherheit → Absturz von Software oder Betriebssystem beeinflusst nicht Host-OS oder andere VMs [[@noauthor_virtualisierung_nodate]]

~~Häufigste Anwendung: Betrieb unterschiedliche Applikationen in mehreren Umgebungen -> Trennung von Anwendungen aufgrund von Sicherheit oder Datenschutz. Keine eigenen Maschinen für Software notwendig [[@noauthor_virtualisierung_nodate]]

~~Auf für normalen Anwender interessant: Mehrere Umgebungen -> z.B. eine für Arbeit und eine für Internet -> Sicherheitsvorteil [[@noauthor_virtualisierung_nodate]]

### Virtuelle Maschine:

~~![Virtuelle Maschine](https://www.elektronik-kompendium.de/sites/com/bilder/11010114.gif)
[[@noauthor_virtualisierung_nodate]]

~~VM = Software-Container, der gängige Hardware emuliert; Übliche OS besitzen Standardtreiber dafür[[@noauthor_virtualisierung_nodate]]

~~Eingeschränkte Grafikleistung -> 3d-Software und Videowiedergabe nur langsam möglich [[@noauthor_virtualisierung_nodate]]

~~virtuelle Hardware -> Steht der einzelnen VM direkt zur Verfügung; andere VMs können auf diese nicht zugreifen [[@noauthor_virtualisierung_nodate]]

~~Virtualisierungssoftware verwaltet VMs und Ressourcen des System [[@noauthor_virtualisierung_nodate]]

##### ~~Hypervisor

~~Software, welche virtuelle Hardware erstellt -> Stellt innerhalb VMs Standard-Schnittstellen bereit -> fängt Syscalls zu Hardware ab -> Parallele Zugriffe werden vermieden [[@noauthor_virtualisierung_nodate]]

~~Typ1:
- ~~läuft als Betriebssystem auf der Hardware (native)
- ~~Verwaltet Hardware selbst
- ~~Treiber für Hardware müssen integriert sein
- ~~z.B. Hyper-V, vSphere, KVM
 [[@noauthor_virtualisierung_nodate]]

~~Typ2:
- ~~läuft auf installierten Betriebssystem
- ~~Fordert Ressourcen bei Betriebssystem an
- ~~Treiber sind in Wirtssystem enthalten
- ~~z.B. VMware Workstation, VirtualBox
 [[@noauthor_virtualisierung_nodate]]
 
~~![System-Virtualisierung](https://www.elektronik-kompendium.de/sites/com/bilder/11010113.gif)
Typ1 HV
[[@noauthor_virtualisierung_nodate]]

~~![System-Virtualisierung](https://www.elektronik-kompendium.de/sites/com/bilder/11010112.gif)
Typ2 HV
[[@noauthor_virtualisierung_nodate]]

##### ~~Hardware-Unterstützung

- ~~Ursprünglich reine Softwareanwendung -> dadurch schlechte Performance
- ~~Unterstützung der Virtualisierung durch Hardwareerweiterungen der CPU (Intel VT und AMD SVM)
- ~~Ermöglicht I/O-Virtualisierung (z.B. Passthrough von PCIe Geräten)
[[@noauthor_virtualisierung_nodate]]

##### ~~Anwendungen

- ~~Software Entwicklung:
	- ~~Produkt unter verschiedenen OS zu testen
- ~~Arbeitsplatzrechner
	- ~~Verschiedene Arbeitsumgebungen; Trennung von Internet und internen Netz
- ~~Weiterbetrieb von legacy Software
- ~~Behebung von Kompatibilitätsproblemen
[[@noauthor_virtualisierung_nodate]]

##### ~~Virtualisierung in der Server-Umgebung
- ~~Erreichung einer verbesserten Systemauslastung, um Ressourcen effizienter zu nutzen.
- ~~Vereinfachtes Management des Systems für eine leichtere Verwaltung.
- ~~Senkung der Energiekosten, um Umweltrichtlinien zu erfüllen und einen nachhaltigen Betrieb zu gewährleisten.
- ~~S~~teigerung der Sicherheit und Stabilität des Systems, um mögliche Risiken zu minimieren.
- ~~Beschleunigte Umsetzung von Anforderungen, um flexibel und reaktionsschnell auf Veränderungen reagieren zu können.
[[@noauthor_virtualisierung_nodate]]

##### ~~Virtualisierung in der Desktop-Umgebung
- ~~höhere Sicherheit und Stabilität
- ~~Abwärtskompatibilität
[[@noauthor_virtualisierung_nodate]]

##### ~~Virtualisierung im großen Maßstab
- ~~Ab 20 virtuellen Maschinen auf einem Rechner: Überwachung, Update-Management und Leistungsmessung werden wichtig.
- ~~Herausforderung: Updates auf allen VMs einspielen, ohne diese einzeln zu stoppen und zu starten.
- ~~Notwendigkeit eines Verteilungs- und Kontrollmechanismus, um VMs automatisch auf andere Hardware zu verteilen.
[[@noauthor_virtualisierung_nodate]]

---

~~Technologie, um virtuelle Ressourcen für Betriebssysteme bereitzustellen -> Ausnutzung der vollständigen Leistungsfähigkeit der Software
[[@noauthor_virtualisierung_nodate-1]]

~~Beispiel:
- ~~Drei physikalische Server
	- ~~1 Mailserver
	- ~~1 Webserver
	- ~~1 Server mit legacy Anwendungen
- ~~Jeder zu 30 Prozent ausgelastet
~~![Server usage](https://www.redhat.com/rhdc/managed-files/server-usage-500x131.png "Server-Auslastung")

~~Durch Virtualiserung können diese zusammengefasst werden -> Effizienz wird gesteigert

![Server usage: virtualization](https://www.redhat.com/rhdc/managed-files/server-usage-for-virtualization-500x131.png "Server-Auslastung mit Virtualisierung")
~~[[@noauthor_virtualisierung_nodate-1]]

#### ~~Geschichte
- ~~Anfänge in 1960er Jahre
- ~~Zunächst Ermöglichung von Multiusern Betriebssystemen
- ~~Timesharing -> Nutzer innerhalb Betriebssystem isoliert -> Jeder Nutzer bekommt CPU-Zeit zugeteilt
- ~~In 1990er: Ausführung von legacy Software und Partitionierung von Servern
- ~~Grundlage für Cloud Computing
[[@noauthor_virtualisierung_nodate-1]]


##### Funktionsweise

~~Hypervisor:
- ~~Software, die physikalische Ressourcen von virtuellen System
- ~~Ermöglicht Aufteilung von diesen
- ~~VM verhält sich wie Datendatei -> Kann deshalb zwischen Host-Systemen verschoben werden
![How virtualization works](https://www.redhat.com/rhdc/managed-files/how-virtualization-works-400x217.png "So funktioniert die Virtualisierung")
~~[[@noauthor_virtualisierung_nodate-1]]

##### ~~Arten der Virtualisierung
- ~~Datenvirtualisierung
	- ~~Daten können in einzelner Quelle konsolidiert werden
	- ~~Daten werden dann als dynamische Quelle behandelt
	- ~~Diese werden dann im geforderten Format und zum richtigen Zeitpunkt zur Verfügung gestellt
- ~~Desktop-Virtualisierung
	- ~~VDI - Virtual Desktop Infrastruckture
	- ~~Bereitstellung von virtuellen Desktops
	- ~~Dadurch Vereinfachung der Administration, da Massenkonfiguration und -updates möglich ist
- ~~Servervirtualisierung
	- ~~Ermöglicht Partitionierung der Ressourcen des Servers
	- ~~Erlaubt parallele Ausführung von mehreren Betriebssystem
- ~~Virtualisierung von Betriebsystemen
	- ~~Ausführung von mehreren Betriebssystemen auf derselben Hardware
	- ~~Bessere Ausnutzung der Hardware
	- ~~Verbesserung der Sicherheit, da verstärkte Isolation
	- ~~Vereinfachtes Management
- ~~Network Functions Virtualization
	- ~~Trennung von Netzwerkfunktionen (z.B. Verzeichnisdienste, gemeinsame Dateinutzung o.ä.)
	- ~~Zahl der physikalischen Komponenten kann reduziert werden
[[@noauthor_virtualisierung_nodate-1]]

---

~~VM:
- ~~Laufzeitumgebung
- ~~Stellt virtuelles Betriebssystem mit CPU, Speicher, Netzwerkschnittstelle und Storage bereit
- ~~Weist Ressourcen entsprechend Benutzervorgabe zu
- ~~Enthält eigenes OS
- ~~Kann Workloads wie Server, Desktops, Datenbanken oder Netzwerke ausführen
- ~~Mehrere Betriebssysteme gleichzeitig auf selber Hardware
[[@noauthor_was_nodate-5]]

~~Hypervisor:
- ~~Hypervisor trennt Host-Hardware von virtuellen Maschinen
- ~~Hypervisor leitet Systemcalls der VM an Hardware oder Host-Betriebssystem weiter
	- ~~Typ1:
		- ~~Bare Metal
		- ~~Hypervisor verwaltet Ressourcen der Hardware direkt und weißt diese den VMs zu
		- ~~z.B. KVM, vSphere
	- ~~Typ2:
		- ~~gehosteter Hypervisor
		- ~~läuft auf einem Betriebssystem
		- ~~fordert Ressourcen bei Betriebssystem an
		- ~~z.B. VirtualBox, VMware Workstation
[[@noauthor_was_nodate-5]]

~~Vorteile VM:
- ~~Serverkonsolidierung -> Erhöhte Effizienz -> Einsparung von physikalischer Hardware und Platz
- ~~Disaster-Recovery-Options -> Failover u. Redundanz
- ~~Umgebung ist vom Rest des Systems isoliert
- ~~Usecase: Testen neuer Anwendungen oder einrichten von Produktivumgebungen
[[@noauthor_was_nodate-5]]

---

Virtualisierung:
- Abstraktion physikalischer IT-Ressourcen
- Dadurch Abstraktionsschicht zwischen physikalischer Ressource und virtuellem Abbild
- Grundlage für Cloudservices
- Abgrenzung zu Simulation und Emulation
[[@noauthor_konzepte_2021]]

Definition Virtualisierung
- Virtualisierung: Abstrahiert physische IT-Ressourcen (Hardware, Software, Speicher, Netzwerkkomponenten).
- Ziel: Flexible Bereitstellung und Verteilung an verschiedene Abnehmer.
- Vorteil: Verbesserte Auslastung der IT-Ressourcen.
[[@noauthor_konzepte_2021]]

Simulation:
- Simulation: Vollständige Nachbildung eines Systems mittels Software.
- Ziel: Nachstellung aller Systemkomponenten und ihrer inneren Logik.
- Anwendung: Analyse von Programmen auf anderen Systemen, Ausführung von Software für antiquierte Großrechner auf modernen Rechenplattformen.
- Unterschied zur Emulation: Nicht für den Praxiseinsatz vorgesehen.
- Beispiel: Flug-Simulator, iPhone Simulator in XCode für das Testen mobiler Webseiten auf dem Desktop.
[[@noauthor_konzepte_2021]]

Emulation:
- Nachbildung von Hardware- oder Software-Funktionen ohne innere Logik.
- Ziel: Erzielen der gleichen Ergebnisse wie mit dem realen System.
- Unterschied zur Simulation: Emulation kann das nachgebildete System komplett ersetzen.
- Beispiel: Android Emulator in Android Studio.
[[@noauthor_konzepte_2021]]

Einsatzszenarien von Simulation bzw Emulation
- Hardware-Emulation ermöglicht Betriebssystem auf fremder Prozessorplattform.
- Betriebssystem-Nachbildung für Anwendungen anderer Systeme.
- Hardware-Nachbildung für veraltete Software ohne Original-Komponenten.
[[@noauthor_konzepte_2021]]

##### Funktion Virtualisierung
- Virtualisierung ähnelt Simulation und Emulation, hat jedoch einen anderen Zweck.
- Simulatoren und Emulatoren implementieren ein Computermodell, um Inkompatibilitäten zu überbrücken.
- Ziel ist es, Anwendungen auf einem nicht unterstützten System auszuführen.
- Nachteile von Emulation und Simulation: Aufwendige Entwicklung und Performance-Verlust.
- Virtualisierung minimiert Simulation und Emulation, indem sie eine Abstraktionsschicht bereitstellt.
- Dadurch können IT-Ressourcen unabhängig von ihrer physischen Grundlage bereitgestellt werden.
[[@noauthor_konzepte_2021]]
##### Arten der Virtualisierung:
- Hardware-Virtualisierung
- Software-Virtualisierung
- Speichervirtualisierung
- Datenvirtualisierung
- Netzwerkvirtualisierung
[[@noauthor_konzepte_2021]]

##### Hardware-Virtualisierung

Vollvirtualisierung:
- Hypervisor gibt VMs komplette Hardware-Umgebung vor.
- Jede VM hat zugewiesene virtuelle Hardware-Ressourcen.
- Physische Hardware des Wirtssystems bleibt verborgen.
- Ermöglicht Betrieb unmodifizierter Gastsysteme.
- Beliebte Software: Oracle VM VirtualBox, Parallels Workstation, VMware Workstation, Microsoft Hyper-V, Microsoft Virtual Server.
[[@noauthor_konzepte_2021]]
 
 Paravirtualisierung:
- Hypervisor bietet API für direkten Zugriff auf physische Hardware des Wirts.
- Performance-Vorteil gegenüber Vollvirtualisierung.
- Erfordert portierten Kernel des Gastbetriebssystems.
- Nur modifizierte Gastsysteme können paravirtualisiert werden.
- Anbieter wie Microsoft gestatten dies in der Regel nicht.
- Hypervisoren: Xen, Oracle VM Server for SPARC, z/VM von IBM.
[[@noauthor_konzepte_2021]]

##### Software-Virtualisierung

Statt Hardwarekomponenten werden Softwarekomponenten virtualisiert:
- Anwendungsvirtualisierung
- Desktop-Virtualisierung
- Virtualisierung auf Betriebssystemen

Anwendungsvirtualisierung:
- Abstraktion von Anwendungen vom Betriebssystem.
- Anwendungen werden in isolierten Laufzeitumgebungen ausgeführt.
- VMware ThinApp, Microsoft App-V, Citrix XenApp sind Anwendungsvirtualisierungssysteme.
- Ermöglicht Verteilung über verschiedene Systeme ohne Änderungen an lokalen Ressourcen.
- Beispiel:
	- **VMware ThinApp:** Konvertiert Windows-Installer-Paketdateien (MSI) in eigenständige EXE-Dateien.
	- Enthält alle benötigten Bibliotheken und Konfigurationsdateien.
	- Ermöglicht Ausführung der Anwendung auf beliebiger Windows-Betriebssystemumgebung.
- Anwendungsvirtualisierung für lokalen Einsatz zum Schutz des Betriebssystems vor Schadcode.
- Alternativ können virtualisierte Anwendungen auf einem Server für verschiedene Clients bereitgestellt werden.
- Anwendungsvirtualisierung ermöglicht Application-Streaming für den Zugriff auf virtualisierte Anwendungen.
- Anwendung wird inklusive aller Abhängigkeiten vom Server auf das Clientgerät kopiert und in isolierter Laufzeitumgebung ausgeführt.
- Keine Installation der Software auf dem Zielsystem erforderlich.
- Kapselung von Anwendungen ermöglicht Portabilität auf USB-Sticks für direkte Ausführung.
- Ziel der Anwendungsvirtualisierung: Entkopplung von Programmen vom darunterliegenden Betriebssystem.
- Ermöglicht bequeme Portierung und zentrale Wartung der Anwendungen.
[[@noauthor_konzepte_2021]]

##### Desktop-Virtualisierung
- Desktop-Virtualisierung: Zentrale Bereitstellung von Desktop-Umgebungen über ein Netzwerk.
- Hauptsächlich im Unternehmenskontext genutzt.
- Basiert auf einer Client-Server-Struktur mit Remote-Display-Protokollen.
- Führende Anbieter: Microsoft, VMware, Citrix mit proprietären Technologien.
- Unterscheidung zwischen host- und clientbasierten Ansätzen für die Rechenleistungsbereitstellung.
[[@noauthor_konzepte_2021]]

- **Hostbasierte Desktop-Virtualisierung:** Virtuelle Desktops werden direkt auf dem Server ausgeführt.
- Server-Hardware stellt die gesamte Rechenleistung für die Desktop-Umgebung und Anwendungen bereit.
- Anwender greifen über das Netzwerk mit verschiedenen Clientgeräten auf die virtuellen Desktops zu.
- Clientgeräte können Thick Clients (vollausgestattete PCs oder Notebooks), Thin Clients (reduzierte Hardware), Zero Clients (minimalisierte Rechner), Tablets und Smartphones sein.
- Permanente Netzwerkverbindung ist in der Regel erforderlich.
- Ansätze:
	- **Hostbasierte virtuelle Maschine
	- Jeder Anwender verbindet sich über ein Clientgerät mit einer eigenen virtuellen Maschine auf dem Server.
	- Unterscheidung zwischen persistenten und nichtpersistenten Ansätzen.
	- Persistent: Anwender verbindet sich bei jeder Sitzung mit derselben VM und kann sie personalisieren.
	- Nichtpersistent: Virtuelle Maschinen werden zufällig zugeteilt.
	- Einsatz im Rahmen der Desktop-Virtualisierung als Virtual Desktop Infrastructure (VDI).
	- Persistente VMs bieten großen Individualisierungsspielraum mit benutzerdefinierten Anwendungen und Anzeigeoptionen.

	- **Terminal-Service (Präsentationsvirtualisierung):**
	- Client als Anzeigegerät für zentral gehostete Desktop-Umgebungen.
	- Terminal-Services werden von einem Terminalserver bereitgestellt.
	- Minimaler Individualisierungsspielraum für Anwender.
	- Geeignet für hochstandardisierte Arbeitsplätze mit eingeschränkten Funktionen in großer Anzahl.
	- Einsatz z.B. im Einzelhandel: Thin Clients für Lagerbestandsprüfung, Produktinformationen, Kundenindividualisierung und Bestellungen.

	- **Blade-Server:**
	- Modular aufgebauter Server mit mehreren Einplatinencomputern (Blades) in einem gemeinsamen Servergehäuse.
	- Ermöglicht Remote-Zugriff von Endanwendern auf separate physische Maschinen.
	- Jede Desktop-Umgebung wird auf einem separaten Blade ausgeführt.
	- Vorteile: Eigenständige Rechenmaschinen, gemeinsame Versorgungseinrichtungen (Strom und Kühlung) und zentrale Verwaltung.
[[@noauthor_konzepte_2021]] 

- **Clientbasierte Desktop-Virtualisierung:** Ressourcen für Desktop-Umgebung werden vom Clientgerät bereitgestellt.
- Erfordert einen Thick Client mit entsprechender Hardware.
- Umsetzung erfolgt durch virtuelle Maschinen oder OS-Streaming.
	- - **Clientbasierte virtuelle Maschinen:**
	- Desktop-Umgebung wird in einer virtuellen Maschine auf dem Clientgerät ausgeführt.
	- In der Regel mit einem Hypervisor realisiert.
	- Virtuelle Desktops synchronisieren sich regelmäßig mit einem Betriebssystem-Image auf dem Server.
	- Zentrale Verwaltung und imagebasierte Back-up-Zyklen möglich.
	- Anwendungen stehen lokal zur Verfügung, auch wenn die Verbindung zum Server abbricht.

	- **OS-Streaming:** Betriebssystem der Desktop-Umgebung wird lokal auf der Hardware ausgeführt.
	- Der Boot-Vorgang erfolgt per Remote über ein Image auf dem Server.
	- Geeignet für Desktop-Gruppen mit einem einzigen Betriebssystem-Image.
	- Administratoren müssen nur ein Image auf dem Server verwalten, um Anpassungen auf allen Desktops vorzunehmen.
	- Kein Hypervisor erforderlich, aber konstante Netzwerkverbindung zwischen Server und Clientgerät nötig.
[[@noauthor_konzepte_2021]]

- Desktop-Virtualisierung bietet zentralisierte Administration.
- Reduziert Verwaltungs- und Wartungsaufwand, besonders für standardisierte Umgebungen.
- Herausforderung bei heterogener IT-Infrastruktur mit vielen verschiedenen Desktops.
- Zentralisierungsvorteil relativiert sich in solchen Szenarien.
[[@noauthor_konzepte_2021]]

##### Speichervirtualisierung

- Speichervirtualisierung zielt auf die Abbildung verschiedener Speicherressourcen (Festplatten, Flashspeicher, Bandlaufwerke) als einen zusammenhängenden Speicherpool ab.
- Es wird eine Abstraktionsschicht zwischen physischen Speichermedien und der logischen Ebene geschaffen.
- Die Speicherressourcen können zentral mittels Software verwaltet werden.
- Virtueller Speicher kann in Kontingente zerlegt und Anwendungen zugewiesen werden.
- Zugriff auf gespeicherte Daten erfolgt über dieselben Dateipfade, auch wenn sich der physische Speicherort ändert.
- Eine von der Virtualisierungssoftware verwaltete Zuordnungstabelle (Mapping) ermöglicht dies auf logischen Laufwerken (Volumes).
- Logische Laufwerke sind nicht an die physischen Kapazitätsgrenzen der einzelnen Speichermedien gebunden.
- Speichervirtualisierung bietet mehr Flexibilität bei der Zuteilung von Speicherressourcen.
- Die Hardware für Datenspeicherung kann effektiver ausgelastet werden.
- Unternehmen können Speicherkapazitäten im Rechenzentrum kostengünstiger bereitstellen.
- Speichervirtualisierung im Unternehmenskontext meist blockbasiert.
- Daten werden in gleich große Blöcke unterteilt, jeder mit einer einzigartigen Adresse.
- Virtualisierungssoftware speichert die Zuordnungstabelle (Mapping-Table) mit allen Metadaten zur Auffindung des physischen Speicherorts eines Datenblocks.
- Mapping ermöglicht unabhängige Verwaltung von Daten auf virtueller Ebene, z. B. Verschieben, Kopieren, Spiegeln oder Replizieren.
[[@noauthor_konzepte_2021]]

##### Datenvirtualisierung
- Zusammenfassung verschiedener Virtualisierungsansätze für Data-Warehouse-Analysen.
- Ziel: Abstrahierter Zugriff auf Daten für Anwendungen, unabhängig von physischen Gegebenheiten.
- Erstellung einer Master-Kopie, virtuelles Abbild des Gesamtdatenbestands.
- Datenvirtualisierung ist ein Konzept der Informationsintegration.
- Es unterscheidet sich von klassischen Verfahren wie dem ETL-Prozess, da eine Abstraktionsschicht zwischen physischen Datenquellen und dem virtuellen Abbild der Daten etabliert wird.
- Im Rahmen der Informationsintegration wird ETL (Extract, Transform, Load) verwendet, um Daten aus unterschiedlichen Quellen zu extrahieren und in einer Zieldatenbank in einheitlicher Form zusammenzuführen.
- Datenvirtualisierung ermöglicht auch das Auslesen und Manipulieren von Daten aus verschiedenen Quellen, jedoch bleiben die Daten physisch an ihren jeweiligen Orten.
- Datenvirtualisierung integriert Daten nur auf einer virtuellen Ebene und ermöglicht einen Echtzeit-Zugriff auf die physischen Datenquellen.
- Datenvirtualisierung ermöglicht die effektive Zusammenführung von Daten aus verschiedenen Data-Warehouses, Data-Marts oder Data-Lakes, ohne eine neue physische Datenplattform zu erstellen.
- Reduziert den benötigten Speicherplatz für Analysen großer Datenmengen und die Datenübertragung über das Netzwerk.
- Virtuelles Abbild des Gesamtdatenbestands kann verschiedenen Anwendungen zur Verfügung gestellt werden.
- Im Rahmen von Business Intelligence (BI) stehen Self-Service-Tools zur Verfügung, um Berichte und Analysen ohne IT-Personal zu erstellen.
[[@noauthor_konzepte_2021]]

##### Netzwerkvirtualisierung

- Netzwerkvirtualisierung abstrahiert Netzwerkressourcen auf Hardware- und Software-Ebene.
- Häufig verwendet im Rahmen von Sicherheitskonzepten.
- Ziele: Zusammenfassung physischer Netzwerk-Ressourcen zu einer logischen Einheit und Aufteilung in verschiedene virtuelle Einheiten.
- Ein anschauliches Beispiel für Netzwerkvirtualisierung ist das Virtual Private Network (VPN).
- Ein VPN ist ein virtuelles Netzwerk auf Basis eines physischen Netzwerks.
- VPNs werden eingesetzt, um sichere Verbindungen über unsichere Leitungen herzustellen, z. B. wenn Außenmitarbeiter über das Internet auf das private Unternehmensnetzwerk zugreifen.
- Das Internet als öffentliches Netzwerk bietet keine sichere Verbindung zwischen Rechnern.
- VPNs nutzen Virtualisierung, um virtuelle Netzwerke von physischen Netzwerken abzustrahieren und mittels Verschlüsselungs- und Authentifizierungsverfahren abzusichern.
- Die Datenübertragung zwischen Rechnern erfolgt in einem privaten Netzwerk, auch als Tunnel bezeichnet.
- Ein weiteres Beispiel für Netzwerkvirtualisierung sind Virtual Local Area Networks (VLANs).
- VLANs sind virtuelle Teilnetze, die auf einem physischen Rechnernetz basieren.
- VLANs werden über Hardware-Komponenten wie virtualisierende Switches oder Router realisiert.
- Geräte, die zu einem VLAN gehören, können nur mit anderen Geräten im selben VLAN kommunizieren.
- Eine Datenverbindung zu Geräten in anderen VLANs besteht nicht, selbst wenn sich alle Geräte im selben physischen Netzwerk befinden.
- Netzwerkvirtualisierung ermöglicht die flexible Bereitstellung, Verwaltung und Zuteilung von Netzwerk-Ressourcen unabhängig von physischen Gegebenheiten.

Ein weiteres Konzept für die Netzwerkvirtualisierung ist Software-Defined Networking (SDN):

- SDN ermöglicht die zentrale Steuerung virtueller Netzwerkressourcen ohne manuellen Zugriff auf physische Netzwerkkomponenten.
- SDN entkoppelt die virtuelle Kontrollebene (Control Plane) von der physischen Netzwerkebene (Data Plane).
- Ein Netzwerk-Controller verwaltet die Netzwerkkomponenten der Data Plane, wie Router und Switches, und steuert die Weiterleitung von Datenpaketen.
- Der Netzwerk-Controller ist für das Management des Netzwerks, Routingvorgaben, Zugriffsrechte und die Umsetzung von Sicherheitskonzepten verantwortlich.
- Netzwerkkomponenten der Data Plane nehmen Anweisungen des Netzwerk-Controllers entgegen und sind für den Transport der Datenpakete zum gewünschten Empfangsgerät zuständig.
[[@noauthor_konzepte_2021]]

---

##### Virtualisierung
- Virtualisierung erstellt virtuelle Darstellungen von Servern, Speichern und Netzwerken.
- Virtuelle Software ahmt die Funktionen materieller Hardware nach.
- Ziel: Effiziente Nutzung von Hardware-Ressourcen und mehr aus Investitionen herausholen.
- Unterstützt Cloud-Computing-Services für effizientere Infrastrukturnutzung.
- Bietet Flexibilität, Skalierbarkeit und einfacheres Management von IT-Ressourcen.
[[@noauthor_was_nodate-6]]

- Virtualisierung ermöglicht flexiblen Umgang mit Hardware-Ressourcen.
- Physische Server verbrauchen Strom, Platz und erfordern Wartung.
- Virtualisierung hebt räumliche und netzwerkbedingte Einschränkungen auf.
- Hardware-Infrastruktur kann wie eine Anwendung im Internet verwaltet und genutzt werden.
[[@noauthor_was_nodate-6]]
#### Vorteile Virtualisierung:
- Virtualisierung ermöglicht effiziente Ressourcennutzung im Rechenzentrum.
- Virtuelle Serverpools können nach Bedarf erstellt und abgegeben werden.
- Weniger physische Server sparen Platz, Strom und Kühlungskosten.
- Automatisierte IT-Verwaltung durch Software-Tools für virtuelle Maschinen.
- Vorlagen für virtuelle Maschinen ermöglichen konsistente Duplizierung.
- Schnellere Notfallwiederherstellung in Minuten statt Stunden oder Tagen.
- Verbesserte Ausfallsicherheit und Geschäftskontinuität.
[[@noauthor_was_nodate-6]]